/*****************************************************************************
*  Copyright Statement:
*  --------------------
*  This software is protected by Copyright and the information contained
*  herein is confidential. The software may not be copied and the information
*  contained herein may not be used or disclosed except with the written
*  permission of MediaTek Inc. (C) 2005
*
*  BY OPENING THIS FILE, BUYER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
*  THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
*  RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO BUYER ON
*  AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES,
*  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
*  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
*  NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
*  SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
*  SUPPLIED WITH THE MEDIATEK SOFTWARE, AND BUYER AGREES TO LOOK ONLY TO SUCH
*  THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. MEDIATEK SHALL ALSO
*  NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE RELEASES MADE TO BUYER'S
*  SPECIFICATION OR TO CONFORM TO A PARTICULAR STANDARD OR OPEN FORUM.
*
*  BUYER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND CUMULATIVE
*  LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE,
*  AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE MEDIATEK SOFTWARE AT ISSUE,
*  OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY BUYER TO
*  MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE. 
*
*  THE TRANSACTION CONTEMPLATED HEREUNDER SHALL BE CONSTRUED IN ACCORDANCE
*  WITH THE LAWS OF THE STATE OF CALIFORNIA, USA, EXCLUDING ITS CONFLICT OF
*  LAWS PRINCIPLES.  ANY DISPUTES, CONTROVERSIES OR CLAIMS ARISING THEREOF AND
*  RELATED THERETO SHALL BE SETTLED BY ARBITRATION IN SAN FRANCISCO, CA, UNDER
*  THE RULES OF THE INTERNATIONAL CHAMBER OF COMMERCE (ICC).
*
*****************************************************************************/

/*****************************************************************************
 *
 * Filename:
 * ---------
 *   image_sensor.c
 *
 * Project:
 * --------
 *   Maui_sw
 *
 * Description:
 * ------------
 *   Image sensor driver function
 *
 * Author:
 * -------
 *   UW Wang (mtk01051)
 *
 *============================================================================
 *             HISTORY
 * Below this line, this part is controlled by PVCS VM. DO NOT MODIFY!!
 *------------------------------------------------------------------------------
 *
 *------------------------------------------------------------------------------
 * Upper this line, this part is controlled by PVCS VM. DO NOT MODIFY!!
 *============================================================================
 ****************************************************************************/
#include "drv_comm.h"
#include "IntrCtrl.h"
#include "reg_base.h"
#include "gpio_sw.h"
//#include "sccb.h"
#include "isp_if.h"
#include "image_sensor_SP0A18.h"
#include "camera_para.h"
#include "upll_ctrl.h"
#include "med_api.h"
#include "sensor_common.h"

#ifndef SP0A18_HW_SCCB
#include "sccb.h"
#else
#include "sccb_v2.h"
#endif


//#define __DBG_SENSOR_TRACE__

//global variables
static kal_bool  SP0A18_s_bSensor_cap_state = KAL_FALSE; // capture or preview mode state
// Pclk, dummy, exposue related variables.
static kal_uint16 SP0A18_exposure_lines=0;
/* Image Sensor ID */
static kal_uint8 SP0A18_sensor_id=0;
static kal_uint8 SP0A18_banding = 0;//xuegang 0 for 50hz ,1 for 60hz
static kal_bool SP0A18_sensor_bVideoMode = KAL_FALSE;    // KAL_TRUE for video recorder mode
static kal_bool SP0A18_sensor_bCaptureMode = KAL_FALSE;
static kal_bool SP0A18_mode_change = KAL_FALSE;
kal_bool SP0A18_sensor_cap_state=KAL_FALSE;

#define VDOREC_20_20FPS        1//video record daylight
#define VDOREC_20_20FPS_MAXGAIN                    0x8c
#define VDOREC_18_18FPS        0//video record daylight
#define VDOREC_18_18FPS_MAXGAIN                    0x88
#define VDOREC_16_16FPS        0//video record daylight
#define VDOREC_16_16FPS_MAXGAIN                   0x84
#define VDOREC_14_14FPS        0//video record daylight
#define VDOREC_14_14FPS_MAXGAIN                   0x80 
#define VDOREC_12_12FPS        0//video record daylight
#define VDOREC_12_12FPS_MAXGAIN                   0X7c
#define VDOREC_12_12FPS_NIGHT        1//video record nightmode
#define VDOREC_12_12FPS_MAXGAIN_NIGHT      0xa0
#define CAPPRE_20_10FPS         0//capture preview daylight
#define CAPPRE_20_10FPS_MAXGAIN                  0x78  
#define CAPPRE_20_09FPS         0//capture preview daylight
#define CAPPRE_20_09FPS_MAXGAIN                 0x74 
#define CAPPRE_20_08FPS         1//capture preview daylight
#define CAPPRE_20_08FPS_MAXGAIN                 0x70
#define CAPPRE_20_07FPS        0//capture preview daylight
#define CAPPRE_20_07FPS_MAXGAIN                 0x6c
#define CAPPRE_20_06FPS        0//capture preview daylight
#define CAPPRE_20_06FPS_MAXGAIN                 0x68 
#define CAPPRE_20_06FPS_NIGHT         1//capture preview nightmode
#define CAPPRE_20_06FPS_MAXGAIN_NIGHT     0Xa0 

#define NORMAL_Y0ffset  0x08
#define LOWLIGHT_Y0ffset  0x25




#ifndef SP0A18_HW_SCCB
static kal_uint8 SP0A18_SCCB_send_byte(kal_uint8 send_byte)
{
	  volatile signed char i;
	  volatile kal_uint32 j;
	  kal_uint8 ack;
	  for (i = 7; i >= 0; i--)
	  {
	    if (send_byte&(1 << i))
	    {
	   		 SP0A18_SET_SCCB_DATA_HIGH;
	    }
	    else
	    {
	     	 SP0A18_SET_SCCB_DATA_LOW;	 
	    }
	    for (j = 0; j < SP0A18_SENSOR_I2C_DELAY; j++);
	   SP0A18_SET_SCCB_CLK_HIGH;   
	   // for (j = 0; j < SP0A18_SENSOR_I2C_DELAY; j++);
	   // SP0A18_SET_SCCB_DATA_OUTPUT; /* only for delay */    
	    for (j = 0; j < SP0A18_SENSOR_I2C_DELAY; j++);	
	  	SP0A18_SET_SCCB_CLK_LOW; 
	    for (j = 0; j < SP0A18_SENSOR_I2C_DELAY; j++);
  }  
  	SP0A18_SET_SCCB_DATA_LOW;
	SP0A18_SET_SCCB_DATA_INPUT;
	SP0A18_SET_SCCB_CLK_HIGH;
	for(j=0;j<SP0A18_SENSOR_I2C_DELAY;j++);
//---
#ifdef __DBG_SENSOR_TRACE__
    if (GET_SCCB_DATA_BIT != 0) {
        kal_print_string_trace(MOD_ENG, TRACE_INFO, "WARNING: no ACK!!");
    }
#endif
//---
	SP0A18_SET_SCCB_CLK_LOW;
	SP0A18_SET_SCCB_DATA_OUTPUT;
}


/*************************************************************************
* FUNCTION
*    SP0A18_SCCB_get_byte
*
* DESCRIPTION
*    This function read 8bit data from I2C
*
* PARAMETERS
*    None
*
* RETURNS
*    8bit data read from I2C
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint8 SP0A18_SCCB_get_byte(void)
{
	volatile signed char i;
	volatile kal_uint32 j;
	kal_uint8 get_byte=0;

	SP0A18_SET_SCCB_DATA_INPUT;
	for (j = 0; j < SP0A18_SENSOR_I2C_DELAY; j++); //add this for writing 0x11 register fail

	for (i=7;i>=0;i--)
	{	/* data bit 7~0 */
		SP0A18_SET_SCCB_CLK_HIGH;
		for(j=0;j<SP0A18_SENSOR_I2C_DELAY;j++);
		if (SP0A18_GET_SCCB_DATA_BIT)
			get_byte |= (1<<i);
		for(j=0;j<SP0A18_SENSOR_I2C_DELAY;j++);
		SP0A18_SET_SCCB_CLK_LOW;
		for(j=0;j<SP0A18_SENSOR_I2C_DELAY;j++);
	}
	/* don't care bit, 9th bit */
	SP0A18_SET_SCCB_DATA_OUTPUT;
	SP0A18_SET_SCCB_DATA_HIGH;
	for(j=0;j<SP0A18_SENSOR_I2C_DELAY;j++);
	SP0A18_SET_SCCB_CLK_HIGH;
	for(j=0;j<SP0A18_SENSOR_I2C_DELAY;j++);
	SP0A18_SET_SCCB_CLK_LOW;

	return get_byte;
}	/* SCCB_get_byte() */
#endif

/*************************************************************************
* FUNCTION
*    SP0A18_write_cmos_sensor
*
* DESCRIPTION
*    This function wirte data to CMOS sensor through I2C
*    SP0A18_MAX_I2C_FAIL_TRY_NO is the max try number. when write fail, the function retry again until
*    try times reach SP0A18_MAX_I2C_FAIL_TRY_NO.
*
* PARAMETERS
*    addr    : the 8bit address of register
*    para    : the 8bit value of register
*
* RETURNS
*    None
*
* GLOBALS AFFECTED
*
*************************************************************************/




void SP0A18_write_cmos_sensor(kal_uint32 addr, kal_uint32 para)
{
	volatile kal_uint32 j;
	#ifdef SP0A18_HW_SCCB
		SCCB_TRANSACTION_RESULT rt;
		kal_uint8 write_buff[2];
		
		write_buff[0] = addr;
		write_buff[1] = para;
		i2c_set_get_handle_wait(SCCB_OWNER_CAMERA, KAL_TRUE);
	    i2c_set_slave_address(SCCB_OWNER_CAMERA, SP0A18_WRITE_ID);//GPWGPW
	    i2c_set_transaction_mode(SCCB_OWNER_CAMERA, SCCB_TRANSACTION_FAST_MODE, SCCB_100KB);
		rt = i2c_write(SCCB_OWNER_CAMERA, write_buff, sizeof(write_buff));
		#ifdef SP0A18_DBG_TRACE
	        if (rt == SCCB_TRANSACTION_FAIL) 
				kal_print_string_trace(MOD_ENG, TRACE_WARNING, "I2C write %x, %x error", addr, para);
        #endif
	#else
		SP0A18_I2C_START_TRANSMISSION;
		for(j=0;j<SP0A18_SENSOR_I2C_DELAY;j++);
		SP0A18_SCCB_send_byte(SP0A18_WRITE_ID);
		for(j=0;j<SP0A18_SENSOR_I2C_DELAY;j++);
		SP0A18_SCCB_send_byte(addr);
		for(j=0;j<SP0A18_SENSOR_I2C_DELAY;j++);
		SP0A18_SCCB_send_byte(para);
		for(j=0;j<SP0A18_SENSOR_I2C_DELAY;j++);
		SP0A18_I2C_STOP_TRANSMISSION;
	#endif /* SP0A18_HW_SCCB */

}	/* SP0A18_write_cmos_sensor() */
/*************************************************************************
* FUNCTION
*    SP0A18_read_cmos_sensor
*
* DESCRIPTION
*    This function read data from CMOS sensor through I2C.
*    SP0A18_MAX_I2C_FAIL_TRY_NO is the max try number. when read fail, the function retry again until
*    try times reach SP0A18_MAX_I2C_FAIL_TRY_NO.
*
* PARAMETERS
*    addr    : the 8bit address of register
*
* RETURNS
*    8bit data read through I2C
*
* GLOBALS AFFECTED
*
*************************************************************************/

kal_uint32 SP0A18_read_cmos_sensor(kal_uint32 addr)
{
	volatile kal_uint32 j;
	kal_uint8 get_byte=0;
    #ifdef __DBG_SENSOR_TRACE__
    {
        char buff[50];
        sprintf(buff, "read(%x)", addr);
        kal_print_string_trace(MOD_ENG, TRACE_INFO, buff);
    }
    #endif

	#ifdef SP0A18_HW_SCCB
	    SCCB_TRANSACTION_RESULT rt;
		kal_uint8 write_buff[1] = {0xFF};
		kal_uint8 read_buff[1];
		i2c_set_get_handle_wait(SCCB_OWNER_CAMERA, KAL_TRUE);
		i2c_set_slave_address(SCCB_OWNER_CAMERA, SP0A18_WRITE_ID);//GPWGPW
		i2c_set_transaction_mode(SCCB_OWNER_CAMERA, SCCB_TRANSACTION_FAST_MODE, SCCB_100KB);
		write_buff[0]=(kal_uint8)(addr&0xff);
	    rt = i2c_write(SCCB_OWNER_CAMERA,write_buff,1);
	    rt = i2c_read(SCCB_OWNER_CAMERA,read_buff,1);
	    get_byte=read_buff[0];
   
	    #ifdef SP0A18_DBG_TRACE
  		    if (rt == SCCB_TRANSACTION_FAIL) 
			    kal_print_string_trace(MOD_ENG, TRACE_WARNING, "I2C read %x error", addr);
	    #endif
	#else  
		SP0A18_I2C_START_TRANSMISSION;
		for(j=0;j<SP0A18_SENSOR_I2C_DELAY;j++);
		SP0A18_SCCB_send_byte(SP0A18_WRITE_ID);
		for(j=0;j<SP0A18_SENSOR_I2C_DELAY;j++);
		SP0A18_SCCB_send_byte(addr);
		for(j=0;j<SP0A18_SENSOR_I2C_DELAY;j++);
		SP0A18_I2C_STOP_TRANSMISSION;
		for(j=0;j<SP0A18_SENSOR_I2C_DELAY;j++);
		SP0A18_I2C_START_TRANSMISSION;
		for(j=0;j<SP0A18_SENSOR_I2C_DELAY;j++);
		SP0A18_SCCB_send_byte(SP0A18_READ_ID);
		for(j=0;j<SP0A18_SENSOR_I2C_DELAY;j++);
		get_byte=SP0A18_SCCB_get_byte();
		for(j=0;j<SP0A18_SENSOR_I2C_DELAY;j++);
		SP0A18_I2C_STOP_TRANSMISSION;
	#endif

	return get_byte;
}	/* SP0A18_read_cmos_sensor() */


void SP0A18_write_shutter(kal_uint16 shutter)
{
}	/* write_SP0A18_shutter */

kal_uint32 SP0A18_read_shutter(void)
{
}	/* read_SP0A18_shutter */

void SP0A18_write_gain(kal_uint16 gain)
{
}  /* write_SP0A18_gain */

kal_uint16 SP0A18_read_gain(void)
{
}  /* read_SP0A18_gain */

void SP0A18_set_dummy(kal_uint16 pixels, kal_uint16 lines)
{
}	/* set_SP0A18_dummy */

/*************************************************************************
* FUNCTION
*	config_SP0A18_window
*
* DESCRIPTION
*	This function config the hardware window of SP0A18 for getting specified
*  data of that window.
*
* PARAMETERS
*	start_x : start column of the interested window
*  start_y : start row of the interested window
*  width  : column widht of the itnerested window
*  height : row depth of the itnerested window
*
* RETURNS
*	the data that read from SP0A18
*
* GLOBALS AFFECTED
*
*************************************************************************/
void SP0A18_config_window(kal_uint16 startx,kal_uint16 starty,kal_uint16 width, kal_uint16 height)
{
}	/* config_SP0A18_window */

void SP0A18_init_setting(void)
{
SP0A18_write_cmos_sensor(0xfd , 0x00);  
SP0A18_write_cmos_sensor(0x1C , 0x00); 
SP0A18_write_cmos_sensor(0x1B , 0x2f); 
SP0A18_write_cmos_sensor(0x32 , 0x00); 
SP0A18_write_cmos_sensor(0xfd , 0x01);  
SP0A18_write_cmos_sensor(0x28 , 0xc4);                                      
SP0A18_write_cmos_sensor(0x29 , 0x9e);  
SP0A18_write_cmos_sensor(0xfd , 0x00); 
SP0A18_write_cmos_sensor(0xe7 , 0x03); 
SP0A18_write_cmos_sensor(0xe7 , 0x00); 
SP0A18_write_cmos_sensor(0x0f , 0x3f);                                      
SP0A18_write_cmos_sensor(0x10 , 0x3a);                                      
SP0A18_write_cmos_sensor(0x13 , 0x1f);  //5f                                    
SP0A18_write_cmos_sensor(0x15 , 0x0a); // 4f 
SP0A18_write_cmos_sensor(0x16 , 0x00); 
SP0A18_write_cmos_sensor(0x1a , 0x09);                                   
SP0A18_write_cmos_sensor(0x44 , 0x0f);                                      
SP0A18_write_cmos_sensor(0x22 , 0x13);                                      
SP0A18_write_cmos_sensor(0x26 , 0x02);                                      
SP0A18_write_cmos_sensor(0x27 , 0x68); //e8                                    
SP0A18_write_cmos_sensor(0x28 , 0x12); //b                                    
SP0A18_write_cmos_sensor(0x30 , 0x00);                                      
SP0A18_write_cmos_sensor(0x31 , 0x10);                                                            
SP0A18_write_cmos_sensor(0x34 , 0x00);         
//special
SP0A18_write_cmos_sensor(0xfd , 0x01);                                      
SP0A18_write_cmos_sensor(0x00 , 0x01);  
//pregain
SP0A18_write_cmos_sensor(0xfd , 0x01);                                      
SP0A18_write_cmos_sensor(0xc6 , 0x0a);//a~f  
SP0A18_write_cmos_sensor(0xc7 , 0x0a);//a~f   
SP0A18_write_cmos_sensor(0xc8 , 0x0a);//a~f   
SP0A18_write_cmos_sensor(0xc9 , 0x0a);//a~f                                            
//Del sunspot                                       
SP0A18_write_cmos_sensor(0xfd , 0x00);                                      
SP0A18_write_cmos_sensor(0xcd , 0x24);                                      
SP0A18_write_cmos_sensor(0xd1 , 0x03);                                      
SP0A18_write_cmos_sensor(0xd5 , 0xff);                                      
SP0A18_write_cmos_sensor(0xfc , 0x03);                                      
SP0A18_write_cmos_sensor(0xfb , 0x0f); //27                                                                              
//Blacklevel                                        
SP0A18_write_cmos_sensor(0xfd , 0x00);                                      
SP0A18_write_cmos_sensor(0x65 , 0x00);//blue_suboffset                       
SP0A18_write_cmos_sensor(0x66 , 0x00);//red_suboffset                        
SP0A18_write_cmos_sensor(0x67 , 0x00);//gr_suboffset                         
SP0A18_write_cmos_sensor(0x68 , 0x00);//gb_suboffset                                                                            
//AWB                                               
SP0A18_write_cmos_sensor(0xfd , 0x01);  
SP0A18_write_cmos_sensor(0x10 , 0x0d);                                                                                                            
SP0A18_write_cmos_sensor(0x11 , 0x0d);                                      
SP0A18_write_cmos_sensor(0x12 , 0x0d);  
SP0A18_write_cmos_sensor(0x17 , 0x27);                                    
SP0A18_write_cmos_sensor(0x18 , 0x45);                                      
SP0A18_write_cmos_sensor(0x1a , 0xac);                                      
SP0A18_write_cmos_sensor(0x1b , 0x9e);                                      
SP0A18_write_cmos_sensor(0x2a , 0xE0);                                      
SP0A18_write_cmos_sensor(0x2b , 0x10);                                      
SP0A18_write_cmos_sensor(0x2c , 0x9f);//90    
SP0A18_write_cmos_sensor(0x2d , 0x99);
SP0A18_write_cmos_sensor(0x2e , 0x99);
SP0A18_write_cmos_sensor(0x6f , 0x05);                                      
SP0A18_write_cmos_sensor(0x8b , 0x2f); 
SP0A18_write_cmos_sensor(0x20 , 0xd0); 
SP0A18_write_cmos_sensor(0x21 , 0x78); 
SP0A18_write_cmos_sensor(0x22 , 0xe0); 
SP0A18_write_cmos_sensor(0x23 , 0x80); 
SP0A18_write_cmos_sensor(0x16 , 0x0d);
//smooth   
#if 1//Ԥ
SP0A18_write_cmos_sensor(0xfd , 0x00);                                      
SP0A18_write_cmos_sensor(0x4f , 0x54);//raw_gf_fac_outdoor raw_gf_fac_nr 55  
SP0A18_write_cmos_sensor(0x50 , 0x22);//draw_gf_fac_dummy raw_gf_fac_low     
SP0A18_write_cmos_sensor(0x57 , 0x06);//raw_dif_thr_outdoor                  
SP0A18_write_cmos_sensor(0x58 , 0x0f);//raw_dif_thr_normal                   
SP0A18_write_cmos_sensor(0x56 , 0x10);//dummy                                
SP0A18_write_cmos_sensor(0x59 , 0x10);//low                                                                                    
SP0A18_write_cmos_sensor(0x5a , 0x70);//raw_rb_fac_outdoor,raw_rb_fac_nr     
SP0A18_write_cmos_sensor(0x5b , 0x00);//raw_rb_fac_dummy,raw_rb_fac_low  
#else//ԤԽ
SP0A18_write_cmos_sensor(0xfd , 0x00);                                      
SP0A18_write_cmos_sensor(0x4f , 0x43);//raw_gf_fac_outdoor raw_gf_fac_nr 55  
SP0A18_write_cmos_sensor(0x50 , 0x11);//draw_gf_fac_dummy raw_gf_fac_low     
SP0A18_write_cmos_sensor(0x57 , 0x06);//raw_dif_thr_outdoor                  
SP0A18_write_cmos_sensor(0x58 , 0x16);//raw_dif_thr_normal                   
SP0A18_write_cmos_sensor(0x56 , 0x18);//dummy                                
SP0A18_write_cmos_sensor(0x59 , 0x18);//low                                                                                    
SP0A18_write_cmos_sensor(0x5a , 0x70);//raw_rb_fac_outdoor,raw_rb_fac_nr     
SP0A18_write_cmos_sensor(0x5b , 0x00);//raw_rb_fac_dummy,raw_rb_fac_low  
#endif
//sharpen                                           
SP0A18_write_cmos_sensor(0xfd , 0x01); 
SP0A18_write_cmos_sensor(0xe5 , 0x20);
SP0A18_write_cmos_sensor(0xe6 , 0x10);
SP0A18_write_cmos_sensor(0xe7 , 0x20);  
SP0A18_write_cmos_sensor(0xe8 , 0x38);//sharp_fac_pos_outdoor                
SP0A18_write_cmos_sensor(0xec , 0x38);//sharp_fac_neg_outdoor                
SP0A18_write_cmos_sensor(0xe9 , 0x30);//sharp_fac_pos_nr                     
SP0A18_write_cmos_sensor(0xed , 0x30);//sharp_fac_neg_nr                     
SP0A18_write_cmos_sensor(0xea , 0x30);//sharp_fac_pos_dummy                  
SP0A18_write_cmos_sensor(0xef , 0x30);//sharp_fac_neg_dummy                  
SP0A18_write_cmos_sensor(0xeb , 0x10);//sharp_fac_pos_low                    
SP0A18_write_cmos_sensor(0xf0 , 0x20);//sharp_fac_neg_low                                                                  
//rpc                                               
SP0A18_write_cmos_sensor(0xfd , 0x00);                 
SP0A18_write_cmos_sensor(0xe0 , 0x32);//rpc_1base_max
SP0A18_write_cmos_sensor(0xe1 , 0x26);//rpc_2base_max
SP0A18_write_cmos_sensor(0xe2 , 0x22);//rpc_3base_max
SP0A18_write_cmos_sensor(0xe3 , 0x1e);//rpc_4base_max 
SP0A18_write_cmos_sensor(0xe4 , 0x1e);//rpc_5base_max 
SP0A18_write_cmos_sensor(0xe5 , 0x1d);//rpc_6base_max 
SP0A18_write_cmos_sensor(0xe6 , 0x1d);//rpc_7base_max 
SP0A18_write_cmos_sensor(0xe8 , 0x1b);//rpc_8base_max 
SP0A18_write_cmos_sensor(0xe9 , 0x1b);//rpc_9base_max 
SP0A18_write_cmos_sensor(0xea , 0x1b);//rpc_10base_max
SP0A18_write_cmos_sensor(0xeb , 0x1a);//rpc_11base_max
SP0A18_write_cmos_sensor(0xf5 , 0x1a);//rpc_12base_max
SP0A18_write_cmos_sensor(0xf6 , 0x1a);//rpc_13base_max                                                       
//ae min gain                                       
SP0A18_write_cmos_sensor(0xfd , 0x01);                                                        
SP0A18_write_cmos_sensor(0x95 , 0x1a);//rpc_min_indr                                        
SP0A18_write_cmos_sensor(0x9d , 0x1a);//rpc_min_outdr   
//ae setting       
SP0A18_write_cmos_sensor(0xfd , 0x01);       
SP0A18_write_cmos_sensor(0x9c , 0x80);//rpc_max_outdr    
SP0A18_write_cmos_sensor(0x94 , 0x80);//rpc_max_indr   
SP0A18_write_cmos_sensor(0xfd , 0x00);                                      
SP0A18_write_cmos_sensor(0x05 , 0x00);                                      
SP0A18_write_cmos_sensor(0x06 , 0x00);                                      
SP0A18_write_cmos_sensor(0x07 , 0x00);                                      
SP0A18_write_cmos_sensor(0x08 , 0x00);                                      
SP0A18_write_cmos_sensor(0x09 , 0x01);                                      
SP0A18_write_cmos_sensor(0x0A , 0x76);                                      
SP0A18_write_cmos_sensor(0xf0 , 0x62);//ABF_exp_base_8lsb                    
SP0A18_write_cmos_sensor(0xf1 , 0x00);//exp_min_base_msb                     
SP0A18_write_cmos_sensor(0xfd , 0x01);                                      
SP0A18_write_cmos_sensor(0x90 , 0x98);//exp_max_indr[7:0]                    
SP0A18_write_cmos_sensor(0x91 , 0x04);//exp_max_indr[12:8]                   
SP0A18_write_cmos_sensor(0x92 , 0x62);//exp_min_indr[7:0]                    
SP0A18_write_cmos_sensor(0x93 , 0x00);//exp_min_indr[12:8]                   
SP0A18_write_cmos_sensor(0x98 , 0x62);//exp_max_outdr[7:0]                   
SP0A18_write_cmos_sensor(0x99 , 0x00);//exp_max_outdr[12:8]                  
SP0A18_write_cmos_sensor(0x9a , 0x01);//exp_min_outdr[7:0]                   
SP0A18_write_cmos_sensor(0x9b , 0x00);//exp_min_outdr[12:8]                                                                                                 
SP0A18_write_cmos_sensor(0xfd , 0x01);                                      
SP0A18_write_cmos_sensor(0xc4 , 0x70);//mean_nr_dummy                        
SP0A18_write_cmos_sensor(0xc5 , 0x74);//mean_dummy_nr                        
SP0A18_write_cmos_sensor(0xca , 0x30);//mean_heq_low                         
SP0A18_write_cmos_sensor(0xcb , 0x45);//mean_heq_dummy                       
SP0A18_write_cmos_sensor(0xcc , 0x70);//rpc_heq_low                          
SP0A18_write_cmos_sensor(0xcd , 0x70);//rpc_heq_dummy                        
SP0A18_write_cmos_sensor(0xce , 0x98);//exp_heq_dummy_8lsm                   
SP0A18_write_cmos_sensor(0xcf , 0x04);//exp_heq_dummy_5hsm                   
SP0A18_write_cmos_sensor(0xd0 , 0x98);//exp_heq_low_8lsm                     
SP0A18_write_cmos_sensor(0xd1 , 0x04);//exp_heq_low_5hsm                                                                      
//ae target                                         
SP0A18_write_cmos_sensor(0xfd , 0x00);                                      
SP0A18_write_cmos_sensor(0xed , 0x8c);//80);//90                                   
SP0A18_write_cmos_sensor(0xf7 , 0x88);//7c);//8c                                   
SP0A18_write_cmos_sensor(0xf8 , 0x80);//70);//84                                   
SP0A18_write_cmos_sensor(0xec , 0x7c);//6c);//80                                                                                    
SP0A18_write_cmos_sensor(0xef , 0x74);//99                                   
SP0A18_write_cmos_sensor(0xf9 , 0x70);//90                                   
SP0A18_write_cmos_sensor(0xfa , 0x68);//80                                   
SP0A18_write_cmos_sensor(0xee , 0x64);//78                                                                                    
/*// gamma 1 Ͷ˽ϰ                         
SP0A18_write_cmos_sensor(0xfd , 0x00);  
SP0A18_write_cmos_sensor(0x8b , 0x0 );  
SP0A18_write_cmos_sensor(0x8c , 0x6 );  
SP0A18_write_cmos_sensor(0x8d , 0xC );  
SP0A18_write_cmos_sensor(0x8e , 0x1A);  
SP0A18_write_cmos_sensor(0x8f , 0x3A);  
SP0A18_write_cmos_sensor(0x90 , 0x56);  
SP0A18_write_cmos_sensor(0x91 , 0x70);  
SP0A18_write_cmos_sensor(0x92 , 0x86);  
SP0A18_write_cmos_sensor(0x93 , 0x99);  
SP0A18_write_cmos_sensor(0x94 , 0xA9);  
SP0A18_write_cmos_sensor(0x95 , 0xB5);  
SP0A18_write_cmos_sensor(0x96 , 0xC0);  
SP0A18_write_cmos_sensor(0x97 , 0xCA);  
SP0A18_write_cmos_sensor(0x98 , 0xD4);  
SP0A18_write_cmos_sensor(0x99 , 0xDD);  
SP0A18_write_cmos_sensor(0x9a , 0xE6);  
SP0A18_write_cmos_sensor(0x9b , 0xEF);  
SP0A18_write_cmos_sensor(0xfd , 0x01);  
SP0A18_write_cmos_sensor(0x8d , 0xF7);  
SP0A18_write_cmos_sensor(0x8e , 0xFF);*/
/*// gamma 2 Ͷ԰                  
SP0A18_write_cmos_sensor(0xfd , 0x00);  
SP0A18_write_cmos_sensor(0x8b , 0x0 );  
SP0A18_write_cmos_sensor(0x8c , 0xA );  
SP0A18_write_cmos_sensor(0x8d , 0x13);  
SP0A18_write_cmos_sensor(0x8e , 0x25);  
SP0A18_write_cmos_sensor(0x8f , 0x43);  
SP0A18_write_cmos_sensor(0x90 , 0x5D);  
SP0A18_write_cmos_sensor(0x91 , 0x74);  
SP0A18_write_cmos_sensor(0x92 , 0x88);  
SP0A18_write_cmos_sensor(0x93 , 0x9A);  
SP0A18_write_cmos_sensor(0x94 , 0xA9);  
SP0A18_write_cmos_sensor(0x95 , 0xB5);  
SP0A18_write_cmos_sensor(0x96 , 0xC0);  
SP0A18_write_cmos_sensor(0x97 , 0xCA);  
SP0A18_write_cmos_sensor(0x98 , 0xD4);  
SP0A18_write_cmos_sensor(0x99 , 0xDD);  
SP0A18_write_cmos_sensor(0x9a , 0xE6);  
SP0A18_write_cmos_sensor(0x9b , 0xEF);  
SP0A18_write_cmos_sensor(0xfd , 0x01);  
SP0A18_write_cmos_sensor(0x8d , 0xF7);  
SP0A18_write_cmos_sensor(0x8e , 0xFF);*/
//gamma 3 Ƽʹ                       
SP0A18_write_cmos_sensor(0xfd , 0x00);  
SP0A18_write_cmos_sensor(0x8b , 0x0 );  
SP0A18_write_cmos_sensor(0x8c , 0xC );  
SP0A18_write_cmos_sensor(0x8d , 0x19);  
SP0A18_write_cmos_sensor(0x8e , 0x2C);  
SP0A18_write_cmos_sensor(0x8f , 0x49);  
SP0A18_write_cmos_sensor(0x90 , 0x61);  
SP0A18_write_cmos_sensor(0x91 , 0x77);  
SP0A18_write_cmos_sensor(0x92 , 0x8A);  
SP0A18_write_cmos_sensor(0x93 , 0x9B);  
SP0A18_write_cmos_sensor(0x94 , 0xA9);  
SP0A18_write_cmos_sensor(0x95 , 0xB5);  
SP0A18_write_cmos_sensor(0x96 , 0xC0);  
SP0A18_write_cmos_sensor(0x97 , 0xCA);  
SP0A18_write_cmos_sensor(0x98 , 0xD4);  
SP0A18_write_cmos_sensor(0x99 , 0xDD);  
SP0A18_write_cmos_sensor(0x9a , 0xE6);  
SP0A18_write_cmos_sensor(0x9b , 0xEF);  
SP0A18_write_cmos_sensor(0xfd , 0x01);  
SP0A18_write_cmos_sensor(0x8d , 0xF7);  
SP0A18_write_cmos_sensor(0x8e , 0xFF);  
/*//gamma 4 Ͷ                       
SP0A18_write_cmos_sensor(0xfd , 0x00);  
SP0A18_write_cmos_sensor(0x8b , 0x0 );  
SP0A18_write_cmos_sensor(0x8c , 0x14);  
SP0A18_write_cmos_sensor(0x8d , 0x22);  
SP0A18_write_cmos_sensor(0x8e , 0x36);  
SP0A18_write_cmos_sensor(0x8f , 0x51);  
SP0A18_write_cmos_sensor(0x90 , 0x67);  
SP0A18_write_cmos_sensor(0x91 , 0x7A);  
SP0A18_write_cmos_sensor(0x92 , 0x8C);  
SP0A18_write_cmos_sensor(0x93 , 0x9B);  
SP0A18_write_cmos_sensor(0x94 , 0xA9);  
SP0A18_write_cmos_sensor(0x95 , 0xB5);  
SP0A18_write_cmos_sensor(0x96 , 0xC0);  
SP0A18_write_cmos_sensor(0x97 , 0xCA);  
SP0A18_write_cmos_sensor(0x98 , 0xD4);  
SP0A18_write_cmos_sensor(0x99 , 0xDD);  
SP0A18_write_cmos_sensor(0x9a , 0xE6);  
SP0A18_write_cmos_sensor(0x9b , 0xEF);  
SP0A18_write_cmos_sensor(0xfd , 0x01);  
SP0A18_write_cmos_sensor(0x8d , 0xF7);  
SP0A18_write_cmos_sensor(0x8e , 0xFF);*/
/*//gamma 5 ͹                
SP0A18_write_cmos_sensor(0xfd , 0x00);  
SP0A18_write_cmos_sensor(0x8b , 0x0 );  
SP0A18_write_cmos_sensor(0x8c , 0x20);  
SP0A18_write_cmos_sensor(0x8d , 0x2d);  
SP0A18_write_cmos_sensor(0x8e , 0x40);  
SP0A18_write_cmos_sensor(0x8f , 0x5a);  
SP0A18_write_cmos_sensor(0x90 , 0x6e);  
SP0A18_write_cmos_sensor(0x91 , 0x80);  
SP0A18_write_cmos_sensor(0x92 , 0x8f);  
SP0A18_write_cmos_sensor(0x93 , 0x9c);  
SP0A18_write_cmos_sensor(0x94 , 0xa9);  
SP0A18_write_cmos_sensor(0x95 , 0xb5);  
SP0A18_write_cmos_sensor(0x96 , 0xc0);  
SP0A18_write_cmos_sensor(0x97 , 0xca);  
SP0A18_write_cmos_sensor(0x98 , 0xd4);  
SP0A18_write_cmos_sensor(0x99 , 0xdd);  
SP0A18_write_cmos_sensor(0x9a , 0xe6);  
SP0A18_write_cmos_sensor(0x9b , 0xef);  
SP0A18_write_cmos_sensor(0xfd , 0x01);  
SP0A18_write_cmos_sensor(0x8d , 0xf7);  
SP0A18_write_cmos_sensor(0x8e , 0xff);*/


//Lens shading                                      
SP0A18_write_cmos_sensor(0xfd , 0x00);                                      
SP0A18_write_cmos_sensor(0xa0 , 0x10);//lsc_gr_gain                          
SP0A18_write_cmos_sensor(0xa1 , 0x10);//lsc_gb_gain                          
SP0A18_write_cmos_sensor(0xa2 , 0x14);//lsc_r_gain                           
SP0A18_write_cmos_sensor(0xa3 , 0x10);//lsc_b_gain                           
SP0A18_write_cmos_sensor(0xa4 , 0x14);//lsc_gain_max                         
SP0A18_write_cmos_sensor(0xa5 , 0x80);//col_center                           
SP0A18_write_cmos_sensor(0xa6 , 0x80);//row_center                                                                        
//uv en                                             
SP0A18_write_cmos_sensor(0xfd , 0x00);                                      
SP0A18_write_cmos_sensor(0xb0 , 0x00);//uv_dif_gain_outdoor,uv_dif_gain_nr   
SP0A18_write_cmos_sensor(0xb1 , 0x33);//uv_dif_gain_dummy,uv_dif_gain_low    
//neg
SP0A18_write_cmos_sensor(0xfd , 0x01);                                      
SP0A18_write_cmos_sensor(0xd2 , 0x00);                                                   
//lowlight lum                                      
SP0A18_write_cmos_sensor(0xfd , 0x00);                                      
SP0A18_write_cmos_sensor(0xb2 , NORMAL_Y0ffset);//lum_limit                            
SP0A18_write_cmos_sensor(0xb3 , 0x1f);//lum_set                              
SP0A18_write_cmos_sensor(0xb4 , 0x20);//black_vt                             
SP0A18_write_cmos_sensor(0xb5 , 0x45);//white_vt                                                                              
//auto sat                                          
SP0A18_write_cmos_sensor(0xfd , 0x00);                                      
SP0A18_write_cmos_sensor(0xbf , 0x01);//autosa_en                            
SP0A18_write_cmos_sensor(0xc0 , 0xff);//y_p_th                               
SP0A18_write_cmos_sensor(0xc1 , 0xff);//y_mean_th                                                                              
//saturation                                        
SP0A18_write_cmos_sensor(0xfd , 0x00);                                      
SP0A18_write_cmos_sensor(0xd8 , 0x80);//74 //sat_uv_s1                            
SP0A18_write_cmos_sensor(0xd9 , 0x80);//74 //sat_uv_s2                            
SP0A18_write_cmos_sensor(0xda , 0x80);//74 //sat_uv_s3                            
SP0A18_write_cmos_sensor(0xdb , 0x80);//74 //sat_uv_s4                                                                             
//heq                                               
SP0A18_write_cmos_sensor(0xfd , 0x00);                                      
SP0A18_write_cmos_sensor(0xdc , 0x00);//heq_offset                           
SP0A18_write_cmos_sensor(0xdd , 0x80);//ku                                   
SP0A18_write_cmos_sensor(0xde , 0xa8);//90 //kl                                 
SP0A18_write_cmos_sensor(0xdf , 0x70);//heq_mean                                                                               
//CCM                                               
SP0A18_write_cmos_sensor(0xfd , 0x01);                                      
SP0A18_write_cmos_sensor(0xa0 , 0x80);//80(ɫӽɫ)                                        
SP0A18_write_cmos_sensor(0xa1 , 0x0 );//0                                                               
SP0A18_write_cmos_sensor(0xa2 , 0x0 );//0                                                              
SP0A18_write_cmos_sensor(0xa3 , 0xf3);//f0                                                              
SP0A18_write_cmos_sensor(0xa4 , 0x8e);//a6                                                              
SP0A18_write_cmos_sensor(0xa5 , 0x0 );//ea                                                              
SP0A18_write_cmos_sensor(0xa6 , 0x0 );//0                                                               
SP0A18_write_cmos_sensor(0xa7 , 0xe6);//e6                         
SP0A18_write_cmos_sensor(0xa8 , 0x9a);//9a                        
SP0A18_write_cmos_sensor(0xa9 , 0x0 );//0                                                              
SP0A18_write_cmos_sensor(0xaa , 0x3 );//33                                                              
SP0A18_write_cmos_sensor(0xab , 0xc );//c                                                                                                      
//LSC                                               
SP0A18_write_cmos_sensor(0xfd , 0x00);                                      
SP0A18_write_cmos_sensor(0x33 , 0xcf);                                                                                      
//skin                                              
SP0A18_write_cmos_sensor(0xfd , 0x01);                                                                                       
SP0A18_write_cmos_sensor(0x8b , 0x2f);//bit7,0 en                            
SP0A18_write_cmos_sensor(0x01 , 0xf0);                                      
SP0A18_write_cmos_sensor(0x02 , 0x04);                                      
SP0A18_write_cmos_sensor(0x03 , 0x70);                                      
SP0A18_write_cmos_sensor(0x04 , 0x99);                                      
SP0A18_write_cmos_sensor(0x05 , 0x24);                                                                                        
//resize_en                                         
SP0A18_write_cmos_sensor(0xfd , 0x01);                                      
SP0A18_write_cmos_sensor(0x0e , 0x00);                                                                                                                                       
//outformat                                         
SP0A18_write_cmos_sensor(0xfd , 0x00);                                      
SP0A18_write_cmos_sensor(0x35 , 0x00);                                      
SP0A18_write_cmos_sensor(0x5f , 0x01);                                                                                        
//En AE                                             
SP0A18_write_cmos_sensor(0xfd , 0x00);                                      
SP0A18_write_cmos_sensor(0x32 , 0x0d);                                      
SP0A18_write_cmos_sensor(0x34 , 0x06);        
SP0A18_write_cmos_sensor(0xf4 , 0x09);        
dbg_print("SP0A18_init_setting\r\n");
}


#ifdef SP0A18_HW_SCCB
/*
static kal_bool SP0A18_Config_HW_SCCB(void)
{
	sccb_config_struct config;
  
	config.sccb_mode= SCCB_HW_8BIT ; 	 
	config.get_handle_wait=KAL_TRUE;	 
	config.slave_address= SP0A18_SCCB_SLAVE_ADDR; 
	config.delay_len = 0;
	config.transaction_mode=SCCB_TRANSACTION_FAST_MODE;
	config.Fast_Mode_Speed=SP0A18_SCCB_FAST_MODE_SPEED;	//The speed of sccb fast mode(Kb)
  
	i2c_config(SCCB_OWNER_CAMERA, &config);
}
*/
#endif

#define MODULE_RESET_PIN		(60|0x80)


/*************************************************************************
* FUNCTION
*	init_SP0A18
*
* DESCRIPTION
*	This function initialize the registers of CMOS sensor and ISP control register.
*
* PARAMETERS
*	None
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/

 

static kal_int16 SP0A18_init(void)
{
    kal_uint16 sensor_id = 0;
    int i,tmp;

    /* PowerOn the sensor */
	
    cis_module_power_on(KAL_TRUE);	
    kal_sleep_task(2);  /* delay for power stable */

    /* set sensors chip enable pin to high to activate SP0A18 */
    //SP0A18_PWRDN_PIN_HIGH;
	//SP0A18_PWRDN_PIN_LOW;
    //set_isp_driving_current(ISP_DRIVING_6MA);



	
	
	SET_CMOS_CLOCK_POLARITY_LOW;
	
	SET_VSYNC_POLARITY_HIGH;	//SET_VSYNC_POLARITY_LOW	//yud for green screen 2010-08-09
	
	SET_HSYNC_POLARITY_LOW;    
	ENABLE_CAMERA_INDATA_FORMAT;
	SET_CAMERA_INPUT_TYPE(INPUT_YUV422);
	SET_CAMERA_INPUT_ORDER(INPUT_ORDER_CbYCrY1);

	ENABLE_CAMERA_TG_CLK_48M;
	SET_TG_OUTPUT_CLK_DIVIDER(1); //for mt6253 and mt6268, video and cemera preview/capture will use the same clock
	SET_CMOS_RISING_EDGE(0);
	SET_CMOS_FALLING_EDGE(1);
	ENABLE_CAMERA_PIXEL_CLKIN_ENABLE;
	SET_TG_PIXEL_CLK_DIVIDER(1);
	SET_CMOS_DATA_LATCH(1);


	#if 0

	ENABLE_CAMERA_TG_CLK_48M;				/* 48Mhz Clock Base */
		UPLL_Enable(UPLL_OWNER_ISP);
		/* Set MCLK Divider, The MCLK = 52 / (1+1) Mhz, or 48  / (1+1) Mhz based on the Clock Base above */
		SET_TG_OUTPUT_CLK_DIVIDER(1);
		SET_CMOS_RISING_EDGE(0);			/* Always set the Rising_Edge = 0 */
		SET_CMOS_FALLING_EDGE(1);			/* Set the Falling_Edge = ((TG_CLK_DIVIDER + 1) / 2) to get 50% duty of MCLK. */


//#else
    /* SP0A18 needs 24M MCLK */
    /* Use UPLL to produce 48M clock, then divided by 2 */
#if (defined(DRV_ISP_6238_SERIES))
    setCameraCPLLOutputFreq(48000000);
    ENABLE_CAMERA_TG_CLK_48M;
#else
    DISABLE_CAMERA_TG_CLK_48M;

    #if !defined(SP0829_52Mhz_24FPS)
    ENABLE_CAMERA_TG_CLK_48M;
    #endif
    UPLL_Enable(UPLL_OWNER_ISP);
#endif
    SET_TG_OUTPUT_CLK_DIVIDER(2);//48Mhz/2=24M
    SET_CMOS_RISING_EDGE(0);
    SET_CMOS_FALLING_EDGE(0);
#endif
    /* Sensor Signal Polarity */
    /* Note: Set HSync Polarity to Low means High active */
#if 0
    ENABLE_CAMERA_PIXEL_CLKIN_ENABLE;
    ENABLE_CAMERA_PIXEL_CLK_INV;
   
  

    /* YUV Sensor Input Format */
    ENABLE_CAMERA_INDATA_FORMAT;            /* Enable yuv data input */
    SET_CAMERA_INPUT_TYPE(INPUT_YUV422);    /* SP0A18 support YUV422 */
    SET_CAMERA_INPUT_ORDER(INPUT_ORDER_CbYCrY1);
#endif
    /* Reset the sensor */
    SP0A18_RESET_PIN_LOW;
    kal_sleep_task(1);
    SP0A18_RESET_PIN_HIGH;
    kal_sleep_task(1);  /* delay for stable sensor */

	
/*****SET SPI_CLK SPI_DATA GPIO MODE***/
  	//GPIO_ModeSetup(SP0A18_SPI_DATA_PIN,2);	// 2:CAM_CSD
	//GPIO_ModeSetup(SP0A18_SPI_CLOCK_PIN,2);	// 2:CAM_CSK
	
	GPIO_ModeSetup(SP0A18_CMDAT0_PIN,1);	
	GPIO_ModeSetup(SP0A18_CMDAT1_PIN,1);	
	GPIO_ModeSetup(SP0A18_CMDAT2_PIN,1);
	GPIO_ModeSetup(SP0A18_CMDAT3_PIN,1);
	GPIO_ModeSetup(SP0A18_CMDAT4_PIN,1);
	GPIO_ModeSetup(SP0A18_CMDAT5_PIN,1);
	GPIO_ModeSetup(SP0A18_CMDAT6_PIN,1);
	GPIO_ModeSetup(SP0A18_CMDAT7_PIN,1);
	
	GPIO_ModeSetup(SP0A18_CMHREF_PIN,1);
	GPIO_ModeSetup(SP0A18_CMVREF_PIN,1);
	//GPIO_ModeSetup(58,0);
	GPIO_ModeSetup(SP0A18_CMPCKL_PIN,1);
	
	

	

/*****SET I2C GPIO MODE***/	
#ifdef SP0A18_HW_SCCB
	GPIO_ModeSetup(SP0A18_I2C_CLOCK_PIN, 3);	
	GPIO_ModeSetup(SP0A18_I2C_DATA_PIN, 3);
#else
	GPIO_ModeSetup(SP0A18_I2C_CLOCK_PIN,0);
	GPIO_ModeSetup(SP0A18_I2C_DATA_PIN,0);		
	GPIO_WriteIO(1, SP0A18_I2C_CLOCK_PIN);		
	GPIO_WriteIO(1, SP0A18_I2C_DATA_PIN);		      
	GPIO_InitIO(1, SP0A18_I2C_CLOCK_PIN);		
	GPIO_InitIO(1, SP0A18_I2C_DATA_PIN);
#endif

 	
/*******gpio CMPDN*****/
	GPIO_ModeSetup(SP0A18_POWERDOWN_PIN, 0);
    GPIO_InitIO(1, SP0A18_POWERDOWN_PIN);

	
    kal_sleep_task(4);
	GPIO_WriteIO(0, SP0A18_POWERDOWN_PIN);
  	kal_sleep_task(1); 
    GPIO_WriteIO(1, SP0A18_POWERDOWN_PIN);
	kal_sleep_task(4); 
	GPIO_WriteIO(0, SP0A18_POWERDOWN_PIN);
	kal_sleep_task(2); 
  

#ifdef SP0A18_HW_SCCB
    i2c_set_get_handle_wait(SCCB_OWNER_CAMERA, KAL_TRUE);
    i2c_set_slave_address(SCCB_OWNER_CAMERA, SP0A18_WRITE_ID);//GPWGPW
    i2c_set_transaction_mode(SCCB_OWNER_CAMERA, SCCB_TRANSACTION_FAST_MODE, SCCB_100KB);
#endif 
    
    
    /* Read Sensor ID  */
	
  	#if 1
		SP0A18_write_cmos_sensor(0xfd, 0x00);//gpwgpw
		SP0A18_sensor_id= SP0A18_read_cmos_sensor(0x02);
		dbg_print("SP0A18_sensor_id=== %x\r\n", SP0A18_sensor_id);
	#else
   	sensor_id = SP0A18_read_cmos_sensor(0x02);//(0x01) ; 
    dbg_print("sensor_id=%x\r\n",sensor_id);
	#endif

	if(SP0A18_sensor_id != SP0A18_SENSOR_ID)
		return -1;

	// Initail Sequence Write In.
      SP0A18_init_setting(); 
	SP0827_SERIAL_Disable();
    return 1;
}


/*************************************************************************
* FUNCTION
*	init_SP0A18
*
* DESCRIPTION
*	This function initialize the registers of CMOS sensor and ISP control register.
*
* PARAMETERS
*	None
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
image_sensor_func_struct image_sensor_func_SP0A18;



kal_uint32 SP0A18_detect_sensor_id(void)
{
	dbg_print("SP0A18_detect_sensor_id \r\n");


	
    /* PowerOn the sensor */
    cis_module_power_on(KAL_TRUE);	
    kal_sleep_task(2);  /* delay for power stable */

    /* set sensors chip enable pin to high to activate SP0A18 */
    //SP0A18_PWRDN_PIN_HIGH;
	//SP0A18_PWRDN_PIN_LOW;
    //set_isp_driving_current(ISP_DRIVING_6MA);



	
	
	SET_CMOS_CLOCK_POLARITY_LOW;
	
	SET_VSYNC_POLARITY_HIGH;	//SET_VSYNC_POLARITY_LOW	//yud for green screen 2010-08-09
	
	SET_HSYNC_POLARITY_LOW;    
	ENABLE_CAMERA_INDATA_FORMAT;
	SET_CAMERA_INPUT_TYPE(INPUT_YUV422);
	SET_CAMERA_INPUT_ORDER(INPUT_ORDER_CbYCrY1);

	ENABLE_CAMERA_TG_CLK_48M;
	SET_TG_OUTPUT_CLK_DIVIDER(1); //for mt6253 and mt6268, video and cemera preview/capture will use the same clock
	SET_CMOS_RISING_EDGE(0);
	SET_CMOS_FALLING_EDGE(1);
	ENABLE_CAMERA_PIXEL_CLKIN_ENABLE;
	SET_TG_PIXEL_CLK_DIVIDER(1);
	SET_CMOS_DATA_LATCH(1);


	#if 0

	ENABLE_CAMERA_TG_CLK_48M;				/* 48Mhz Clock Base */
		UPLL_Enable(UPLL_OWNER_ISP);
		/* Set MCLK Divider, The MCLK = 52 / (1+1) Mhz, or 48  / (1+1) Mhz based on the Clock Base above */
		SET_TG_OUTPUT_CLK_DIVIDER(1);
		SET_CMOS_RISING_EDGE(0);			/* Always set the Rising_Edge = 0 */
		SET_CMOS_FALLING_EDGE(1);			/* Set the Falling_Edge = ((TG_CLK_DIVIDER + 1) / 2) to get 50% duty of MCLK. */


//#else
    /* SP0A18 needs 24M MCLK */
    /* Use UPLL to produce 48M clock, then divided by 2 */
#if (defined(DRV_ISP_6238_SERIES))
    setCameraCPLLOutputFreq(48000000);
    ENABLE_CAMERA_TG_CLK_48M;
#else
    DISABLE_CAMERA_TG_CLK_48M;

    #if !defined(SP0829_52Mhz_24FPS)
    ENABLE_CAMERA_TG_CLK_48M;
    #endif
    UPLL_Enable(UPLL_OWNER_ISP);
#endif
    SET_TG_OUTPUT_CLK_DIVIDER(2);//48Mhz/2=24M
    SET_CMOS_RISING_EDGE(0);
    SET_CMOS_FALLING_EDGE(0);
#endif
    /* Sensor Signal Polarity */
    /* Note: Set HSync Polarity to Low means High active */
#if 0
    ENABLE_CAMERA_PIXEL_CLKIN_ENABLE;
    ENABLE_CAMERA_PIXEL_CLK_INV;
   
  

    /* YUV Sensor Input Format */
    ENABLE_CAMERA_INDATA_FORMAT;            /* Enable yuv data input */
    SET_CAMERA_INPUT_TYPE(INPUT_YUV422);    /* SP0A18 support YUV422 */
    SET_CAMERA_INPUT_ORDER(INPUT_ORDER_CbYCrY1);
#endif
    /* Reset the sensor */
    SP0A18_RESET_PIN_LOW;
    kal_sleep_task(1);
    SP0A18_RESET_PIN_HIGH;
    kal_sleep_task(1);  /* delay for stable sensor */

	
/*****SET SPI_CLK SPI_DATA GPIO MODE***/
  	//GPIO_ModeSetup(SP0A18_SPI_DATA_PIN,2);	// 2:CAM_CSD
	//GPIO_ModeSetup(SP0A18_SPI_CLOCK_PIN,2);	// 2:CAM_CSK
	
	GPIO_ModeSetup(SP0A18_CMDAT0_PIN,1);	
	GPIO_ModeSetup(SP0A18_CMDAT1_PIN,1);	
	GPIO_ModeSetup(SP0A18_CMDAT2_PIN,1);
	GPIO_ModeSetup(SP0A18_CMDAT3_PIN,1);
	GPIO_ModeSetup(SP0A18_CMDAT4_PIN,1);
	GPIO_ModeSetup(SP0A18_CMDAT5_PIN,1);
	GPIO_ModeSetup(SP0A18_CMDAT6_PIN,1);
	GPIO_ModeSetup(SP0A18_CMDAT7_PIN,1);
	
	GPIO_ModeSetup(SP0A18_CMHREF_PIN,1);
	GPIO_ModeSetup(SP0A18_CMVREF_PIN,1);
	//GPIO_ModeSetup(58,0);
	GPIO_ModeSetup(SP0A18_CMPCKL_PIN,1);
	
	

	

/*****SET I2C GPIO MODE***/	
#ifdef SP0A18_HW_SCCB
	GPIO_ModeSetup(SP0A18_I2C_CLOCK_PIN, 3);	
	GPIO_ModeSetup(SP0A18_I2C_DATA_PIN, 3);
#else
	GPIO_ModeSetup(SP0A18_I2C_CLOCK_PIN,0);
	GPIO_ModeSetup(SP0A18_I2C_DATA_PIN,0);		
	GPIO_WriteIO(1, SP0A18_I2C_CLOCK_PIN);		
	GPIO_WriteIO(1, SP0A18_I2C_DATA_PIN);		      
	GPIO_InitIO(1, SP0A18_I2C_CLOCK_PIN);		
	GPIO_InitIO(1, SP0A18_I2C_DATA_PIN);
#endif

 	
/*******gpio CMPDN*****/
	GPIO_ModeSetup(SP0A18_POWERDOWN_PIN, 0);
    GPIO_InitIO(1, SP0A18_POWERDOWN_PIN);

	
    kal_sleep_task(4);
	GPIO_WriteIO(0, SP0A18_POWERDOWN_PIN);
  	kal_sleep_task(1); 
    GPIO_WriteIO(1, SP0A18_POWERDOWN_PIN);
	kal_sleep_task(4); 
	GPIO_WriteIO(0, SP0A18_POWERDOWN_PIN);
	kal_sleep_task(2); 
    
	
    	SP0A18_write_cmos_sensor(0xfd, 0x00);
    	SP0A18_sensor_id= SP0A18_read_cmos_sensor(0x02);
		dbg_print("Read Sensor ID is %x\r\n",  SP0A18_sensor_id);
#ifdef __DBG_SENSOR_TRACE__
        kal_print_string_trace(MOD_ENG, TRACE_INFO, "SP0A18_detect_sensor_id SP0A18_sensor_id=%x", SP0A18_sensor_id);
#endif

       if(SP0A18_sensor_id == SP0A18_SENSOR_ID)
       return SP0A18_sensor_id;
       else
       return 0;
}	/* SP0A18_detect_sensor_id() */

/*************************************************************************
* FUNCTION
*	power_off_SP0A18
*
* DESCRIPTION
*	This function is to turn off sensor module power.
*
* PARAMETERS
*	None
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/

void SP0A18_power_off(void)
{
	SP0A18_write_cmos_sensor(0xfd, 0x00); 
	SP0A18_write_cmos_sensor(0x0e, 0xff);
	cis_module_power_on(KAL_FALSE);      // Power Off CIS Power

	
	GPIO_ModeSetup(SP0A18_POWERDOWN_PIN, 0);
    GPIO_InitIO(1, SP0A18_POWERDOWN_PIN);
	
    GPIO_WriteIO(0, SP0A18_POWERDOWN_PIN);
  	kal_sleep_task(0); 
    GPIO_WriteIO(1, SP0A18_POWERDOWN_PIN);
	kal_sleep_task(4); 
	GPIO_WriteIO(0, SP0A18_POWERDOWN_PIN);
	kal_sleep_task(2); 
	
	
	#ifndef SP0A18_HW_SCCB
	   SET_SCCB_CLK_LOW;
	   SET_SCCB_DATA_LOW;
	#endif
UPLL_Disable(UPLL_OWNER_ISP);


	

}
/*************************************************************************
* FUNCTION
*	get_SP0A18_id
*
* DESCRIPTION
*	This function return the sensor read/write id of SCCB interface.
*
* PARAMETERS
*	*sensor_write_id : address pointer of sensor write id
*  *sensor_read_id  : address pointer of sensor read id
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
void SP0A18_get_id(kal_uint8 *sensor_write_id, kal_uint8 *sensor_read_id)
{
	dbg_print("xg:SP0A18_get_id\r\n");
	*sensor_write_id=SP0A18_WRITE_ID;
	*sensor_read_id=SP0A18_READ_ID;
}	/* get_SP0A18_id */

/*************************************************************************
* FUNCTION
*	get_SP0A18_size
*
* DESCRIPTION
*	This function return the image width and height of image sensor.
*
* PARAMETERS
*	*sensor_width : address pointer of horizontal effect pixels of image sensor
*  *sensor_height : address pointer of vertical effect pixels of image sensor
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
void SP0A18_get_size(kal_uint16 *sensor_width, kal_uint16 *sensor_height)
{
	dbg_print("xg:SP0A18_get_size\r\n");
	*sensor_width=SP0A18_IMAGE_SENSOR_VGA_WIDTH;			/* pixel numbers actually used in one frame */
	*sensor_height=SP0A18_IMAGE_SENSOR_VGA_HEIGHT;		/* line numbers actually used in one frame */
}	/* get_SP0A18_size */

/*************************************************************************
* FUNCTION
*	get_SP0A18_period
*
* DESCRIPTION
*	This function return the image width and height of image sensor.
*
* PARAMETERS
*	*pixel_number : address pointer of pixel numbers in one period of HSYNC
*  *line_number : address pointer of line numbers in one period of VSYNC
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
void SP0A18_get_period(kal_uint16 *pixel_number, kal_uint16 *line_number)
{
	dbg_print("xg:SP0A18_get_period\r\n");
	*pixel_number=SP0A18_VGA_PERIOD_PIXEL_NUMS;		/* pixel numbers in one period of HSYNC */
	*line_number=SP0A18_VGA_PERIOD_LINE_NUMS;			/* line numbers in one period of VSYNC */
}	/* get_SP0A18_period */


void SP0A18_preview(image_sensor_exposure_window_struct *image_window, image_sensor_config_struct *sensor_config_data)
{
	kal_uint8 iStartX = 0, iStartY = 1;
	kal_bool video_mode = 0;
	//kal_prompt_trace(MOD_MED_C,"SP0A18_Preview------------------");

	SP0A18_sensor_cap_state=KAL_FALSE;



	if (sensor_config_data->isp_op_mode == ISP_MJPEG_PREVIEW_MODE || sensor_config_data->isp_op_mode == ISP_MJPEG_ENCODE_MODE
		|| (sensor_config_data->frame_rate==0x0F)) 
	{ // MJPEG mode
		video_mode = KAL_TRUE;
        //24MHz MCLk
		SET_TG_OUTPUT_CLK_DIVIDER(1);	
		SET_CMOS_RISING_EDGE(0);
		SET_CMOS_FALLING_EDGE(1);
		ENABLE_CAMERA_PIXEL_CLKIN_ENABLE;
		SET_TG_PIXEL_CLK_DIVIDER(1);
		SET_CMOS_DATA_LATCH(1); 		
	}
	else 
	{
		video_mode = KAL_FALSE;
		SP0A18_sensor_bCaptureMode = KAL_FALSE;
		/* config TG of ISP to match the setting of image sensor*/
        //24MHz MCLk
		SET_TG_OUTPUT_CLK_DIVIDER(1);	
		SET_CMOS_RISING_EDGE(0);
		SET_CMOS_FALLING_EDGE(1);
		ENABLE_CAMERA_PIXEL_CLKIN_ENABLE;
		SET_TG_PIXEL_CLK_DIVIDER(1);
		SET_CMOS_DATA_LATCH(1); 		
	}

    if (video_mode != SP0A18_sensor_bVideoMode)
    {
       SP0A18_sensor_bVideoMode = video_mode;
       SP0A18_mode_change = KAL_TRUE;
    }

	image_window->grab_start_x = iStartX;
	image_window->grab_start_y = iStartY;
	image_window->exposure_window_width = SP0A18_IMAGE_SENSOR_VGA_WIDTH - iStartX;
	image_window->exposure_window_height = SP0A18_IMAGE_SENSOR_VGA_HEIGHT - iStartY;
	
	kal_sleep_task(30);	
}	/* SP0A18_preview */

void SP0A18_capture(image_sensor_exposure_window_struct *image_window, image_sensor_config_struct *sensor_config_data)
{
	kal_uint8 iStartX = 0, iStartY = 1;

	//kal_prompt_trace(MOD_MED_C," SP0A18_capture------------------BEGIN");

	SP0A18_sensor_cap_state = KAL_TRUE;
	SP0A18_sensor_bCaptureMode = KAL_TRUE;

	/* config TG of ISP to match the setting of image sensor*/
	SET_TG_OUTPUT_CLK_DIVIDER(1);	
	SET_CMOS_RISING_EDGE(0);
	SET_CMOS_FALLING_EDGE(1);
	ENABLE_CAMERA_PIXEL_CLKIN_ENABLE;
	SET_TG_PIXEL_CLK_DIVIDER(1);
	SET_CMOS_DATA_LATCH(1);



if(image_window->image_target_width == SP0A18_IMAGE_SENSOR_VGA_WIDTH &&
		image_window->image_target_height == SP0A18_IMAGE_SENSOR_VGA_HEIGHT)
{
	dbg_print("xg:0828_capture\r\n");
	image_window->grab_start_x = iStartX;
	image_window->grab_start_y = iStartY;
	image_window->exposure_window_width =  SP0A18_IMAGE_SENSOR_VGA_WIDTH - iStartX;
	image_window->exposure_window_height =  SP0A18_IMAGE_SENSOR_VGA_HEIGHT -iStartY;
}
else
{
	dbg_print("xg:0828_capture  2\r\n");
	image_window->grab_start_x = iStartX;
	image_window->grab_start_y = iStartY;
	image_window->exposure_window_width =  SP0A18_IMAGE_SENSOR_VGA_WIDTH - iStartX;
	image_window->exposure_window_height =  SP0A18_IMAGE_SENSOR_VGA_HEIGHT - iStartY;
}
		kal_sleep_task(30);	
}	/* SP0A18_capture() */

/*************************************************************************
* FUNCTION
*	write_SP0A18_reg
*
* DESCRIPTION
*	This function set the register of SP0A18.
*
* PARAMETERS
*	addr : the register index of SP0A18
*  para : setting parameter of the specified register of SP0A18
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
void SP0A18_write_reg(kal_uint32 addr, kal_uint32 para)
{
	SP0A18_write_cmos_sensor(addr,para);
}	/* write_SP0A18_reg() */

/*************************************************************************
* FUNCTION
*	SP0A18_read_cmos_sensor
*
* DESCRIPTION
*	This function read parameter of specified register from SP0A18.
*
* PARAMETERS
*	addr : the register index of SP0A18
*
* RETURNS
*	the data that read from SP0A18
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0A18_read_reg(kal_uint32 addr)
{
	return (SP0A18_read_cmos_sensor(addr));
}	/* read_SP0A18_reg() */

/*************************************************************************
* FUNCTION
*	set_SP0A18_shutter
*
* DESCRIPTION
*	This function set e-shutter of SP0A18 to change exposure time.
*
* PARAMETERS
*	shutter : exposured lines
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
void SP0A18_set_shutter(kal_uint16 shutter)
{
  //  MY_CAM_TRACE_HEAD_1(SP0A18_set_shutter, shutter);
	SP0A18_exposure_lines=shutter;
	SP0A18_write_shutter(shutter);
}	/* set_SP0A18_shutter */

/*************************************************************************
* FUNCTION
*	set_SP0A18_gain
*
* DESCRIPTION
*	This function is to set global gain to sensor.
*
* PARAMETERS
*	gain : sensor global gain(base: 0x40)
*
* RETURNS
*	the actually gain set to sensor.
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint16 SP0A18_set_gain(kal_uint16 gain)
{
   return gain;
}

/*************************************************************************
* FUNCTION
*	SP0A18_night_mode
*
* DESCRIPTION
*	This function night mode of SP0A18.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
void SP0A18_night_mode(kal_bool enable)
{

	if (/*SP0A18_sensor_bVideoMode || */SP0A18_sensor_bCaptureMode) //20110325 HL
	{
		return ;
	}

	if(!SP0A18_s_bSensor_cap_state)
	{  
		if (!enable) //daylight
			{
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0xb2,NORMAL_Y0ffset);
					SP0A18_write_cmos_sensor(0xb3,0x1f);			
			if(SP0A18_sensor_bVideoMode)
				{
				dbg_print(" SP0A18_banding=%x\r\n",SP0A18_banding);
				if(SP0A18_banding == 0)
					{
                                    #if VDOREC_20_20FPS
					//Video record daylight 24M 50hz 20-20FPS maxgain:0x8c
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,VDOREC_20_20FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0x9c,VDOREC_20_20FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x1 );
					SP0A18_write_cmos_sensor(0x0a,0x76);
					SP0A18_write_cmos_sensor(0xf0,0x62);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0xea);
					SP0A18_write_cmos_sensor(0x91,0x1 );
					SP0A18_write_cmos_sensor(0x92,0x62);
					SP0A18_write_cmos_sensor(0x98,0x62);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,VDOREC_20_20FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xcd,VDOREC_20_20FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xce,0xea);
					SP0A18_write_cmos_sensor(0xcf,0x1 );
					SP0A18_write_cmos_sensor(0xd0,0xea);
					SP0A18_write_cmos_sensor(0xd1,0x1 );
                                   #endif				
					#if VDOREC_18_18FPS
					//Video record daylight 24M 50hz 18-18FPS maxgain:0x88
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,VDOREC_18_18FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0x9c,VDOREC_18_18FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x1 );
					SP0A18_write_cmos_sensor(0x0a,0xf2);
					SP0A18_write_cmos_sensor(0xf0,0x59);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0xbd);
					SP0A18_write_cmos_sensor(0x91,0x1 );
					SP0A18_write_cmos_sensor(0x92,0x59);
					SP0A18_write_cmos_sensor(0x98,0x59);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,VDOREC_18_18FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xcd,VDOREC_18_18FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xce,0xbd);
					SP0A18_write_cmos_sensor(0xcf,0x1 );
					SP0A18_write_cmos_sensor(0xd0,0xbd);
					SP0A18_write_cmos_sensor(0xd1,0x1 );
					#endif		
					#if VDOREC_16_16FPS
					//Video record daylight 24M 50hz 16-16FPS maxgain:0x84   
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,VDOREC_16_16FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0x9c,VDOREC_16_16FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x2 );
					SP0A18_write_cmos_sensor(0x0a,0x9d);
					SP0A18_write_cmos_sensor(0xf0,0x4f);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0xda);
					SP0A18_write_cmos_sensor(0x91,0x1 );
					SP0A18_write_cmos_sensor(0x92,0x4f);
					SP0A18_write_cmos_sensor(0x98,0x4f);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,VDOREC_16_16FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xcd,VDOREC_16_16FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xce,0xda);
					SP0A18_write_cmos_sensor(0xcf,0x1 );
					SP0A18_write_cmos_sensor(0xd0,0xda);
					SP0A18_write_cmos_sensor(0xd1,0x1 );
					#endif
					#if VDOREC_14_14FPS
					//Video record daylight 24M 50hz 14-14FPS maxgain:0x80
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,VDOREC_14_14FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0x9c,VDOREC_14_14FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x3 );
					SP0A18_write_cmos_sensor(0x0a,0x79);
					SP0A18_write_cmos_sensor(0xf0,0x45);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0xe3);
					SP0A18_write_cmos_sensor(0x91,0x1 );
					SP0A18_write_cmos_sensor(0x92,0x45);
					SP0A18_write_cmos_sensor(0x98,0x45);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,VDOREC_14_14FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xcd,VDOREC_14_14FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xce,0xe3);
					SP0A18_write_cmos_sensor(0xcf,0x1 );
					SP0A18_write_cmos_sensor(0xd0,0xe3);
					SP0A18_write_cmos_sensor(0xd1,0x1 );
					#endif
					#if VDOREC_12_12FPS
					//Video record daylight 24M 50hz 12-12FPS maxgain:0x7c
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,VDOREC_12_12FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0x9c,VDOREC_12_12FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x4 );
					SP0A18_write_cmos_sensor(0x0a,0xa0);
					SP0A18_write_cmos_sensor(0xf0,0x3b);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0xd8);
					SP0A18_write_cmos_sensor(0x91,0x1 );
					SP0A18_write_cmos_sensor(0x92,0x3b);
					SP0A18_write_cmos_sensor(0x98,0x3b);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,VDOREC_12_12FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xcd,VDOREC_12_12FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xce,0xd8);
					SP0A18_write_cmos_sensor(0xcf,0x1 );
					SP0A18_write_cmos_sensor(0xd0,0xd8);
					SP0A18_write_cmos_sensor(0xd1,0x1 );
					#endif	  
					dbg_print(" video 50Hz normal\r\n");
					}
				else if(SP0A18_banding == 1)
					{
		                     #if VDOREC_20_20FPS
					//Video record daylight 24M 60Hz 20-20FPS maxgain:0x8c
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,VDOREC_20_20FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0x9c,VDOREC_20_20FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x1 );
					SP0A18_write_cmos_sensor(0x0a,0x72);
					SP0A18_write_cmos_sensor(0xf0,0x52);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0xec);
					SP0A18_write_cmos_sensor(0x91,0x1 );
					SP0A18_write_cmos_sensor(0x92,0x52);
					SP0A18_write_cmos_sensor(0x98,0x52);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,VDOREC_20_20FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xcd,VDOREC_20_20FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xce,0xec);
					SP0A18_write_cmos_sensor(0xcf,0x1 );
					SP0A18_write_cmos_sensor(0xd0,0xec);
					SP0A18_write_cmos_sensor(0xd1,0x1 );
					#endif				
					#if VDOREC_18_18FPS
					//Video record daylight 24M 60Hz 18-18FPS maxgain:0x88
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,VDOREC_18_18FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0x9c,VDOREC_18_18FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x1 );
					SP0A18_write_cmos_sensor(0x0a,0xf5);
					SP0A18_write_cmos_sensor(0xf0,0x4a);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0xbc);
					SP0A18_write_cmos_sensor(0x91,0x1 );
					SP0A18_write_cmos_sensor(0x92,0x4a);
					SP0A18_write_cmos_sensor(0x98,0x4a);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,VDOREC_18_18FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xcd,VDOREC_18_18FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xce,0xbc);
					SP0A18_write_cmos_sensor(0xcf,0x1 );
					SP0A18_write_cmos_sensor(0xd0,0xbc);
					SP0A18_write_cmos_sensor(0xd1,0x1 );
					#endif		
					#if VDOREC_16_16FPS
					//Video record daylight 24M 60Hz 16-16FPS maxgain:0x84   
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,VDOREC_16_16FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0x9c,VDOREC_16_16FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x2 );
					SP0A18_write_cmos_sensor(0x0a,0x99);
					SP0A18_write_cmos_sensor(0xf0,0x42);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0xce);
					SP0A18_write_cmos_sensor(0x91,0x1 );
					SP0A18_write_cmos_sensor(0x92,0x42);
					SP0A18_write_cmos_sensor(0x98,0x42);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,VDOREC_16_16FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xcd,VDOREC_16_16FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xce,0xce);
					SP0A18_write_cmos_sensor(0xcf,0x1 );
					SP0A18_write_cmos_sensor(0xd0,0xce);
					SP0A18_write_cmos_sensor(0xd1,0x1 );
					#endif
					#if VDOREC_14_14FPS
					//Video record daylight 24M 60Hz 14-14FPS maxgain:0x80
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,VDOREC_14_14FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0x9c,VDOREC_14_14FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x3 );
					SP0A18_write_cmos_sensor(0x0a,0x6a);
					SP0A18_write_cmos_sensor(0xf0,0x3a);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0xd0);
					SP0A18_write_cmos_sensor(0x91,0x1 );
					SP0A18_write_cmos_sensor(0x92,0x3a);
					SP0A18_write_cmos_sensor(0x98,0x3a);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,VDOREC_14_14FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xcd,VDOREC_14_14FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xce,0xd0);
					SP0A18_write_cmos_sensor(0xcf,0x1 );
					SP0A18_write_cmos_sensor(0xd0,0xd0);
					SP0A18_write_cmos_sensor(0xd1,0x1 );
					#endif
					#if VDOREC_12_12FPS
					//Video record daylight 24M 60Hz 12-12FPS maxgain:0x7c
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,VDOREC_12_12FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0x9c,VDOREC_12_12FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x4 );
					SP0A18_write_cmos_sensor(0x0a,0xa7);
					SP0A18_write_cmos_sensor(0xf0,0x31);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0xea);
					SP0A18_write_cmos_sensor(0x91,0x1 );
					SP0A18_write_cmos_sensor(0x92,0x31);
					SP0A18_write_cmos_sensor(0x98,0x31);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,VDOREC_12_12FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xcd,VDOREC_12_12FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xce,0xea);
					SP0A18_write_cmos_sensor(0xcf,0x1 );
					SP0A18_write_cmos_sensor(0xd0,0xea);
					SP0A18_write_cmos_sensor(0xd1,0x1 );
					#endif	
					dbg_print(" video 60Hz normal\r\n");
					}
			       }
			else
				{
				dbg_print(" SP0A18_banding=%x\r\n",SP0A18_banding);
			       if(SP0A18_banding == 0)
					{
					#if CAPPRE_20_10FPS
					//capture preview daylight 24M 50hz 20-10FPS maxgain:0x78
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,CAPPRE_20_10FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0x9c,CAPPRE_20_10FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x1 );
					SP0A18_write_cmos_sensor(0x0a,0x76);
					SP0A18_write_cmos_sensor(0xf0,0x62);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0xd4);
					SP0A18_write_cmos_sensor(0x91,0x3 );
					SP0A18_write_cmos_sensor(0x92,0x62);
					SP0A18_write_cmos_sensor(0x98,0x62);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,CAPPRE_20_10FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xcd,CAPPRE_20_10FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xce,0xd4);
					SP0A18_write_cmos_sensor(0xcf,0x3 );
					SP0A18_write_cmos_sensor(0xd0,0xd4);
					SP0A18_write_cmos_sensor(0xd1,0x3 );
					#endif				
					#if CAPPRE_20_09FPS
					//capture preview daylight 24M 50hz 20-9FPS maxgain:0x74
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,CAPPRE_20_09FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0x9c,CAPPRE_20_09FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x1 );
					SP0A18_write_cmos_sensor(0x0a,0x76);
					SP0A18_write_cmos_sensor(0xf0,0x62);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0x36);
					SP0A18_write_cmos_sensor(0x91,0x4 );
					SP0A18_write_cmos_sensor(0x92,0x62);
					SP0A18_write_cmos_sensor(0x98,0x62);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,CAPPRE_20_09FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xcd,CAPPRE_20_09FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xce,0x36);
					SP0A18_write_cmos_sensor(0xcf,0x4 );
					SP0A18_write_cmos_sensor(0xd0,0x36);
					SP0A18_write_cmos_sensor(0xd1,0x4 );
					#endif		
					#if CAPPRE_20_08FPS
					//capture preview daylight 24M 50hz 20-8FPS maxgain:0x70   
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,CAPPRE_20_08FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0x9c,CAPPRE_20_08FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x1 );
					SP0A18_write_cmos_sensor(0x0a,0x76);
					SP0A18_write_cmos_sensor(0xf0,0x62);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0x98);
					SP0A18_write_cmos_sensor(0x91,0x4 );
					SP0A18_write_cmos_sensor(0x92,0x62);
					SP0A18_write_cmos_sensor(0x98,0x62);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,CAPPRE_20_08FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xcd,CAPPRE_20_08FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xce,0x98);
					SP0A18_write_cmos_sensor(0xcf,0x4 );
					SP0A18_write_cmos_sensor(0xd0,0x98);
					SP0A18_write_cmos_sensor(0xd1,0x4 );
					#endif
					#if CAPPRE_20_07FPS
					//capture preview daylight 24M 50hz 20-7FPS maxgain:0x6c
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,CAPPRE_20_07FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0x9c,CAPPRE_20_07FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x1 );
					SP0A18_write_cmos_sensor(0x0a,0x76);
					SP0A18_write_cmos_sensor(0xf0,0x62);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0x5c);
					SP0A18_write_cmos_sensor(0x91,0x5 );
					SP0A18_write_cmos_sensor(0x92,0x62);
					SP0A18_write_cmos_sensor(0x98,0x62);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,CAPPRE_20_07FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xcd,CAPPRE_20_07FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xce,0x5c);
					SP0A18_write_cmos_sensor(0xcf,0x5 );
					SP0A18_write_cmos_sensor(0xd0,0x5c);
					SP0A18_write_cmos_sensor(0xd1,0x5 );
					#endif
					#if CAPPRE_20_06FPS
					//capture preview daylight 24M 50hz 20-6FPS maxgain:0x68
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,CAPPRE_20_06FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0x9c,CAPPRE_20_06FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x1 );
					SP0A18_write_cmos_sensor(0x0a,0x76);
					SP0A18_write_cmos_sensor(0xf0,0x62);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0x20);
					SP0A18_write_cmos_sensor(0x91,0x6 );
					SP0A18_write_cmos_sensor(0x92,0x62);
					SP0A18_write_cmos_sensor(0x98,0x62);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,CAPPRE_20_06FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xcd,CAPPRE_20_06FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xce,0x20);
					SP0A18_write_cmos_sensor(0xcf,0x6 );
					SP0A18_write_cmos_sensor(0xd0,0x20);
					SP0A18_write_cmos_sensor(0xd1,0x6 );
					#endif			
					dbg_print(" priview 50Hz normal\r\n");
					}
				else if(SP0A18_banding == 1)
					{
		                     #if CAPPRE_20_10FPS
					//capture preview daylight 24M 60hz 20-10FPS maxgain:0x78
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,CAPPRE_20_10FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0x9c,CAPPRE_20_10FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x1 );
					SP0A18_write_cmos_sensor(0x0a,0x72);
					SP0A18_write_cmos_sensor(0xf0,0x52);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0xd8);
					SP0A18_write_cmos_sensor(0x91,0x3 );
					SP0A18_write_cmos_sensor(0x92,0x52);
					SP0A18_write_cmos_sensor(0x98,0x52);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,CAPPRE_20_10FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xcd,CAPPRE_20_10FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xce,0xd8);
					SP0A18_write_cmos_sensor(0xcf,0x3 );
					SP0A18_write_cmos_sensor(0xd0,0xd8);
					SP0A18_write_cmos_sensor(0xd1,0x3 );
					#endif				
					#if CAPPRE_20_09FPS
					//capture preview daylight 24M 60hz 20-9FPS maxgain:0x74
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,CAPPRE_20_09FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0x9c,CAPPRE_20_09FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x1 );
					SP0A18_write_cmos_sensor(0x0a,0x72);
					SP0A18_write_cmos_sensor(0xf0,0x52);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0x2a);
					SP0A18_write_cmos_sensor(0x91,0x4 );
					SP0A18_write_cmos_sensor(0x92,0x52);
					SP0A18_write_cmos_sensor(0x98,0x52);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,CAPPRE_20_09FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xcd,CAPPRE_20_09FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xce,0x2a);
					SP0A18_write_cmos_sensor(0xcf,0x4 );
					SP0A18_write_cmos_sensor(0xd0,0x2a);
					SP0A18_write_cmos_sensor(0xd1,0x4 );
					#endif		
					#if CAPPRE_20_08FPS
					//capture preview daylight 24M 60hz 20-8FPS maxgain:0x70   
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,CAPPRE_20_08FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0x9c,CAPPRE_20_08FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x1 );
					SP0A18_write_cmos_sensor(0x0a,0x72);
					SP0A18_write_cmos_sensor(0xf0,0x52);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0xce);
					SP0A18_write_cmos_sensor(0x91,0x4 );
					SP0A18_write_cmos_sensor(0x92,0x52);
					SP0A18_write_cmos_sensor(0x98,0x52);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,CAPPRE_20_08FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xcd,CAPPRE_20_08FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xce,0xce);
					SP0A18_write_cmos_sensor(0xcf,0x4 );
					SP0A18_write_cmos_sensor(0xd0,0xce);
					SP0A18_write_cmos_sensor(0xd1,0x4 );
					#endif
					#if CAPPRE_20_07FPS
					//capture preview daylight 24M 60hz 20-7FPS maxgain:0x6c
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,CAPPRE_20_07FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0x9c,CAPPRE_20_07FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x1 );
					SP0A18_write_cmos_sensor(0x0a,0x72);
					SP0A18_write_cmos_sensor(0xf0,0x52);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0x72);
					SP0A18_write_cmos_sensor(0x91,0x5 );
					SP0A18_write_cmos_sensor(0x92,0x52);
					SP0A18_write_cmos_sensor(0x98,0x52);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,CAPPRE_20_07FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xcd,CAPPRE_20_07FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xce,0x72);
					SP0A18_write_cmos_sensor(0xcf,0x5 );
					SP0A18_write_cmos_sensor(0xd0,0x72);
					SP0A18_write_cmos_sensor(0xd1,0x5 );
					#endif
					#if CAPPRE_20_06FPS
					//capture preview daylight 24M 60hz 20-6FPS maxgain:0x68
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,CAPPRE_20_06FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0x9c,CAPPRE_20_06FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x1 );
					SP0A18_write_cmos_sensor(0x0a,0x72);
					SP0A18_write_cmos_sensor(0xf0,0x52);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0x68);
					SP0A18_write_cmos_sensor(0x91,0x6 );
					SP0A18_write_cmos_sensor(0x92,0x52);
					SP0A18_write_cmos_sensor(0x98,0x52);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,CAPPRE_20_06FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xcd,CAPPRE_20_06FPS_MAXGAIN);
					SP0A18_write_cmos_sensor(0xce,0x68);
					SP0A18_write_cmos_sensor(0xcf,0x6 );
					SP0A18_write_cmos_sensor(0xd0,0x68);
					SP0A18_write_cmos_sensor(0xd1,0x6 );
					#endif
					dbg_print(" priview 60Hz normal\r\n");
					}
			       }
			}
		else //night mode
		       {
		       		SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0xb2,LOWLIGHT_Y0ffset);
					SP0A18_write_cmos_sensor(0xb3,0x1f);	
			if(SP0A18_sensor_bVideoMode)
				{
				dbg_print(" SP0A18_banding=%x\r\n",SP0A18_banding);
				if(SP0A18_banding == 0)
					{
					#if VDOREC_12_12FPS_NIGHT
					//Video record daylight 24M 50hz 12-12FPS maxgain:0x8c
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					SP0A18_write_cmos_sensor(0x9c,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x4 );
					SP0A18_write_cmos_sensor(0x0a,0xa0);
					SP0A18_write_cmos_sensor(0xf0,0x3b);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0xd8);
					SP0A18_write_cmos_sensor(0x91,0x1 );
					SP0A18_write_cmos_sensor(0x92,0x3b);
					SP0A18_write_cmos_sensor(0x98,0x3b);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					SP0A18_write_cmos_sensor(0xcd,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					SP0A18_write_cmos_sensor(0xce,0xd8);
					SP0A18_write_cmos_sensor(0xcf,0x1 );
					SP0A18_write_cmos_sensor(0xd0,0xd8);
					SP0A18_write_cmos_sensor(0xd1,0x1 );
					#endif					
					dbg_print(" video 50Hz night\r\n");				
					}
				else if(SP0A18_banding == 1)
					{
					#if VDOREC_12_12FPS_NIGHT
					//Video record daylight 24M 60Hz 12-12FPS maxgain:0x8c
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					SP0A18_write_cmos_sensor(0x9c,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x4 );
					SP0A18_write_cmos_sensor(0x0a,0xa7);
					SP0A18_write_cmos_sensor(0xf0,0x31);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0xea);
					SP0A18_write_cmos_sensor(0x91,0x1 );
					SP0A18_write_cmos_sensor(0x92,0x31);
					SP0A18_write_cmos_sensor(0x98,0x31);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					SP0A18_write_cmos_sensor(0xcd,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					SP0A18_write_cmos_sensor(0xce,0xea);
					SP0A18_write_cmos_sensor(0xcf,0x1 );
					SP0A18_write_cmos_sensor(0xd0,0xea);
					SP0A18_write_cmos_sensor(0xd1,0x1 );
					#endif				
					dbg_print(" video 60Hz night\r\n");	
					}
			       }
			else
				{
				dbg_print(" SP0A18_banding=%x\r\n",SP0A18_banding);
			       if(SP0A18_banding == 0)
					{
					#if CAPPRE_20_06FPS_NIGHT
					//capture preview night 24M 50hz 20-6FPS maxgain:0x78	 
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
					SP0A18_write_cmos_sensor(0x9c,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x1 );
					SP0A18_write_cmos_sensor(0x0a,0x76);
					SP0A18_write_cmos_sensor(0xf0,0x62);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0x20);
					SP0A18_write_cmos_sensor(0x91,0x6 );
					SP0A18_write_cmos_sensor(0x92,0x62);
					SP0A18_write_cmos_sensor(0x98,0x62);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
					SP0A18_write_cmos_sensor(0xcd,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
					SP0A18_write_cmos_sensor(0xce,0x20);
					SP0A18_write_cmos_sensor(0xcf,0x6 );
					SP0A18_write_cmos_sensor(0xd0,0x20);
					SP0A18_write_cmos_sensor(0xd1,0x6 );
		                    #endif
					dbg_print(" priview 50Hz night\r\n");	
					}  
				else if(SP0A18_banding == 1)
					{
		                     #if CAPPRE_20_06FPS_NIGHT
					//capture preview night 24M 60hz 20-6FPS maxgain:0x78
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x94,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
					SP0A18_write_cmos_sensor(0x9c,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
					SP0A18_write_cmos_sensor(0xfd,0x0 );
					SP0A18_write_cmos_sensor(0x09,0x1 );
					SP0A18_write_cmos_sensor(0x0a,0x72);
					SP0A18_write_cmos_sensor(0xf0,0x52);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0x90,0x68);
					SP0A18_write_cmos_sensor(0x91,0x6 );
					SP0A18_write_cmos_sensor(0x92,0x52);
					SP0A18_write_cmos_sensor(0x98,0x52);
					SP0A18_write_cmos_sensor(0xfd,0x1 );
					SP0A18_write_cmos_sensor(0xcc,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
					SP0A18_write_cmos_sensor(0xcd,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
					SP0A18_write_cmos_sensor(0xce,0x68);
					SP0A18_write_cmos_sensor(0xcf,0x6 );
					SP0A18_write_cmos_sensor(0xd0,0x68);
					SP0A18_write_cmos_sensor(0xd1,0x6 );
		                     #endif
					dbg_print(" priview 60Hz night\r\n");	
					}
			       }
		        }
	}
}	/* SP0A18_night_mode */

#if (!defined(DRV_ISP_6219_SERIES))
/*************************************************************************
* FUNCTION
*	set_SP0A18_flashlight
*
* DESCRIPTION
*	turn on/off SP0A18 flashlight .
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
extern void flashlight_power_on(kal_bool on);
void SP0A18_set_flashlight(kal_bool enable)
{
    flashlight_power_on(enable);
}
#endif

/*************************************************************************
* FUNCTION
*	set_SP0A18_param_zoom
*
* DESCRIPTION
*	SP0A18 zoom setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0A18_set_param_zoom(kal_uint32 para)
{
	return KAL_FALSE;
}

/*************************************************************************
* FUNCTION
*	set_SP0A18_param_contrast
*
* DESCRIPTION
*	SP0A18 contrast setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0A18_set_param_contrast(kal_uint32 para)
{
	// Not Support
	return KAL_FALSE;	
}

/*************************************************************************
* FUNCTION
*	set_SP0A18_param_brightness
*
* DESCRIPTION
*	SP0A18 brightness setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0A18_set_param_brightness(kal_uint32 para)
{
	// Not Support
	return KAL_FALSE;	
}

/*************************************************************************
* FUNCTION
*	set_SP0A18_param_hue
*
* DESCRIPTION
*	SP0A18 hue setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0A18_set_param_hue(kal_uint32 para)
{
	// Not Support
	return KAL_FALSE;	
}

/*************************************************************************
* FUNCTION
*	set_SP0A18_param_gamma
*
* DESCRIPTION
*	SP0A18 gamma setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0A18_set_param_gamma(kal_uint32 para)
{
	return KAL_FALSE;	
}

/*************************************************************************
* FUNCTION
*	set_SP0A18_param_wb
*
* DESCRIPTION
*	SP0A18 wb setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0A18_set_param_wb(kal_uint32 para)
{ 

	if (SP0A18_sensor_bCaptureMode == KAL_TRUE)
	{
		return KAL_TRUE;
	}

	switch (para)
	{
		case CAM_WB_AUTO:   // enable AWB 
			//SP0A18_reg_WB_auto         Զ
			SP0A18_write_cmos_sensor(0xfd,0x01);                                                          
			SP0A18_write_cmos_sensor(0x28,0xc4);		                                                       
			SP0A18_write_cmos_sensor(0x29,0x9e);
			SP0A18_write_cmos_sensor(0xfd,0x00);  // AUTO 3000K~7000K   	  
			SP0A18_write_cmos_sensor(0x32,0x0d);      			
		break;

		case CAM_WB_CLOUD: 
			// SP0A18_reg_WB_auto   
			SP0A18_write_cmos_sensor(0xfd,0x00);   //7000K                                     
			SP0A18_write_cmos_sensor(0x32,0x05);                                                          
			SP0A18_write_cmos_sensor(0xfd,0x01);                                                          
			SP0A18_write_cmos_sensor(0x28,0xe2);		                                                       
			SP0A18_write_cmos_sensor(0x29,0x82);		                                                       
			SP0A18_write_cmos_sensor(0xfd,0x00);                                             
		break;

		case CAM_WB_DAYLIGHT: 
			// SP0A18_reg_WB_auto   
			SP0A18_write_cmos_sensor(0xfd,0x00);  //6500K                                     
			SP0A18_write_cmos_sensor(0x32,0x05);                                                          
			SP0A18_write_cmos_sensor(0xfd,0x01);                                                          
			SP0A18_write_cmos_sensor(0x28,0xc1);		                                                       
			SP0A18_write_cmos_sensor(0x29,0x88);		                                                       
			SP0A18_write_cmos_sensor(0xfd,0x00);                                                         
		break;

		case CAM_WB_INCANDESCENCE: 
			// SP0A18_reg_WB_auto ׳ 
			SP0A18_write_cmos_sensor(0xfd,0x00);  //2800K~3000K                                     
			SP0A18_write_cmos_sensor(0x32,0x05);                                                          
			SP0A18_write_cmos_sensor(0xfd,0x01);                                                          
			SP0A18_write_cmos_sensor(0x28,0x7b);		                                                       
			SP0A18_write_cmos_sensor(0x29,0xd3);		                                                       
			SP0A18_write_cmos_sensor(0xfd,0x00);                                                          
		break;

		case CAM_WB_FLUORESCENT: 
			//SP0A18_reg_WB_auto  ӫ 
			SP0A18_write_cmos_sensor(0xfd,0x00);  //4200K~5000K                                     
			SP0A18_write_cmos_sensor(0x32,0x05);                                                          
			SP0A18_write_cmos_sensor(0xfd,0x01);                                                          
			SP0A18_write_cmos_sensor(0x28,0xb4);		                                                       
			SP0A18_write_cmos_sensor(0x29,0xc4);		                                                       
			SP0A18_write_cmos_sensor(0xfd,0x00);                                                         
		break;

		case CAM_WB_TUNGSTEN: 
			// SP0A18_reg_WB_auto ȹ
			SP0A18_write_cmos_sensor(0xfd,0x00);  //4000K                                   
			SP0A18_write_cmos_sensor(0x32,0x05);                                                          
			SP0A18_write_cmos_sensor(0xfd,0x01);                                                          
			SP0A18_write_cmos_sensor(0x28,0xae);		                                                       
			SP0A18_write_cmos_sensor(0x29,0xcc);		                                                       
			SP0A18_write_cmos_sensor(0xfd,0x00);                                                         
		break;

		case CAM_WB_MANUAL:
		break;

		default:
		return KAL_FALSE;
	}

	return KAL_TRUE;

}

/*************************************************************************
* FUNCTION
*	set_SP0A18_param_exposure
*
* DESCRIPTION
*	SP0A18 exposure setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0A18_set_param_exposure(kal_uint32 para)
{

	switch (para)
	{
		case CAM_EV_NEG_4_3:    // -4 EV
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0xdc, 0xc0);
		break;

		case CAM_EV_NEG_3_3:    // -3 EV
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0xdc, 0xd0);
		break;

		case CAM_EV_NEG_2_3:    // -2 EV
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0xdc, 0xe0);
		break;

		case CAM_EV_NEG_1_3:    // -1 EV
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0xdc, 0xf0);
		break;

		case CAM_EV_ZERO:   // +0 EV
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0xdc, 0x00);//0xfa before
		break;

		case CAM_EV_POS_1_3:    // +1 EV
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0xdc, 0x10);
		break;

		case CAM_EV_POS_2_3:    // +2 EV
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0xdc, 0x20);
		break;

		case CAM_EV_POS_3_3:    // +3 EV
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0xdc, 0x30);
		break;

		case CAM_EV_POS_4_3:    // +4 EV
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0xdc, 0x40);
		break;

		default:
		return KAL_FALSE;    
	}
	return KAL_TRUE;	

}

/*************************************************************************
* FUNCTION
*	set_SP0A18_param_effect
*
* DESCRIPTION
*	SP0A18 effect setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0A18_set_param_effect(kal_uint32 para)
{

    kal_uint32  ret = KAL_TRUE;

	switch (para)
	{
		case CAM_EFFECT_ENC_NORMAL:
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0x62, 0x00);
			SP0A18_write_cmos_sensor(0x63, 0x80);
			SP0A18_write_cmos_sensor(0x64, 0x80);
		break;

		case CAM_EFFECT_ENC_GRAYSCALE:
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0x62, 0x20);
			SP0A18_write_cmos_sensor(0x63, 0x80);
			SP0A18_write_cmos_sensor(0x64, 0x80);

		break;

		case CAM_EFFECT_ENC_SEPIA:
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0x62, 0x10);
			SP0A18_write_cmos_sensor(0x63, 0xc0);
			SP0A18_write_cmos_sensor(0x64, 0x20);

		break;

		case CAM_EFFECT_ENC_COLORINV:
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0x62, 0x04);
			SP0A18_write_cmos_sensor(0x63, 0x80);
			SP0A18_write_cmos_sensor(0x64, 0x80);
		break;

		case CAM_EFFECT_ENC_SEPIAGREEN:
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0x62, 0x10);
			SP0A18_write_cmos_sensor(0x63, 0x20);
			SP0A18_write_cmos_sensor(0x64, 0x20);
		break;

		case CAM_EFFECT_ENC_SEPIABLUE:
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0x62, 0x10);
			SP0A18_write_cmos_sensor(0x63, 0x20);
			SP0A18_write_cmos_sensor(0x64, 0xf0);

		break;

		case CAM_EFFECT_ENC_GRAYINV:
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0x62, 0x08);
			SP0A18_write_cmos_sensor(0x63, 0x80);
			SP0A18_write_cmos_sensor(0x64, 0x80);

		break;

		case CAM_EFFECT_ENC_EMBOSSMENT:
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0x62, 0x01);
			SP0A18_write_cmos_sensor(0x63, 0x80);
			SP0A18_write_cmos_sensor(0x64, 0x80);

		break;

		case CAM_EFFECT_ENC_SKETCH:
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0x62, 0x02);
			SP0A18_write_cmos_sensor(0x63, 0x80);
			SP0A18_write_cmos_sensor(0x64, 0x80);

		break;

		case CAM_EFFECT_ENC_WHITEBOARD:
		case CAM_EFFECT_ENC_COPPERCARVING:        
		case CAM_EFFECT_ENC_BLUECARVING:
		case CAM_EFFECT_ENC_CONTRAST:
		case CAM_EFFECT_ENC_JEAN:       
		case CAM_EFFECT_ENC_OIL:
		default:
		return 
			ret = KAL_FALSE;
	}

	return ret;

}


/*************************************************************************
* FUNCTION
*	set_SP0A18_param_banding
*
* DESCRIPTION
*	SP0A18 banding setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0A18_set_param_banding(kal_uint32 para)
{
	if (SP0A18_sensor_bCaptureMode == KAL_TRUE)
	{
		return KAL_TRUE;
	}

	switch (para)
	{
		case CAM_BANDING_50HZ:
			SP0A18_banding = 0;
		dbg_print(" Banding 50Hz\r\n");	
		break;

		case CAM_BANDING_60HZ:
			SP0A18_banding = 1;
		dbg_print(" Banding 60Hz\r\n");	
		break;

		default:
		return KAL_FALSE;
	}

	return KAL_TRUE;
}

/*************************************************************************
* FUNCTION
*	set_SP0A18_param_saturation
*
* DESCRIPTION
*	SP0A18 SATURATION setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0A18_set_param_saturation(kal_uint32 para)
{
    // Not Support
	return KAL_FALSE;	
}

/*************************************************************************
* FUNCTION
*	set_SP0A18_param_nightmode
*
* DESCRIPTION
*	SP0A18 night mode setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0A18_set_param_nightmode(kal_uint32 para)
{
	SP0A18_night_mode((kal_bool)para);
	return KAL_TRUE;	
}

/*************************************************************************
* FUNCTION
*	set_SP0A18_param_ev
*
* DESCRIPTION
*	SP0A18 ev setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0A18_set_param_ev(kal_uint32 para)
{
	return SP0A18_set_param_exposure(para);
}

/*************************************************************************
* FUNCTION
*	SP0A18_yuv_sensor_setting
*
* DESCRIPTION
*	This function send command and parameter to yuv sensor module SP0A18
*  to configure it
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0A18_yuv_sensor_setting(kal_uint32 cmd, kal_uint32 para)
{

	kal_uint32 iRet = KAL_FALSE;

	if (SP0A18_sensor_bCaptureMode == KAL_TRUE)
	{
		return KAL_TRUE;
	}
	
	switch (cmd)
	{

		case CAM_PARAM_ZOOM_FACTOR:
			iRet = SP0A18_set_param_zoom(para);
		break;

		case CAM_PARAM_CONTRAST:
			iRet = SP0A18_set_param_contrast(para);
		break;

		case CAM_PARAM_BRIGHTNESS:
			iRet =  SP0A18_set_param_brightness(para);
		break;

		case CAM_PARAM_HUE:
			iRet = SP0A18_set_param_hue(para);
		break;

		case CAM_PARAM_GAMMA:
			iRet = SP0A18_set_param_gamma(para);
		break;

		case CAM_PARAM_WB:
			iRet =SP0A18_set_param_wb(para);
		break;

		case CAM_PARAM_EXPOSURE:
			iRet = SP0A18_set_param_exposure(para);//wait
		break;

		case CAM_PARAM_EFFECT:
			iRet = SP0A18_set_param_effect(para);//wait
		break;

		case CAM_PARAM_BANDING:
			iRet = SP0A18_set_param_banding(para);//wait
		break;

		case CAM_PARAM_SATURATION:
			iRet = SP0A18_set_param_saturation(para);
		break;

		case CAM_PARAM_NIGHT_MODE:
			iRet = SP0A18_set_param_nightmode(para);
		break;

		case CAM_PARAM_EV_VALUE:
			iRet = SP0A18_set_param_ev(para);//wait
		break;

		default:
		       iRet=KAL_FALSE;
	}

	return iRet;

}
void SP0A18_feature_control(void)
{
}


/*************************************************************************
* FUNCTION
*	image_sensor_func_SP0A18
*
* DESCRIPTION
*	SP0A18 Image Sensor functions struct.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
image_sensor_func_struct image_sensor_func_SP0A18=
{
	SP0A18_init,
	SP0A18_get_id,
	SP0A18_get_size,
	SP0A18_get_period,
	SP0A18_preview,
	SP0A18_capture,
	SP0A18_write_reg,
	SP0A18_read_reg,
	SP0A18_set_shutter,
	SP0A18_night_mode,
	SP0A18_power_off,
	SP0A18_set_gain,
	SP0A18_set_flashlight,
	SP0A18_feature_control,
	SP0A18_yuv_sensor_setting
};	/* image_sensor_func_SP0A18 */

/*************************************************************************
* FUNCTION
*	cam_module_func_config
*
* DESCRIPTION
*	This function maps the external camera module function API structure.
*
* PARAMETERS
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
void SP0A18_image_sensor_func_config(void)
{
	image_sensor_func = &image_sensor_func_SP0A18;
}	/* cam_module_func_config() */

// write camera_para to sensor register
void SP0A18_camera_para_to_sensor(void)
{
	kal_uint32	i;
	
	for(i=0; 0xFFFFFFFF!=camera_para.SENSOR.reg[i].addr; i++)
	{
		SP0A18_write_reg(camera_para.SENSOR.reg[i].addr, camera_para.SENSOR.reg[i].para);
	}
#if(! defined(DRV_ISP_6238_SERIES))	
	for(i=SP0A18_FACTORY_START_ADDR; 0xFFFFFFFF!=camera_para.SENSOR.reg[i].addr; i++)
	{
		SP0A18_write_reg(camera_para.SENSOR.reg[i].addr, camera_para.SENSOR.reg[i].para);
	}
	for(i=0; i<SP0A18_CCT_END_ADDR; i++)
	{
		SP0A18_write_reg(camera_para.SENSOR.cct[i].addr, camera_para.SENSOR.cct[i].para);
	}
#else
	for(i=FACTORY_START_ADDR; 0xFFFFFFFF!=camera_para.SENSOR.reg[i].addr; i++)
	{
		SP0A18_write_reg(camera_para.SENSOR.reg[i].addr, camera_para.SENSOR.reg[i].para);
	}
	for(i=0; i<SP0A18_CCT_END_ADDR; i++)
	{
		SP0A18_write_reg(camera_para.SENSOR.cct[i].addr, camera_para.SENSOR.cct[i].para);
	}
#endif

}

// update camera_para from sensor register
void SP0A18_sensor_to_camera_para(void)
{
#if 1
	kal_uint32	i;
	
	for(i=0; 0xFFFFFFFF!=camera_para.SENSOR.reg[i].addr; i++)
	{
		camera_para.SENSOR.reg[i].para = SP0A18_read_reg(camera_para.SENSOR.reg[i].addr);
	}
#if(! defined(DRV_ISP_6238_SERIES))	
	for(i=SP0A18_FACTORY_START_ADDR; 0xFFFFFFFF!=camera_para.SENSOR.reg[i].addr; i++)
	{
		camera_para.SENSOR.reg[i].para = SP0A18_read_reg(camera_para.SENSOR.reg[i].addr);
	}
#else
	for(i=FACTORY_START_ADDR; 0xFFFFFFFF!=camera_para.SENSOR.reg[i].addr; i++)
	{
		camera_para.SENSOR.reg[i].para = SP0A18_read_reg(camera_para.SENSOR.reg[i].addr);
	}
#endif
#endif
}

//------------------------Engineer mode---------------------------------

void  SP0A18_get_sensor_group_count(kal_int32* sensor_count_ptr)
{
	return;
}

void SP0A18_get_sensor_group_info(kal_uint16 group_idx, kal_int8* group_name_ptr, kal_int32* item_count_ptr)
{
}

void SP0A18_get_sensor_item_info(kal_uint16 group_idx,kal_uint16 item_idx, ENG_sensor_info* info_ptr)
{
}

kal_bool SP0A18_set_sensor_item_info(kal_uint16 group_idx, kal_uint16 item_idx, kal_int32 item_value)
{
    return KAL_FALSE;
}

void SP0A18_get_sensor_prefix_name(kal_char* buf){
	strcpy(buf, "SP0A18");
}

#if (defined(DRV_ISP_6238_SERIES))
void  SP0A18_dispatch_camera_info(void) {
       kal_mem_cpy(&dsc_support_info, &SP0A18_dsc_support_info, sizeof(camcorder_info_struct));	
}
#endif

kal_uint32 SP0A18_get_valid_camera_type(void) {
	
	#if(defined(SP0A18_YUV_MAIN))
		return  IMAGE_SENSOR_MAIN;			
	#elif(defined(SP0A18_YUV_SUB))
		return  IMAGE_SENSOR_SUB;			
	#elif(defined(SP0A18_YUV_BAK1))
		return  IMAGE_SENSOR_BAK1;			
	#elif(defined(SP0A18_YUV_SUB_BAK1))
		return  IMAGE_SENSOR_SUB_BAK1;
	#endif									
	
}


