/*****************************************************************************
*  Copyright Statement:
*  --------------------
*  This software is protected by Copyright and the information contained
*  herein is confidential. The software may not be copied and the information
*  contained herein may not be used or disclosed except with the written
*  permission of MediaTek Inc. (C) 2010
*
*  BY OPENING THIS FILE, BUYER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
*  THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
*  RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO BUYER ON
*  AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES,
*  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
*  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
*  NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
*  SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
*  SUPPLIED WITH THE MEDIATEK SOFTWARE, AND BUYER AGREES TO LOOK ONLY TO SUCH
*  THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. MEDIATEK SHALL ALSO
*  NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE RELEASES MADE TO BUYER'S
*  SPECIFICATION OR TO CONFORM TO A PARTICULAR STANDARD OR OPEN FORUM.
*
*  BUYER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND CUMULATIVE
*  LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE,
*  AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE MEDIATEK SOFTWARE AT ISSUE,
*  OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY BUYER TO
*  MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
*
*  THE TRANSACTION CONTEMPLATED HEREUNDER SHALL BE CONSTRUED IN ACCORDANCE
*  WITH THE LAWS OF THE STATE OF CALIFORNIA, USA, EXCLUDING ITS CONFLICT OF
*  LAWS PRINCIPLES.  ANY DISPUTES, CONTROVERSIES OR CLAIMS ARISING THEREOF AND
*  RELATED THERETO SHALL BE SETTLED BY ARBITRATION IN SAN FRANCISCO, CA, UNDER
*  THE RULES OF THE INTERNATIONAL CHAMBER OF COMMERCE (ICC).
*
*****************************************************************************/

/*****************************************************************************
 *
 * Filename:
 * ---------
 *   image_sensor_SP0A18.c
 *
 * Project:
 * --------
 *  
 *
 * Description:
 * ------------
 *  Image sensor driver function
 *  V1.0.0
 *
 * Author:
 * -------
 * Mormo
 *
 *============================================================================
 *             HISTORY
 * Below this line, this part is controlled by PVCS VM. DO NOT MODIFY!!
 *------------------------------------------------------------------------------
 *  * $Log$
 * 2011/06/13 Firstly Released By Mormo;
 *------------------------------------------------------------------------------
 * Upper this line, this part is controlled by PVCS VM. DO NOT MODIFY!!
 *============================================================================
 ****************************************************************************/
#include "drv_comm.h"
#include "isp_comm_if.h"
#include "camera_sccb.h"
#include "image_sensor.h"
#include "cal_comm_def.h"
#include "isp_if.h"

/* #define __SP0A18_DEBUG_TRACE__ */
#define SP0A18_SET_PAGE0 CamWriteCmosSensor(0xfd , 0x00)
#define SP0A18_SET_PAGE1 CamWriteCmosSensor(0xfd , 0x01)
#define VDOREC_20_20FPS        1//video record daylight
#define VDOREC_20_20FPS_MAXGAIN                    0x8c
#define VDOREC_18_18FPS        0//video record daylight
#define VDOREC_18_18FPS_MAXGAIN                    0x88
#define VDOREC_16_16FPS        0//video record daylight
#define VDOREC_16_16FPS_MAXGAIN                   0x84
#define VDOREC_14_14FPS       0//video record daylight
#define VDOREC_14_14FPS_MAXGAIN                   0x80 
#define VDOREC_12_12FPS     0//video record daylight
#define VDOREC_12_12FPS_MAXGAIN                   0X7c
#define VDOREC_12_12FPS_NIGHT        1//video record nightmode
#define VDOREC_12_12FPS_MAXGAIN_NIGHT      0xa0

#define CAPPRE_20_10FPS         0//capture preview daylight
#define CAPPRE_20_10FPS_MAXGAIN                  0x78  
#define CAPPRE_20_09FPS         0//capture preview daylight
#define CAPPRE_20_09FPS_MAXGAIN                 0x74 
#define CAPPRE_20_08FPS        1//capture preview daylight
#define CAPPRE_20_08FPS_MAXGAIN                 0x70
#define CAPPRE_20_07FPS         0//capture preview daylight
#define CAPPRE_20_07FPS_MAXGAIN                 0x6c
#define CAPPRE_20_06FPS         0//capture preview daylight  
#define CAPPRE_20_06FPS_MAXGAIN                 0x68 
#define CAPPRE_20_06FPS_NIGHT       1//capture preview nightmode
#define CAPPRE_20_06FPS_MAXGAIN_NIGHT     0Xa0 

#define NORMAL_Y0ffset  0x08
#define LOWLIGHT_Y0ffset  0x25
kal_bool SP0A18_CAM_BANDING_50HZ = KAL_FALSE;
kal_bool SP0A18videomode = KAL_FALSE; 

static struct
{
  kal_bool BypassAe;
  kal_bool BypassAwb;
  kal_uint8 Ctrl3A;
  kal_uint8 AecMode3;
  kal_uint16 VideoFps;
  kal_uint32 IntClk; /* internal clock = half of pclk */
  kal_uint16 FrameHeight;
  kal_uint16 LineLength;
  IMAGE_SENSOR_INDEX_ENUM SensorIdx;
  sensor_data_struct *NvramData;
} SP0A18Sensor;

/*************************************************************************
* FUNCTION
*    SP0A18HalfAdjust
*
* DESCRIPTION
*    This function dividend / divisor and use round-up.
*
* PARAMETERS
*    DividEnd
*    Divisor
*
* RETURNS
*    [DividEnd / Divisor]
*
* LOCAL AFFECTED
*
*************************************************************************/
__inline static kal_uint32 SP0A18HalfAdjust(kal_uint32 DividEnd, kal_uint32 Divisor)
{
  return (DividEnd + (Divisor >> 1)) / Divisor; /* that is [DividEnd / Divisor + 0.5]*/
}

/*************************************************************************
* FUNCTION
*    SP0A18SetMirror
*
* DESCRIPTION
*    This function set the Mirror to the CMOS sensor
*
* PARAMETERS
*    Mirror
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0A18SetMirror(kal_uint8 Mirror)
{
CameraSccbSetAddr(CAMERA_SCCB_SENSOR, 0x42);
SP0A18_SET_PAGE0;
  switch (Mirror)
  {
  case IMAGE_SENSOR_MIRROR_H:
    CamWriteCmosSensor(0x31, 0x30);
    break;
  case IMAGE_SENSOR_MIRROR_V:
    CamWriteCmosSensor(0x31, 0x50);
    break;
  case IMAGE_SENSOR_MIRROR_HV:
    CamWriteCmosSensor(0x31, 0x70);
    break;
  default:
    CamWriteCmosSensor(0x31, 0x10);
  }
}

/*************************************************************************
* FUNCTION
*    SP0A18SetClock
*
* DESCRIPTION
*    This function set sensor vt clock and op clock
*
* PARAMETERS
*    Clk: vt clock
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0A18SetClock(kal_uint32 Clk)
{
  kal_uint8 ClkDiv;
  
  if (SP0A18Sensor.IntClk == Clk)
  {
    return;
  }
  SP0A18Sensor.IntClk = Clk;
  switch (SP0A18Sensor.IntClk)
  {
  case SP0A18_MCLK / 2: ClkDiv = 0x02; break; /* pclk = mclk */
  case SP0A18_MCLK / 4: ClkDiv = 0x04; break; /* pclk = mclk / 2 */
  case SP0A18_MCLK / 8: ClkDiv = 0x06; break; /* pclk = mclk / 4 */
  default: ASSERT(0);
  }
  SP0A18_SET_PAGE0;
  CamWriteCmosSensor(0x30, ClkDiv);
}

/*************************************************************************
* FUNCTION
*    SP0A18WriteShutter
*
* DESCRIPTION
*    This function apply Shutter to sensor
*
* PARAMETERS
*    Shutter: integration time
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0A18WriteShutter(kal_uint32 Shutter)
{SP0A18_SET_PAGE0;
  CamWriteCmosSensor(0x03, Shutter >> 8);
  CamWriteCmosSensor(0x04, Shutter);
}

/*************************************************************************
* FUNCTION
*    SP0A18ReadShutter
*
* DESCRIPTION
*    This function get shutter from sensor
*
* PARAMETERS
*    None
*
* RETURNS
*    Shutter: integration time
*
* LOCAL AFFECTED
*
*************************************************************************/
static kal_uint16 SP0A18ReadShutter(void)
{SP0A18_SET_PAGE0;
  return (CamReadCmosSensor(0x03) << 8)|CamReadCmosSensor(0x04);
}

/*************************************************************************
* FUNCTION
*    SP0A18AeEnable
*
* DESCRIPTION
*    disable/enable AE
*
* PARAMETERS
*    Enable
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0A18AeEnable(kal_bool Enable)
{
  const kal_bool AeEnable = (SP0A18Sensor.AecMode3&0x05) ? KAL_TRUE : KAL_FALSE;
  CameraSccbSetAddr(CAMERA_SCCB_SENSOR, 0x42);

  if (SP0A18Sensor.BypassAe)
  {
    Enable = KAL_FALSE;
  }
  if (AeEnable == Enable)
  {
    return;
  }
  if (Enable)
  {
    SP0A18Sensor.AecMode3 |= 0x05;
  }
  else
  {
    SP0A18Sensor.AecMode3 &= 0x08;
  }
  SP0A18_SET_PAGE0;
  CamWriteCmosSensor(0x32, SP0A18Sensor.AecMode3);
}

/*************************************************************************
* FUNCTION
*    SP0A18AwbEnable
*
* DESCRIPTION
*    disable/enable awb
*
* PARAMETERS
*    Enable
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0A18AwbEnable(kal_bool Enable)
{
  const kal_bool AwbEnable = (SP0A18Sensor.Ctrl3A&0x08) ? KAL_TRUE : KAL_FALSE;
  CameraSccbSetAddr(CAMERA_SCCB_SENSOR, 0x42);

  if (SP0A18Sensor.BypassAwb)
  {
    Enable = KAL_FALSE;
  }
  if (AwbEnable == Enable)
  {
    return;
  }
  if (Enable)
  {
    SP0A18Sensor.Ctrl3A |= 0x08;
  }
  else
  {
    SP0A18Sensor.Ctrl3A &= 0x05;
  }
    SP0A18_SET_PAGE0;
  CamWriteCmosSensor(0x32, SP0A18Sensor.Ctrl3A);
}

/*************************************************************************
* FUNCTION
*    SP0A18SetBaseShutter
*
* DESCRIPTION
*    This function set base shutter to the CMOS sensor
*
* PARAMETERS
*    Banding: 50Hz or 60Hz
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0A18SetBaseShutter(kal_uint8 Banding)
{
#if 0
  const kal_uint16 bandStep = SP0A18HalfAdjust(SP0A18Sensor.IntClk, SP0A18Sensor.LineLength * Banding * 2);
  
  CamWriteCmosSensor(0xE2, bandStep >> 8);
  CamWriteCmosSensor(0xE3, bandStep);
#endif
}

/*************************************************************************
* FUNCTION
*    SP0A18SetDummy
*
* DESCRIPTION
*    This function add DummyPixel and DummyLine.
*
* PARAMETERS
*    DummyPixel
*    DummyLine
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0A18SetDummy(kal_uint16 DummyPixel, kal_uint16 DummyLine)
{
#if 0
  const kal_uint16 LineLength = DummyPixel + SP0A18_PERIOD_PIXEL_NUMS;
  const kal_uint16 FrameHeight = DummyLine + SP0A18_PERIOD_LINE_NUMS;
  kal_bool update = KAL_FALSE;
  
  /* add default dummy */
  DummyPixel += SP0A18_IMAGE_SENSOR_HBLANKING;
  DummyLine += SP0A18_IMAGE_SENSOR_VBLANKING;
  
  /* config line length */
  if (LineLength != SP0A18Sensor.LineLength)
  {
    if (LineLength > SP0A18_MAX_LINELENGTH)
    {
      ASSERT(0);
    }
    update = KAL_TRUE;
    SP0A18Sensor.LineLength = LineLength;
    CamWriteCmosSensor(0x01, DummyPixel);
  }
  /* config frame height */
  if (FrameHeight != SP0A18Sensor.FrameHeight)
  {
    if (FrameHeight > SP0A18_MAX_FRAMEHEIGHT)
    {
      ASSERT(0);
    }
    update = KAL_TRUE;
    SP0A18Sensor.FrameHeight = FrameHeight;
    CamWriteCmosSensor(0x02, DummyLine);
  }
  if (update)
  {
    CamWriteCmosSensor(0x0F, ((DummyLine >> 4)&0xF0)|((DummyPixel >> 8)&0x0F));
  }
#endif
}

/*************************************************************************
* FUNCTION
*    SP0A18SetVideoFps
*
* DESCRIPTION
*    This function calculate & fix frame rate in video mode
*
* PARAMETERS
*    Fps: video frame rate, base on SP0A18_FPS(x)
*
* RETURNS
*    Fps: real frame rate set by sensor
*
* LOCAL AFFECTED
*
*************************************************************************/
static kal_uint16 SP0A18SetVideoFps(kal_uint16 Fps)
{
#if 0
  kal_uint32 LineLength, FrameHeight;
  kal_uint16 MaxExposure;
  
  /* get max line length */
  LineLength = SP0A18Sensor.IntClk * SP0A18_FPS(1) / (Fps * SP0A18_PERIOD_LINE_NUMS);
  if (LineLength > SP0A18_MAX_LINELENGTH) /* overflow check */
  {
    LineLength = SP0A18_MAX_LINELENGTH;
  }
  if (LineLength < SP0A18_PERIOD_PIXEL_NUMS)
  {
    LineLength = SP0A18_PERIOD_PIXEL_NUMS;
  }
  
  /* get frame height */
  FrameHeight = SP0A18Sensor.IntClk * SP0A18_FPS(1) / (Fps * LineLength);
  if (FrameHeight > SP0A18_MAX_FRAMEHEIGHT) /* overflow check */
  {
    FrameHeight = SP0A18_MAX_FRAMEHEIGHT;
  }
  if (FrameHeight < SP0A18_PERIOD_LINE_NUMS)
  {
    FrameHeight = SP0A18_PERIOD_LINE_NUMS;
  }
  
  /* set max frame rate */
  SP0A18SetDummy(LineLength - SP0A18_PERIOD_PIXEL_NUMS, FrameHeight - SP0A18_PERIOD_LINE_NUMS);
  
  /* set min frame rate */
  MaxExposure = FrameHeight - SP0A18_SHUTTER_MAX_MARGIN;
  CamWriteCmosSensor(0xEC, 0x00); /* use exp level 1 */
  CamWriteCmosSensor(0xE4, MaxExposure >> 8); /* exp level 1: define max exposure */
  CamWriteCmosSensor(0xE5, MaxExposure);
  
  return SP0A18Sensor.IntClk * SP0A18_FPS(1) / (LineLength * FrameHeight);
#endif
}

/*************************************************************************
* FUNCTION
*    SP0A18SetMinFps
*
* DESCRIPTION
*    This function calculate & set min frame rate in camera preview mode
*
* PARAMETERS
*    Fps: min frame rate, base on SP0A18_FPS(x)
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0A18SetMinFps(kal_uint16 Fps)
{
#if 0
  kal_uint32 FrameHeight;
  kal_uint16 MaxExposure;
  
  /* get max frame height */
  FrameHeight = SP0A18HalfAdjust(SP0A18Sensor.IntClk * SP0A18_FPS(1), Fps * SP0A18Sensor.LineLength);
  
  /* set min frame rate */
  MaxExposure = FrameHeight - SP0A18_SHUTTER_MAX_MARGIN;
  CamWriteCmosSensor(0xEC, 0x30); /* use exp level 4, can not use level 1??? */
  CamWriteCmosSensor(0xEA, MaxExposure >> 8); /* exp level 4: define max exposure */
  CamWriteCmosSensor(0xEB, MaxExposure);
#endif
}

/*************************************************************************
* FUNCTION
*    SP0A18Ev
*
* DESCRIPTION
*    Exposure setting.
*
* PARAMETERS
*    In, Out
*
* RETURNS
*    Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0A18Ev(P_CAL_FEATURE_CTRL_STRUCT In, P_CAL_FEATURE_CTRL_STRUCT Out)
{
CameraSccbSetAddr(CAMERA_SCCB_SENSOR, 0x42);
  if (CAL_FEATURE_QUERY_OPERATION == In->FeatureCtrlCode)
  {
    const P_CAL_FEATURE_TYPE_ENUM_STRUCT Exposure = &Out->FeatureInfo.FeatureEnum;
    
    Out->FeatureType = CAL_FEATURE_TYPE_ENUMERATE;
    Out->FeatureOperationSupport = CAL_FEATURE_SET_OPERATION|CAL_FEATURE_QUERY_OPERATION;
    Out->FeatureModeSupport = CAL_FEATURE_CAMERA_VIDEO_SUPPORT;
    Exposure->IsSupport = KAL_TRUE;
    Exposure->ItemCount = 10;
    Exposure->SupportItem[0] = CAM_EV_NEG_4_3;
    Exposure->SupportItem[1] = CAM_EV_NEG_3_3;
    Exposure->SupportItem[2] = CAM_EV_NEG_2_3;
    Exposure->SupportItem[3] = CAM_EV_NEG_1_3;
    Exposure->SupportItem[4] = CAM_EV_ZERO;
    Exposure->SupportItem[5] = CAM_EV_POS_1_3;
    Exposure->SupportItem[6] = CAM_EV_POS_2_3;
    Exposure->SupportItem[7] = CAM_EV_POS_3_3;
    Exposure->SupportItem[8] = CAM_EV_POS_4_3;
    Exposure->SupportItem[9] = CAM_EV_NIGHT_SHOT;
  }
  else if (CAL_FEATURE_SET_OPERATION == In->FeatureCtrlCode)
  {
    static const kal_uint8 Data[9][2]=
    {
      {0x90+0x04,0xc0}, /* EV -4 */
      {0x8c+0x04,0xd0}, /* EV -3 */
      {0x88+0x04,0xe0}, /* EV -2 */
      {0x84+0x04,0xf0}, /* EV -1 */
      {0x80+0x04,0x00}, /* EV 0 */
      {0x7c+0x04,0x10}, /* EV +1 */
      {0x78+0x04,0x20}, /* EV +2 */
      {0x74+0x04,0x30}, /* EV +3 */
      {0x70+0x04,0x40}, /* EV +4 */
    };
    kal_uint8 i;
    
    switch (In->FeatureSetValue)
    {
    case CAM_EV_NEG_4_3: i = 0; break;
    case CAM_EV_NEG_3_3: i = 1; break;
    case CAM_EV_NEG_2_3: i = 2; break;
    case CAM_EV_NEG_1_3: i = 3; break;
    case CAM_EV_ZERO:    i = 4; break;
    case CAM_EV_POS_1_3: i = 5; break;
    case CAM_EV_POS_2_3: i = 6; break;
    case CAM_EV_POS_3_3: i = 7; break;
    case CAM_EV_POS_4_3: i = 8; break;
    default:
      return MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
    }
    SP0A18_SET_PAGE0;
    CamWriteCmosSensor(0xdf, Data[i][0]); /* SGNSET */
    CamWriteCmosSensor(0xdc, Data[i][1]); /* YBright */
  }
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*    SP0A18Wb
*
* DESCRIPTION
*    Wb setting.
*
* PARAMETERS
*    In, Out
*
* RETURNS
*    Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0A18Wb(P_CAL_FEATURE_CTRL_STRUCT In, P_CAL_FEATURE_CTRL_STRUCT Out)
{
CameraSccbSetAddr(CAMERA_SCCB_SENSOR, 0x42);
  if (CAL_FEATURE_QUERY_OPERATION == In->FeatureCtrlCode)
  {
    const P_CAL_FEATURE_TYPE_ENUM_STRUCT Wb = &Out->FeatureInfo.FeatureEnum;
    
    Out->FeatureType = CAL_FEATURE_TYPE_ENUMERATE;
    Out->FeatureOperationSupport = CAL_FEATURE_SET_OPERATION|CAL_FEATURE_QUERY_OPERATION;
    Out->FeatureModeSupport = CAL_FEATURE_CAMERA_VIDEO_SUPPORT;
    Wb->IsSupport = KAL_TRUE;
    Wb->ItemCount = 6;
    Wb->SupportItem[0] = CAM_WB_AUTO;
    Wb->SupportItem[1] = CAM_WB_CLOUD;
    Wb->SupportItem[2] = CAM_WB_DAYLIGHT;
    Wb->SupportItem[3] = CAM_WB_INCANDESCENCE;
    Wb->SupportItem[4] = CAM_WB_FLUORESCENT;
    Wb->SupportItem[5] = CAM_WB_TUNGSTEN;
  }
  else if (CAL_FEATURE_SET_OPERATION == In->FeatureCtrlCode)
  {
    static const kal_uint8 AwbGain[5][2]=
    { /* R gain, B gain. base: 2.6bits, 0x40=1x,0x60=1.5x */
     {0xe2,0x82}, /* cloud */
     {0xc1,0x88}, /* daylight */
     {0x7b,0xd3}, /* INCANDESCENCE */
     {0xb4,0xc4}, /* FLUORESCENT */
     {0xae,0xcc}, /* TUNGSTEN */
    };
    static kal_uint8 BakRGain, BakBGain;
    kal_uint8 RGain, BGain;
    kal_int8 i = sizeof(AwbGain) / sizeof(AwbGain[0]);
    SP0A18_SET_PAGE1;
    RGain = CamReadCmosSensor(0x28);
    BGain = CamReadCmosSensor(0x29);
    while (--i >= 0)
    {
      if (RGain == AwbGain[i][0] && BGain == AwbGain[i][1])
      {
        break;
      }
    }
    if (i < 0)
    {
      BakRGain = RGain;
      BakBGain = BGain;
    }
    switch (In->FeatureSetValue)
    {
    case CAM_WB_AUTO:
      SP0A18_SET_PAGE1;	
      CamWriteCmosSensor(0x28, BakRGain); /* for AWB can adjust back */
      CamWriteCmosSensor(0x29, BakBGain);
      SP0A18_SET_PAGE0;
      SP0A18AwbEnable(KAL_TRUE);
      return MM_ERROR_NONE;
    case CAM_WB_CLOUD:         i = 0; break;
    case CAM_WB_DAYLIGHT:      i = 1; break;
    case CAM_WB_INCANDESCENCE: i = 2; break;
    case CAM_WB_FLUORESCENT:   i = 3; break;
    case CAM_WB_TUNGSTEN:      i = 4; break;
    default:
      return MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
    }
    SP0A18AwbEnable(KAL_FALSE);
    SP0A18_SET_PAGE1;	
    CamWriteCmosSensor(0x28, AwbGain[i][0]); /* awb R gain */
    CamWriteCmosSensor(0x29, AwbGain[i][1]); /* awb B gain */
  }
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*    SP0A18Effect
*
* DESCRIPTION
*    Effect setting.
*
* PARAMETERS
*    In, Out
*
* RETURNS
*    Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0A18Effect(P_CAL_FEATURE_CTRL_STRUCT In, P_CAL_FEATURE_CTRL_STRUCT Out)
{
CameraSccbSetAddr(CAMERA_SCCB_SENSOR, 0x42);
  if (CAL_FEATURE_QUERY_OPERATION == In->FeatureCtrlCode)
  {
    const P_CAL_FEATURE_TYPE_ENUM_STRUCT Effect = &Out->FeatureInfo.FeatureEnum;
    
    Out->FeatureType = CAL_FEATURE_TYPE_ENUMERATE;
    Out->FeatureOperationSupport = CAL_FEATURE_SET_OPERATION|CAL_FEATURE_QUERY_OPERATION;
    Out->FeatureModeSupport = CAL_FEATURE_CAMERA_VIDEO_SUPPORT;
    Effect->IsSupport = KAL_TRUE;
    Effect->ItemCount = 7;
    Effect->SupportItem[0] = CAM_EFFECT_ENC_NORMAL;
    Effect->SupportItem[1] = CAM_EFFECT_ENC_GRAYSCALE;
    Effect->SupportItem[2] = CAM_EFFECT_ENC_SEPIA;
    Effect->SupportItem[3] = CAM_EFFECT_ENC_SEPIAGREEN;
    Effect->SupportItem[4] = CAM_EFFECT_ENC_SEPIABLUE;
    Effect->SupportItem[5] = CAM_EFFECT_ENC_COLORINV;
    Effect->SupportItem[6] = CAM_EFFECT_ENC_GRAYINV;
  }
  else if (CAL_FEATURE_SET_OPERATION == In->FeatureCtrlCode)
  {
    static const kal_uint8 Data[7][3]=
    {
      {0x00,0x80,0x80}, /* NORMAL */
      {0x20,0x80,0x80}, /* GRAYSCALE */
      {0x10,0xc0,0x20}, /* SEPIA */
      {0x10,0x20,0x20}, /* SEPIAGREEN */
      {0x10,0x20,0xf0}, /* SEPIABLUE */
      {0x04,0x80,0x80}, /* COLORINV */
      {0x08,0x80,0x80}, /* GRAYINV */
    };
    kal_uint8 i;
    
    switch (In->FeatureSetValue)
    {
    case CAM_EFFECT_ENC_NORMAL:     i = 0; break;
    case CAM_EFFECT_ENC_GRAYSCALE:  i = 1; break;
    case CAM_EFFECT_ENC_SEPIA:      i = 2; break;
    case CAM_EFFECT_ENC_SEPIAGREEN: i = 3; break;
    case CAM_EFFECT_ENC_SEPIABLUE:  i = 4; break;
    case CAM_EFFECT_ENC_COLORINV:   i = 5; break;
    case CAM_EFFECT_ENC_GRAYINV:    i = 6; break;
    default:
      return MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
    }
    SP0A18_SET_PAGE0;
    CamWriteCmosSensor(0x62, Data[i][0]); /* special effect */
    CamWriteCmosSensor(0x63, Data[i][1]); /* fixed Cb */
    CamWriteCmosSensor(0x64, Data[i][2]); /* fixed Cr */
  }
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*    SP0A18StillCaptureSize
*
* DESCRIPTION
*    This function get capture size
*
* PARAMETERS
*    In, Out
*
* RETURNS
*    Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
MM_ERROR_CODE_ENUM SP0A18StillCaptureSize(P_CAL_FEATURE_CTRL_STRUCT In, P_CAL_FEATURE_CTRL_STRUCT Out)
{
  const P_CAL_FEATURE_TYPE_ENUM_STRUCT CapSize = &Out->FeatureInfo.FeatureEnum;
  
  if (CAL_FEATURE_QUERY_OPERATION == In->FeatureCtrlCode)
  {
    Out->FeatureType = CAL_FEATURE_TYPE_ENUMERATE;
    Out->FeatureOperationSupport = CAL_FEATURE_QUERY_OPERATION;
    Out->FeatureModeSupport = CAL_FEATURE_CAMERA_SUPPORT;
    CapSize->IsSupport = KAL_TRUE;
    CapSize->ItemCount = 2;
    CapSize->SupportItem[0] = CAM_IMAGE_SIZE_WALLPAPER;
    CapSize->SupportItem[1] = CAM_IMAGE_SIZE_VGA;
  }
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*    SP0A18Banding
*
* DESCRIPTION
*    This function get banding setting
*
* PARAMETERS
*    In, Out
*
* RETURNS
*    error code
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0A18Banding(P_CAL_FEATURE_CTRL_STRUCT In, P_CAL_FEATURE_CTRL_STRUCT Out)
{
  const P_CAL_FEATURE_TYPE_ENUM_STRUCT Banding = &Out->FeatureInfo.FeatureEnum;
  
  if (CAL_FEATURE_QUERY_OPERATION == In->FeatureCtrlCode)
  {
    Out->FeatureType = CAL_FEATURE_TYPE_ENUMERATE;
    Out->FeatureOperationSupport = CAL_FEATURE_SET_OPERATION|CAL_FEATURE_QUERY_OPERATION;
    Out->FeatureModeSupport = CAL_FEATURE_CAMERA_VIDEO_SUPPORT;
    Banding->IsSupport = KAL_TRUE;
    Banding->ItemCount = 2;
    Banding->SupportItem[0] = CAM_BANDING_50HZ;
    Banding->SupportItem[1] = CAM_BANDING_60HZ;
  }
  else if (CAL_FEATURE_SET_OPERATION == In->FeatureCtrlCode)
  {
	switch (In->FeatureSetValue)
	{
		case CAM_BANDING_50HZ:
		SP0A18_CAM_BANDING_50HZ = KAL_TRUE;
		break;
		
	case CAM_BANDING_60HZ:
		SP0A18_CAM_BANDING_50HZ = KAL_FALSE;
		break;

	default:
       	return MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
			
	}
  }
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*    SP0A18SceneMode
*
* DESCRIPTION
*    This function get/set scene mode of sensor.
*
* PARAMETERS
*    IsCam: camera scene mode or not
*    In, Out
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0A18SceneMode(kal_bool IsCam, P_CAL_FEATURE_CTRL_STRUCT In, P_CAL_FEATURE_CTRL_STRUCT Out)
{
CameraSccbSetAddr(CAMERA_SCCB_SENSOR, 0x42);
  if (CAL_FEATURE_QUERY_OPERATION == In->FeatureCtrlCode)
  {
    const P_CAL_FEATURE_TYPE_ENUM_STRUCT SceneMode = &Out->FeatureInfo.FeatureEnum;
    
    Out->FeatureType = CAL_FEATURE_TYPE_ENUMERATE;
    Out->FeatureOperationSupport = CAL_FEATURE_SET_OPERATION|CAL_FEATURE_QUERY_OPERATION;
    Out->FeatureModeSupport = CAL_FEATURE_CAMERA_SUPPORT;
    SceneMode->IsSupport = KAL_TRUE;
    SceneMode->ItemCount = 2;
    if (IsCam)
    {
      SceneMode->SupportItem[0] = CAM_AUTO_DSC;
      SceneMode->SupportItem[1] = CAM_NIGHTSCENE;
    }
    else
    {
      SceneMode->SupportItem[0] = CAM_VIDEO_AUTO;
      SceneMode->SupportItem[1] = CAM_VIDEO_NIGHT;
    }
  }
 else if (CAL_FEATURE_SET_OPERATION == In->FeatureCtrlCode)
 {
 #if 0
    if (IsCam)
    {
      switch (In->FeatureSetValue)
      {
	 case CAM_AUTO_DSC:
        {
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0xb2,NORMAL_Y0ffset);
					CamWriteCmosSensor(0xb3,0x1f);
		if(SP0A18_CAM_BANDING_50HZ == KAL_TRUE)
		{
					#if CAPPRE_20_10FPS
					//capture preview daylight 24M 50hz 20-10FPS maxgain:0x78
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,CAPPRE_20_10FPS_MAXGAIN);
					CamWriteCmosSensor(0x9c,CAPPRE_20_10FPS_MAXGAIN);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0x76);
					CamWriteCmosSensor(0xf0,0x62);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0xd4);
					CamWriteCmosSensor(0x91,0x3 );
					CamWriteCmosSensor(0x92,0x62);
					CamWriteCmosSensor(0x98,0x62);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,CAPPRE_20_10FPS_MAXGAIN);
					CamWriteCmosSensor(0xcd,CAPPRE_20_10FPS_MAXGAIN);
					CamWriteCmosSensor(0xce,0xd4);
					CamWriteCmosSensor(0xcf,0x3 );
					CamWriteCmosSensor(0xd0,0xd4);
					CamWriteCmosSensor(0xd1,0x3 );
					#endif				
					#if CAPPRE_20_09FPS
					//capture preview daylight 24M 50hz 20-9FPS maxgain:0x74
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,CAPPRE_20_09FPS_MAXGAIN);
					CamWriteCmosSensor(0x9c,CAPPRE_20_09FPS_MAXGAIN);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0x76);
					CamWriteCmosSensor(0xf0,0x62);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0x36);
					CamWriteCmosSensor(0x91,0x4 );
					CamWriteCmosSensor(0x92,0x62);
					CamWriteCmosSensor(0x98,0x62);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,CAPPRE_20_09FPS_MAXGAIN);
					CamWriteCmosSensor(0xcd,CAPPRE_20_09FPS_MAXGAIN);
					CamWriteCmosSensor(0xce,0x36);
					CamWriteCmosSensor(0xcf,0x4 );
					CamWriteCmosSensor(0xd0,0x36);
					CamWriteCmosSensor(0xd1,0x4 );
					#endif		
					#if CAPPRE_20_08FPS
					//capture preview daylight 24M 50hz 20-8FPS maxgain:0x70   
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,CAPPRE_20_08FPS_MAXGAIN);
					CamWriteCmosSensor(0x9c,CAPPRE_20_08FPS_MAXGAIN);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0x76);
					CamWriteCmosSensor(0xf0,0x62);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0x98);
					CamWriteCmosSensor(0x91,0x4 );
					CamWriteCmosSensor(0x92,0x62);
					CamWriteCmosSensor(0x98,0x62);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,CAPPRE_20_08FPS_MAXGAIN);
					CamWriteCmosSensor(0xcd,CAPPRE_20_08FPS_MAXGAIN);
					CamWriteCmosSensor(0xce,0x98);
					CamWriteCmosSensor(0xcf,0x4 );
					CamWriteCmosSensor(0xd0,0x98);
					CamWriteCmosSensor(0xd1,0x4 );
					#endif
					#if CAPPRE_20_07FPS
					//capture preview daylight 24M 50hz 20-7FPS maxgain:0x6c
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,CAPPRE_20_07FPS_MAXGAIN);
					CamWriteCmosSensor(0x9c,CAPPRE_20_07FPS_MAXGAIN);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0x76);
					CamWriteCmosSensor(0xf0,0x62);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0x5c);
					CamWriteCmosSensor(0x91,0x5 );
					CamWriteCmosSensor(0x92,0x62);
					CamWriteCmosSensor(0x98,0x62);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,CAPPRE_20_07FPS_MAXGAIN);
					CamWriteCmosSensor(0xcd,CAPPRE_20_07FPS_MAXGAIN);
					CamWriteCmosSensor(0xce,0x5c);
					CamWriteCmosSensor(0xcf,0x5 );
					CamWriteCmosSensor(0xd0,0x5c);
					CamWriteCmosSensor(0xd1,0x5 );
					#endif
					#if CAPPRE_20_06FPS
					//capture preview daylight 24M 50hz 20-6FPS maxgain:0x68
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,CAPPRE_20_06FPS_MAXGAIN);
					CamWriteCmosSensor(0x9c,CAPPRE_20_06FPS_MAXGAIN);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0x76);
					CamWriteCmosSensor(0xf0,0x62);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0x20);
					CamWriteCmosSensor(0x91,0x6 );
					CamWriteCmosSensor(0x92,0x62);
					CamWriteCmosSensor(0x98,0x62);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,CAPPRE_20_06FPS_MAXGAIN);
					CamWriteCmosSensor(0xcd,CAPPRE_20_06FPS_MAXGAIN);
					CamWriteCmosSensor(0xce,0x20);
					CamWriteCmosSensor(0xcf,0x6 );
					CamWriteCmosSensor(0xd0,0x20);
					CamWriteCmosSensor(0xd1,0x6 );
					#endif			
					dbg_print(" priview 50Hz normal\r\n");
					}
		else
		{
		                     #if CAPPRE_20_10FPS
					//capture preview daylight 24M 60hz 20-10FPS maxgain:0x78
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,CAPPRE_20_10FPS_MAXGAIN);
					CamWriteCmosSensor(0x9c,CAPPRE_20_10FPS_MAXGAIN);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0x72);
					CamWriteCmosSensor(0xf0,0x52);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0xd8);
					CamWriteCmosSensor(0x91,0x3 );
					CamWriteCmosSensor(0x92,0x52);
					CamWriteCmosSensor(0x98,0x52);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,CAPPRE_20_10FPS_MAXGAIN);
					CamWriteCmosSensor(0xcd,CAPPRE_20_10FPS_MAXGAIN);
					CamWriteCmosSensor(0xce,0xd8);
					CamWriteCmosSensor(0xcf,0x3 );
					CamWriteCmosSensor(0xd0,0xd8);
					CamWriteCmosSensor(0xd1,0x3 );
					#endif				
					#if CAPPRE_20_09FPS
					//capture preview daylight 24M 60hz 20-9FPS maxgain:0x74
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,CAPPRE_20_09FPS_MAXGAIN);
					CamWriteCmosSensor(0x9c,CAPPRE_20_09FPS_MAXGAIN);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0x72);
					CamWriteCmosSensor(0xf0,0x52);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0x2a);
					CamWriteCmosSensor(0x91,0x4 );
					CamWriteCmosSensor(0x92,0x52);
					CamWriteCmosSensor(0x98,0x52);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,CAPPRE_20_09FPS_MAXGAIN);
					CamWriteCmosSensor(0xcd,CAPPRE_20_09FPS_MAXGAIN);
					CamWriteCmosSensor(0xce,0x2a);
					CamWriteCmosSensor(0xcf,0x4 );
					CamWriteCmosSensor(0xd0,0x2a);
					CamWriteCmosSensor(0xd1,0x4 );
					#endif		
					#if CAPPRE_20_08FPS
					//capture preview daylight 24M 60hz 20-8FPS maxgain:0x70   
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,CAPPRE_20_08FPS_MAXGAIN);
					CamWriteCmosSensor(0x9c,CAPPRE_20_08FPS_MAXGAIN);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0x72);
					CamWriteCmosSensor(0xf0,0x52);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0xce);
					CamWriteCmosSensor(0x91,0x4 );
					CamWriteCmosSensor(0x92,0x52);
					CamWriteCmosSensor(0x98,0x52);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,CAPPRE_20_08FPS_MAXGAIN);
					CamWriteCmosSensor(0xcd,CAPPRE_20_08FPS_MAXGAIN);
					CamWriteCmosSensor(0xce,0xce);
					CamWriteCmosSensor(0xcf,0x4 );
					CamWriteCmosSensor(0xd0,0xce);
					CamWriteCmosSensor(0xd1,0x4 );
					#endif
					#if CAPPRE_20_07FPS
					//capture preview daylight 24M 60hz 20-7FPS maxgain:0x6c
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,CAPPRE_20_07FPS_MAXGAIN);
					CamWriteCmosSensor(0x9c,CAPPRE_20_07FPS_MAXGAIN);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0x72);
					CamWriteCmosSensor(0xf0,0x52);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0x72);
					CamWriteCmosSensor(0x91,0x5 );
					CamWriteCmosSensor(0x92,0x52);
					CamWriteCmosSensor(0x98,0x52);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,CAPPRE_20_07FPS_MAXGAIN);
					CamWriteCmosSensor(0xcd,CAPPRE_20_07FPS_MAXGAIN);
					CamWriteCmosSensor(0xce,0x72);
					CamWriteCmosSensor(0xcf,0x5 );
					CamWriteCmosSensor(0xd0,0x72);
					CamWriteCmosSensor(0xd1,0x5 );
					#endif
					#if CAPPRE_20_06FPS
					//capture preview daylight 24M 60hz 20-6FPS maxgain:0x68
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,CAPPRE_20_06FPS_MAXGAIN);
					CamWriteCmosSensor(0x9c,CAPPRE_20_06FPS_MAXGAIN);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0x72);
					CamWriteCmosSensor(0xf0,0x52);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0x68);
					CamWriteCmosSensor(0x91,0x6 );
					CamWriteCmosSensor(0x92,0x52);
					CamWriteCmosSensor(0x98,0x52);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,CAPPRE_20_06FPS_MAXGAIN);
					CamWriteCmosSensor(0xcd,CAPPRE_20_06FPS_MAXGAIN);
					CamWriteCmosSensor(0xce,0x68);
					CamWriteCmosSensor(0xcf,0x6 );
					CamWriteCmosSensor(0xd0,0x68);
					CamWriteCmosSensor(0xd1,0x6 );
					#endif
					dbg_print(" priview 60Hz normal\r\n");
					}
	}
	break;
	
       case CAM_NIGHTSCENE:
	{
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0xb2,LOWLIGHT_Y0ffset);
					CamWriteCmosSensor(0xb3,0x1f);		
		if(SP0A18_CAM_BANDING_50HZ == KAL_TRUE)
		{
					#if CAPPRE_20_06FPS_NIGHT
					//capture preview night 24M 50hz 20-6FPS maxgain:0x78	 
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0x9c,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0x76);
					CamWriteCmosSensor(0xf0,0x62);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0x20);
					CamWriteCmosSensor(0x91,0x6 );
					CamWriteCmosSensor(0x92,0x62);
					CamWriteCmosSensor(0x98,0x62);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0xcd,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0xce,0x20);
					CamWriteCmosSensor(0xcf,0x6 );
					CamWriteCmosSensor(0xd0,0x20);
					CamWriteCmosSensor(0xd1,0x6 );
		                    #endif
					dbg_print(" priview 50Hz night\r\n");	
					}
		else
		{
		      #if CAPPRE_20_06FPS_NIGHT
					//capture preview night 24M 60hz 20-6FPS maxgain:0x78
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0x9c,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0x72);
					CamWriteCmosSensor(0xf0,0x52);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0x68);
					CamWriteCmosSensor(0x91,0x6 );
					CamWriteCmosSensor(0x92,0x52);
					CamWriteCmosSensor(0x98,0x52);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0xcd,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0xce,0x68);
					CamWriteCmosSensor(0xcf,0x6 );
					CamWriteCmosSensor(0xd0,0x68);
					CamWriteCmosSensor(0xd1,0x6 );
		                     #endif
					dbg_print(" priview 60Hz night\r\n");	
					}
	}		
	break;
	
		default:
       		return MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
       }
    }
     else
    {
      switch (In->FeatureSetValue)
      {
    	case CAM_VIDEO_AUTO:
	{
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0xb2,NORMAL_Y0ffset);
					CamWriteCmosSensor(0xb3,0x1f);
		if(SP0A18_CAM_BANDING_50HZ == KAL_TRUE)
		{
                                    #if VDOREC_20_20FPS
					//Video record daylight 24M 50hz 20-20FPS maxgain:0x8c
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,VDOREC_20_20FPS_MAXGAIN);
					CamWriteCmosSensor(0x9c,VDOREC_20_20FPS_MAXGAIN);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0x76);
					CamWriteCmosSensor(0xf0,0x62);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0xea);
					CamWriteCmosSensor(0x91,0x1 );
					CamWriteCmosSensor(0x92,0x62);
					CamWriteCmosSensor(0x98,0x62);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,VDOREC_20_20FPS_MAXGAIN);
					CamWriteCmosSensor(0xcd,VDOREC_20_20FPS_MAXGAIN);
					CamWriteCmosSensor(0xce,0xea);
					CamWriteCmosSensor(0xcf,0x1 );
					CamWriteCmosSensor(0xd0,0xea);
					CamWriteCmosSensor(0xd1,0x1 );
                                   #endif				
					#if VDOREC_18_18FPS
					//Video record daylight 24M 50hz 18-18FPS maxgain:0x88
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,VDOREC_18_18FPS_MAXGAIN);
					CamWriteCmosSensor(0x9c,VDOREC_18_18FPS_MAXGAIN);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0xf2);
					CamWriteCmosSensor(0xf0,0x59);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0xbd);
					CamWriteCmosSensor(0x91,0x1 );
					CamWriteCmosSensor(0x92,0x59);
					CamWriteCmosSensor(0x98,0x59);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,VDOREC_18_18FPS_MAXGAIN);
					CamWriteCmosSensor(0xcd,VDOREC_18_18FPS_MAXGAIN);
					CamWriteCmosSensor(0xce,0xbd);
					CamWriteCmosSensor(0xcf,0x1 );
					CamWriteCmosSensor(0xd0,0xbd);
					CamWriteCmosSensor(0xd1,0x1 );
					#endif		
					#if VDOREC_16_16FPS
					//Video record daylight 24M 50hz 16-16FPS maxgain:0x84   
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,VDOREC_16_16FPS_MAXGAIN);
					CamWriteCmosSensor(0x9c,VDOREC_16_16FPS_MAXGAIN);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x2 );
					CamWriteCmosSensor(0x0a,0x9d);
					CamWriteCmosSensor(0xf0,0x4f);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0xda);
					CamWriteCmosSensor(0x91,0x1 );
					CamWriteCmosSensor(0x92,0x4f);
					CamWriteCmosSensor(0x98,0x4f);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,VDOREC_16_16FPS_MAXGAIN);
					CamWriteCmosSensor(0xcd,VDOREC_16_16FPS_MAXGAIN);
					CamWriteCmosSensor(0xce,0xda);
					CamWriteCmosSensor(0xcf,0x1 );
					CamWriteCmosSensor(0xd0,0xda);
					CamWriteCmosSensor(0xd1,0x1 );
					#endif
					#if VDOREC_14_14FPS
					//Video record daylight 24M 50hz 14-14FPS maxgain:0x80
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,VDOREC_14_14FPS_MAXGAIN);
					CamWriteCmosSensor(0x9c,VDOREC_14_14FPS_MAXGAIN);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x3 );
					CamWriteCmosSensor(0x0a,0x79);
					CamWriteCmosSensor(0xf0,0x45);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0xe3);
					CamWriteCmosSensor(0x91,0x1 );
					CamWriteCmosSensor(0x92,0x45);
					CamWriteCmosSensor(0x98,0x45);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,VDOREC_14_14FPS_MAXGAIN);
					CamWriteCmosSensor(0xcd,VDOREC_14_14FPS_MAXGAIN);
					CamWriteCmosSensor(0xce,0xe3);
					CamWriteCmosSensor(0xcf,0x1 );
					CamWriteCmosSensor(0xd0,0xe3);
					CamWriteCmosSensor(0xd1,0x1 );
					#endif
					#if VDOREC_12_12FPS
					//Video record daylight 24M 50hz 12-12FPS maxgain:0x7c
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,VDOREC_12_12FPS_MAXGAIN);
					CamWriteCmosSensor(0x9c,VDOREC_12_12FPS_MAXGAIN);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x4 );
					CamWriteCmosSensor(0x0a,0xa0);
					CamWriteCmosSensor(0xf0,0x3b);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0xd8);
					CamWriteCmosSensor(0x91,0x1 );
					CamWriteCmosSensor(0x92,0x3b);
					CamWriteCmosSensor(0x98,0x3b);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,VDOREC_12_12FPS_MAXGAIN);
					CamWriteCmosSensor(0xcd,VDOREC_12_12FPS_MAXGAIN);
					CamWriteCmosSensor(0xce,0xd8);
					CamWriteCmosSensor(0xcf,0x1 );
					CamWriteCmosSensor(0xd0,0xd8);
					CamWriteCmosSensor(0xd1,0x1 );
					#endif	  
					dbg_print(" video 50Hz normal\r\n");
					}
		else
		{
		                     #if VDOREC_20_20FPS
					//Video record daylight 24M 60Hz 20-20FPS maxgain:0x8c
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,VDOREC_20_20FPS_MAXGAIN);
					CamWriteCmosSensor(0x9c,VDOREC_20_20FPS_MAXGAIN);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0x72);
					CamWriteCmosSensor(0xf0,0x52);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0xec);
					CamWriteCmosSensor(0x91,0x1 );
					CamWriteCmosSensor(0x92,0x52);
					CamWriteCmosSensor(0x98,0x52);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,VDOREC_20_20FPS_MAXGAIN);
					CamWriteCmosSensor(0xcd,VDOREC_20_20FPS_MAXGAIN);
					CamWriteCmosSensor(0xce,0xec);
					CamWriteCmosSensor(0xcf,0x1 );
					CamWriteCmosSensor(0xd0,0xec);
					CamWriteCmosSensor(0xd1,0x1 );
					#endif				
					#if VDOREC_18_18FPS
					//Video record daylight 24M 60Hz 18-18FPS maxgain:0x88
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,VDOREC_18_18FPS_MAXGAIN);
					CamWriteCmosSensor(0x9c,VDOREC_18_18FPS_MAXGAIN);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0xf5);
					CamWriteCmosSensor(0xf0,0x4a);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0xbc);
					CamWriteCmosSensor(0x91,0x1 );
					CamWriteCmosSensor(0x92,0x4a);
					CamWriteCmosSensor(0x98,0x4a);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,VDOREC_18_18FPS_MAXGAIN);
					CamWriteCmosSensor(0xcd,VDOREC_18_18FPS_MAXGAIN);
					CamWriteCmosSensor(0xce,0xbc);
					CamWriteCmosSensor(0xcf,0x1 );
					CamWriteCmosSensor(0xd0,0xbc);
					CamWriteCmosSensor(0xd1,0x1 );
					#endif		
					#if VDOREC_16_16FPS
					//Video record daylight 24M 60Hz 16-16FPS maxgain:0x84   
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,VDOREC_16_16FPS_MAXGAIN);
					CamWriteCmosSensor(0x9c,VDOREC_16_16FPS_MAXGAIN);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x2 );
					CamWriteCmosSensor(0x0a,0x99);
					CamWriteCmosSensor(0xf0,0x42);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0xce);
					CamWriteCmosSensor(0x91,0x1 );
					CamWriteCmosSensor(0x92,0x42);
					CamWriteCmosSensor(0x98,0x42);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,VDOREC_16_16FPS_MAXGAIN);
					CamWriteCmosSensor(0xcd,VDOREC_16_16FPS_MAXGAIN);
					CamWriteCmosSensor(0xce,0xce);
					CamWriteCmosSensor(0xcf,0x1 );
					CamWriteCmosSensor(0xd0,0xce);
					CamWriteCmosSensor(0xd1,0x1 );
					#endif
					#if VDOREC_14_14FPS
					//Video record daylight 24M 60Hz 14-14FPS maxgain:0x80
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,VDOREC_14_14FPS_MAXGAIN);
					CamWriteCmosSensor(0x9c,VDOREC_14_14FPS_MAXGAIN);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x3 );
					CamWriteCmosSensor(0x0a,0x6a);
					CamWriteCmosSensor(0xf0,0x3a);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0xd0);
					CamWriteCmosSensor(0x91,0x1 );
					CamWriteCmosSensor(0x92,0x3a);
					CamWriteCmosSensor(0x98,0x3a);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,VDOREC_14_14FPS_MAXGAIN);
					CamWriteCmosSensor(0xcd,VDOREC_14_14FPS_MAXGAIN);
					CamWriteCmosSensor(0xce,0xd0);
					CamWriteCmosSensor(0xcf,0x1 );
					CamWriteCmosSensor(0xd0,0xd0);
					CamWriteCmosSensor(0xd1,0x1 );
					#endif
					#if VDOREC_12_12FPS
					//Video record daylight 24M 60Hz 12-12FPS maxgain:0x7c
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,VDOREC_12_12FPS_MAXGAIN);
					CamWriteCmosSensor(0x9c,VDOREC_12_12FPS_MAXGAIN);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x4 );
					CamWriteCmosSensor(0x0a,0xa7);
					CamWriteCmosSensor(0xf0,0x31);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0xea);
					CamWriteCmosSensor(0x91,0x1 );
					CamWriteCmosSensor(0x92,0x31);
					CamWriteCmosSensor(0x98,0x31);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,VDOREC_12_12FPS_MAXGAIN);
					CamWriteCmosSensor(0xcd,VDOREC_12_12FPS_MAXGAIN);
					CamWriteCmosSensor(0xce,0xea);
					CamWriteCmosSensor(0xcf,0x1 );
					CamWriteCmosSensor(0xd0,0xea);
					CamWriteCmosSensor(0xd1,0x1 );
					#endif	
					dbg_print(" video 60Hz normal\r\n");
					}
	}
	break;
	
	case CAM_VIDEO_NIGHT:
	{
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0xb2,LOWLIGHT_Y0ffset);
					CamWriteCmosSensor(0xb3,0x1f);
		if(SP0A18_CAM_BANDING_50HZ == KAL_TRUE)
		{
					#if VDOREC_12_12FPS_NIGHT
					//Video record daylight 24M 50hz 12-12FPS maxgain:0x8c
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0x9c,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x4 );
					CamWriteCmosSensor(0x0a,0xa0);
					CamWriteCmosSensor(0xf0,0x3b);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0xd8);
					CamWriteCmosSensor(0x91,0x1 );
					CamWriteCmosSensor(0x92,0x3b);
					CamWriteCmosSensor(0x98,0x3b);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0xcd,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0xce,0xd8);
					CamWriteCmosSensor(0xcf,0x1 );
					CamWriteCmosSensor(0xd0,0xd8);
					CamWriteCmosSensor(0xd1,0x1 );
					#endif					
					dbg_print(" video 50Hz night\r\n");				
					}
		else
		{
					#if VDOREC_12_12FPS_NIGHT
					//Video record daylight 24M 60Hz 12-12FPS maxgain:0x8c
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0x9c,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x4 );
					CamWriteCmosSensor(0x0a,0xa7);
					CamWriteCmosSensor(0xf0,0x31);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0xea);
					CamWriteCmosSensor(0x91,0x1 );
					CamWriteCmosSensor(0x92,0x31);
					CamWriteCmosSensor(0x98,0x31);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0xcd,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0xce,0xea);
					CamWriteCmosSensor(0xcf,0x1 );
					CamWriteCmosSensor(0xd0,0xea);
					CamWriteCmosSensor(0xd1,0x1 );
					#endif				
					dbg_print(" video 60Hz night\r\n");	
					}

	}
	break;

	default:
       	return MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
       }
     }
   
 #endif
 }
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*    SP0A18NightMode
*
* DESCRIPTION
*    This function set night mode to sensor.
*
* PARAMETERS
*    Enable
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0A18NightMode(kal_uint8 nightmode,kal_uint8 banding)
{
	//GPRICE1(" SP0A18NightMode  %d\r\n",SP0A18videomode);
	if (KAL_FALSE == SP0A18videomode)
	{
	 	if(0==nightmode)//daylight
		{
			CamWriteCmosSensor(0xfd,0x0 );
			CamWriteCmosSensor(0xb2,NORMAL_Y0ffset);
			CamWriteCmosSensor(0xb3,0x1f);
			if(0== banding)//50hz
			{
				//capture preview daylight 24M 50hz 20-8FPS maxgain:0x70   
				CamWriteCmosSensor(0xfd,0x1 );
				CamWriteCmosSensor(0x94,CAPPRE_20_08FPS_MAXGAIN);
				CamWriteCmosSensor(0x9c,CAPPRE_20_08FPS_MAXGAIN);
				CamWriteCmosSensor(0xfd,0x0 );
				CamWriteCmosSensor(0x09,0x1 );
				CamWriteCmosSensor(0x0a,0x76);
				CamWriteCmosSensor(0xf0,0x62);
				CamWriteCmosSensor(0xfd,0x1 );
				CamWriteCmosSensor(0x90,0x98);
				CamWriteCmosSensor(0x91,0x4 );
				CamWriteCmosSensor(0x92,0x62);
				CamWriteCmosSensor(0x98,0x62);
				CamWriteCmosSensor(0xfd,0x1 );
				CamWriteCmosSensor(0xcc,CAPPRE_20_08FPS_MAXGAIN);
				CamWriteCmosSensor(0xcd,CAPPRE_20_08FPS_MAXGAIN);
				CamWriteCmosSensor(0xce,0x98);
				CamWriteCmosSensor(0xcf,0x4 );
				CamWriteCmosSensor(0xd0,0x98);
				CamWriteCmosSensor(0xd1,0x4 );
				//GPRICE(" priview 50Hz normal\r\n");
			}
			else
			{
				//capture preview daylight 24M 60hz 20-8FPS maxgain:0x70   
				CamWriteCmosSensor(0xfd,0x1 );
				CamWriteCmosSensor(0x94,CAPPRE_20_08FPS_MAXGAIN);
				CamWriteCmosSensor(0x9c,CAPPRE_20_08FPS_MAXGAIN);
				CamWriteCmosSensor(0xfd,0x0 );
				CamWriteCmosSensor(0x09,0x1 );
				CamWriteCmosSensor(0x0a,0x72);
				CamWriteCmosSensor(0xf0,0x52);
				CamWriteCmosSensor(0xfd,0x1 );
				CamWriteCmosSensor(0x90,0xce);
				CamWriteCmosSensor(0x91,0x4 );
				CamWriteCmosSensor(0x92,0x52);
				CamWriteCmosSensor(0x98,0x52);
				CamWriteCmosSensor(0xfd,0x1 );
				CamWriteCmosSensor(0xcc,CAPPRE_20_08FPS_MAXGAIN);
				CamWriteCmosSensor(0xcd,CAPPRE_20_08FPS_MAXGAIN);
				CamWriteCmosSensor(0xce,0xce);
				CamWriteCmosSensor(0xcf,0x4 );
				CamWriteCmosSensor(0xd0,0xce);
				CamWriteCmosSensor(0xd1,0x4 );
				//GPRICE(" priview 60Hz normal\r\n");
			}
		}
		else	
		{
				CamWriteCmosSensor(0xfd,0x0 );
				CamWriteCmosSensor(0xb2,LOWLIGHT_Y0ffset);
				CamWriteCmosSensor(0xb3,0x1f);		
			if(0== banding)//50HZ
			{
				//capture preview night 24M 50hz 20-6FPS maxgain:0x78	 
				CamWriteCmosSensor(0xfd,0x1 );
				CamWriteCmosSensor(0x94,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
				CamWriteCmosSensor(0x9c,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
				CamWriteCmosSensor(0xfd,0x0 );
				CamWriteCmosSensor(0x09,0x1 );
				CamWriteCmosSensor(0x0a,0x76);
				CamWriteCmosSensor(0xf0,0x62);
				CamWriteCmosSensor(0xfd,0x1 );
				CamWriteCmosSensor(0x90,0x20);
				CamWriteCmosSensor(0x91,0x6 );
				CamWriteCmosSensor(0x92,0x62);
				CamWriteCmosSensor(0x98,0x62);
				CamWriteCmosSensor(0xfd,0x1 );
				CamWriteCmosSensor(0xcc,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
				CamWriteCmosSensor(0xcd,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
				CamWriteCmosSensor(0xce,0x20);
				CamWriteCmosSensor(0xcf,0x6 );
				CamWriteCmosSensor(0xd0,0x20);
				CamWriteCmosSensor(0xd1,0x6 );
				//GPRICE(" priview 50Hz night\r\n");	
			}
			else
			{
				//capture preview night 24M 60hz 20-6FPS maxgain:0x78
				CamWriteCmosSensor(0xfd,0x1 );
				CamWriteCmosSensor(0x94,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
				CamWriteCmosSensor(0x9c,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
				CamWriteCmosSensor(0xfd,0x0 );
				CamWriteCmosSensor(0x09,0x1 );
				CamWriteCmosSensor(0x0a,0x72);
				CamWriteCmosSensor(0xf0,0x52);
				CamWriteCmosSensor(0xfd,0x1 );
				CamWriteCmosSensor(0x90,0x68);
				CamWriteCmosSensor(0x91,0x6 );
				CamWriteCmosSensor(0x92,0x52);
				CamWriteCmosSensor(0x98,0x52);
				CamWriteCmosSensor(0xfd,0x1 );
				CamWriteCmosSensor(0xcc,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
				CamWriteCmosSensor(0xcd,CAPPRE_20_06FPS_MAXGAIN_NIGHT);
				CamWriteCmosSensor(0xce,0x68);
				CamWriteCmosSensor(0xcf,0x6 );
				CamWriteCmosSensor(0xd0,0x68);
				CamWriteCmosSensor(0xd1,0x6 );
				//GPRICE(" priview 60Hz night\r\n");	
			}
		}		
	}
	 else
	{
		if(0==nightmode)//daylight
		{
			CamWriteCmosSensor(0xfd,0x0 );
			CamWriteCmosSensor(0xb2,NORMAL_Y0ffset);
			CamWriteCmosSensor(0xb3,0x1f);
			if(0== banding)//50hz
			{
				//Video record daylight 24M 50hz 20-20FPS maxgain:0x8c
				CamWriteCmosSensor(0xfd,0x1 );
				CamWriteCmosSensor(0x94,VDOREC_20_20FPS_MAXGAIN);
				CamWriteCmosSensor(0x9c,VDOREC_20_20FPS_MAXGAIN);
				CamWriteCmosSensor(0xfd,0x0 );
				CamWriteCmosSensor(0x09,0x1 );
				CamWriteCmosSensor(0x0a,0x76);
				CamWriteCmosSensor(0xf0,0x62);
				CamWriteCmosSensor(0xfd,0x1 );
				CamWriteCmosSensor(0x90,0xea);
				CamWriteCmosSensor(0x91,0x1 );
				CamWriteCmosSensor(0x92,0x62);
				CamWriteCmosSensor(0x98,0x62);
				CamWriteCmosSensor(0xfd,0x1 );
				CamWriteCmosSensor(0xcc,VDOREC_20_20FPS_MAXGAIN);
				CamWriteCmosSensor(0xcd,VDOREC_20_20FPS_MAXGAIN);
				CamWriteCmosSensor(0xce,0xea);
				CamWriteCmosSensor(0xcf,0x1 );
				CamWriteCmosSensor(0xd0,0xea);
				//GPRICE(" video 50Hz normal\r\n");
			}
			else
			{
				//Video record daylight 24M 60Hz 20-20FPS maxgain:0x8c
				CamWriteCmosSensor(0xfd,0x1 );
				CamWriteCmosSensor(0x94,VDOREC_20_20FPS_MAXGAIN);
				CamWriteCmosSensor(0x9c,VDOREC_20_20FPS_MAXGAIN);
				CamWriteCmosSensor(0xfd,0x0 );
				CamWriteCmosSensor(0x09,0x1 );
				CamWriteCmosSensor(0x0a,0x72);
				CamWriteCmosSensor(0xf0,0x52);
				CamWriteCmosSensor(0xfd,0x1 );
				CamWriteCmosSensor(0x90,0xec);
				CamWriteCmosSensor(0x91,0x1 );
				CamWriteCmosSensor(0x92,0x52);
				CamWriteCmosSensor(0x98,0x52);
				CamWriteCmosSensor(0xfd,0x1 );
				CamWriteCmosSensor(0xcc,VDOREC_20_20FPS_MAXGAIN);
				CamWriteCmosSensor(0xcd,VDOREC_20_20FPS_MAXGAIN);
				CamWriteCmosSensor(0xce,0xec);
				CamWriteCmosSensor(0xcf,0x1 );
				CamWriteCmosSensor(0xd0,0xec);
				CamWriteCmosSensor(0xd1,0x1 );
				//GPRICE(" video 60Hz normal\r\n");
			}
		}
		else
		{
				CamWriteCmosSensor(0xfd,0x0 );
				CamWriteCmosSensor(0xb2,LOWLIGHT_Y0ffset);
				CamWriteCmosSensor(0xb3,0x1f);
				if(0== banding)//50hz
				{
					//Video record daylight 24M 50hz 12-12FPS maxgain:0x8c
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0x9c,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x4 );
					CamWriteCmosSensor(0x0a,0xa0);
					CamWriteCmosSensor(0xf0,0x3b);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0xd8);
					CamWriteCmosSensor(0x91,0x1 );
					CamWriteCmosSensor(0x92,0x3b);
					CamWriteCmosSensor(0x98,0x3b);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0xcd,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0xce,0xd8);
					CamWriteCmosSensor(0xcf,0x1 );
					CamWriteCmosSensor(0xd0,0xd8);
					CamWriteCmosSensor(0xd1,0x1 );
					//GPRICE(" video 50Hz night\r\n");				
				}
				else
				{
					//Video record daylight 24M 60Hz 12-12FPS maxgain:0x8c
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x94,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0x9c,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0xfd,0x0 );
					CamWriteCmosSensor(0x09,0x4 );
					CamWriteCmosSensor(0x0a,0xa7);
					CamWriteCmosSensor(0xf0,0x31);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0x90,0xea);
					CamWriteCmosSensor(0x91,0x1 );
					CamWriteCmosSensor(0x92,0x31);
					CamWriteCmosSensor(0x98,0x31);
					CamWriteCmosSensor(0xfd,0x1 );
					CamWriteCmosSensor(0xcc,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0xcd,VDOREC_12_12FPS_MAXGAIN_NIGHT);
					CamWriteCmosSensor(0xce,0xea);
					CamWriteCmosSensor(0xcf,0x1 );
					CamWriteCmosSensor(0xd0,0xea);
					CamWriteCmosSensor(0xd1,0x1 );
					//GPRICE(" video 60Hz night\r\n");	
				}

		}
   }

}
/*************************************************************************
* FUNCTION
*  SP0A18GammaSelect
*
* DESCRIPTION
*  This function config the gamma curve fitting for  
*  different LCD performances.
*
* PARAMETERS
*  level: different gamma curves.
*         Typical level value is from 1 to 5 which 
*         means small level gamma to high level gamma.
*
* RETURNS
*  NONE
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0A18GammaSelect(kal_uint8 level)
{
  static const GammaData[][19] =
  {
    {0x00,0x09,0x11,0x20,0x40,0x59,0x72,0x85,0x98,0xA9,0xBA,0xC8,0xD5,0xE1,0xEC,0xF4,0xFA,0xFE,0xFF},
    {0x00,0x12,0x1f,0x31,0x4c,0x62,0x77,0x89,0x9b,0xAA,0xBA,0xC7,0xD2,0xdd,0xE7,0xee,0xF5,0xFb,0xFF},//V1111 hight light ??o?
    {0x00,0x09,0x11,0x20,0x40,0x59,0x72,0x85,0x98,0xA9,0xBA,0xC8,0xD5,0xE1,0xEC,0xF4,0xFA,0xFE,0xFF},
    {0x00,0x09,0x11,0x20,0x40,0x59,0x72,0x85,0x98,0xA9,0xBA,0xC8,0xD5,0xE1,0xEC,0xF4,0xFA,0xFE,0xFF},
    {0x00,0x09,0x11,0x20,0x40,0x59,0x72,0x85,0x98,0xA9,0xBA,0xC8,0xD5,0xE1,0xEC,0xF4,0xFA,0xFE,0xFF},
  };
  
  if (level >= sizeof(GammaData) / sizeof(GammaData[0]))
  {
    ASSERT(0);
  }
  SP0A18_SET_PAGE0;
  CamWriteCmosSensor(0x8b, GammaData[level][0]); 
  CamWriteCmosSensor(0x8c, GammaData[level][1]); 
  CamWriteCmosSensor(0x8d, GammaData[level][2]); 
  CamWriteCmosSensor(0x8e, GammaData[level][3]); 
  CamWriteCmosSensor(0x8f, GammaData[level][4]); 
  CamWriteCmosSensor(0x90, GammaData[level][5]); 
  CamWriteCmosSensor(0x91, GammaData[level][6]); 
  CamWriteCmosSensor(0x92, GammaData[level][7]); 
  CamWriteCmosSensor(0x93, GammaData[level][8]); 
  CamWriteCmosSensor(0x94, GammaData[level][9]); 
  CamWriteCmosSensor(0x95, GammaData[level][10]); 
  CamWriteCmosSensor(0x96, GammaData[level][11]); 
  CamWriteCmosSensor(0x97, GammaData[level][12]); 
  CamWriteCmosSensor(0x98, GammaData[level][13]); 
  CamWriteCmosSensor(0x99, GammaData[level][14]); 
  CamWriteCmosSensor(0x9a, GammaData[level][15]); 
  CamWriteCmosSensor(0x9b, GammaData[level][16]);
  SP0A18_SET_PAGE1;
  CamWriteCmosSensor(0x8d, GammaData[level][17]);
  CamWriteCmosSensor(0x8e, GammaData[level][18]);
  SP0A18_SET_PAGE0;
}

/*************************************************************************
* FUNCTION
*    SP0A18InitialSetting
*
* DESCRIPTION
*    This function initialize the registers of CMOS sensor
*
* PARAMETERS
*    None
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
kal_uint16 firstentersp0a18=0;
static void SP0A18InitialSetting(void)
{
	zh_print("%s,firstentersp0a18=%x\r\n",__func__,firstentersp0a18);
CameraSccbSetAddr(CAMERA_SCCB_SENSOR, 0x42);
CamWriteCmosSensor(0xfd , 0x00);    
CamWriteCmosSensor(0x1C , 0x00); 
CamWriteCmosSensor(0x0e , 0x00); 
CamWriteCmosSensor(0x1b , 0x2f);  
CamWriteCmosSensor(0x32 , 0x00);    
CamWriteCmosSensor(0xfd , 0x01);   
CamWriteCmosSensor(0x28 , 0xc4);                                      
CamWriteCmosSensor(0x29 , 0x9e);   
CamWriteCmosSensor(0xfd , 0x00);   
CamWriteCmosSensor(0xe7 , 0x03);
CamWriteCmosSensor(0xe7 , 0x00);
CamWriteCmosSensor(0x0f , 0x3f);                                      
CamWriteCmosSensor(0x10 , 0x3a);                                      
CamWriteCmosSensor(0x13 , 0x1f);  //5f                                    
CamWriteCmosSensor(0x15 , 0x0a); // 4f 
CamWriteCmosSensor(0x16 , 0x00);
CamWriteCmosSensor(0x1a , 0x09);                                   
CamWriteCmosSensor(0x44 , 0x0f);                                      
CamWriteCmosSensor(0x22 , 0x13);                                      
CamWriteCmosSensor(0x26 , 0x02);                                      
CamWriteCmosSensor(0x27 , 0x68); //e8                                    
CamWriteCmosSensor(0x28 , 0x12); //b                                    
CamWriteCmosSensor(0x30 , 0x00);  
	if (firstentersp0a18==1)
	{
	CamWriteCmosSensor(0xfd , 0x00);
	CamWriteCmosSensor(0x31 , 0x00); 
	}
	else
	{
	CamWriteCmosSensor(0xfd , 0x00);
	CamWriteCmosSensor(0x31 , 0x10); 
	}
CamWriteCmosSensor(0x34 , 0x00);         
//special
CamWriteCmosSensor(0xfd , 0x01);                                      
CamWriteCmosSensor(0x00 , 0x01);  
//pregain
CamWriteCmosSensor(0xfd , 0x01);
CamWriteCmosSensor(0xc6 , 0x0a);//a~f  
CamWriteCmosSensor(0xc7 , 0x0a);//a~f    
CamWriteCmosSensor(0xc8 , 0x0a);//a~f    
CamWriteCmosSensor(0xc9 , 0x0a);//a~f    
//Del sunspot                                       
CamWriteCmosSensor(0xfd , 0x00);                                      
CamWriteCmosSensor(0xcd , 0x24);                                      
CamWriteCmosSensor(0xd1 , 0x03);                                      
CamWriteCmosSensor(0xd5 , 0xff);                                      
CamWriteCmosSensor(0xfc , 0x03);                                      
CamWriteCmosSensor(0xfb , 0x0f); //27                                                                                      
//Blacklevel                                        
CamWriteCmosSensor(0xfd , 0x00);                                      
CamWriteCmosSensor(0x65 , 0x00);//blue_suboffset                       
CamWriteCmosSensor(0x66 , 0x00);//red_suboffset                        
CamWriteCmosSensor(0x67 , 0x00);//gr_suboffset                         
CamWriteCmosSensor(0x68 , 0x00);//gb_suboffset                                                                          
//AWB                                               
CamWriteCmosSensor(0xfd , 0x01); 
CamWriteCmosSensor(0x10 , 0x0d);                                                                                                           
CamWriteCmosSensor(0x11 , 0x0d);                                      
CamWriteCmosSensor(0x12 , 0x0d);  
CamWriteCmosSensor(0x17 , 0x27);                                     
CamWriteCmosSensor(0x18 , 0x45);                                      
CamWriteCmosSensor(0x1a , 0xac);                                      
CamWriteCmosSensor(0x1b , 0x9e);                                      
CamWriteCmosSensor(0x2a , 0xE0);                                      
CamWriteCmosSensor(0x2b , 0x10);                                      
CamWriteCmosSensor(0x2c , 0x9f);//90      
CamWriteCmosSensor(0x2d , 0x99);
CamWriteCmosSensor(0x2e , 0x99);
CamWriteCmosSensor(0x6f , 0x05);                                      
CamWriteCmosSensor(0x8b , 0x2f);    
CamWriteCmosSensor(0x20 , 0xd0);
CamWriteCmosSensor(0x21 , 0x78);
CamWriteCmosSensor(0x22 , 0xe0);
CamWriteCmosSensor(0x23 , 0x80);
CamWriteCmosSensor(0x16 , 0x0d);
//smooth   
#if 1//?訤??a???
CamWriteCmosSensor(0xfd , 0x00);                                      
CamWriteCmosSensor(0x4f , 0x54);//raw_gf_fac_outdoor raw_gf_fac_nr 55  
CamWriteCmosSensor(0x50 , 0x22);//draw_gf_fac_dummy raw_gf_fac_low   0x22  
CamWriteCmosSensor(0x57 , 0x06);//raw_dif_thr_outdoor                  
CamWriteCmosSensor(0x58 , 0x0f);//raw_dif_thr_normal                   
CamWriteCmosSensor(0x56 , 0x10);//dummy                                
CamWriteCmosSensor(0x59 , 0x10);//low    0x10                                                                                
CamWriteCmosSensor(0x5a , 0x70);//raw_rb_fac_outdoor,raw_rb_fac_nr     
CamWriteCmosSensor(0x5b , 0x00);//raw_rb_fac_dummy,raw_rb_fac_low  
#else//?訤????????
CamWriteCmosSensor(0xfd , 0x00);                                      
CamWriteCmosSensor(0x4f , 0x43);//raw_gf_fac_outdoor raw_gf_fac_nr 55  
CamWriteCmosSensor(0x50 , 0x11);//draw_gf_fac_dummy raw_gf_fac_low     
CamWriteCmosSensor(0x57 , 0x06);//raw_dif_thr_outdoor                  
CamWriteCmosSensor(0x58 , 0x16);//raw_dif_thr_normal                   
CamWriteCmosSensor(0x56 , 0x18);//dummy                                
CamWriteCmosSensor(0x59 , 0x18);//low                                                                                    
CamWriteCmosSensor(0x5a , 0x70);//raw_rb_fac_outdoor,raw_rb_fac_nr     
CamWriteCmosSensor(0x5b , 0x00);//raw_rb_fac_dummy,raw_rb_fac_low  
#endif                                                   
//sharpen                                           
CamWriteCmosSensor(0xfd , 0x01); 
CamWriteCmosSensor(0xe5 , 0x20);
CamWriteCmosSensor(0xe6 , 0x10);
CamWriteCmosSensor(0xe7 , 0x20);  
CamWriteCmosSensor(0xe8 , 0x38);//sharp_fac_pos_outdoor                
CamWriteCmosSensor(0xec , 0x38);//sharp_fac_neg_outdoor                
CamWriteCmosSensor(0xe9 , 0x30);//sharp_fac_pos_nr                     
CamWriteCmosSensor(0xed , 0x30);//sharp_fac_neg_nr                     
CamWriteCmosSensor(0xea , 0x30);//sharp_fac_pos_dummy                  
CamWriteCmosSensor(0xef , 0x30);//sharp_fac_neg_dummy                  
CamWriteCmosSensor(0xeb , 0x10);//sharp_fac_pos_low                    
CamWriteCmosSensor(0xf0 , 0x20);//sharp_fac_neg_low                                                                     
//rpc                                               
CamWriteCmosSensor(0xfd , 0x00);                 
CamWriteCmosSensor(0xe0 , 0x32);//rpc_1base_max  
CamWriteCmosSensor(0xe1 , 0x26);//rpc_2base_max  
CamWriteCmosSensor(0xe2 , 0x22);//rpc_3base_max  
CamWriteCmosSensor(0xe3 , 0x1e);//rpc_4base_max  
CamWriteCmosSensor(0xe4 , 0x1e);//rpc_5base_max  
CamWriteCmosSensor(0xe5 , 0x1d);//rpc_6base_max  
CamWriteCmosSensor(0xe6 , 0x1d);//rpc_7base_max  
CamWriteCmosSensor(0xe8 , 0x1b);//rpc_8base_max  
CamWriteCmosSensor(0xe9 , 0x1b);//rpc_9base_max  
CamWriteCmosSensor(0xea , 0x1b);//rpc_10base_max 
CamWriteCmosSensor(0xeb , 0x1a);//rpc_11base_max 
CamWriteCmosSensor(0xf5 , 0x1a);//rpc_12base_max 
CamWriteCmosSensor(0xf6 , 0x1a);//rpc_13base_max                                                  
//ae min gain                                       
CamWriteCmosSensor(0xfd , 0x01);                                                           
CamWriteCmosSensor(0x95 , 0x1a);//rpc_min_indr                                           
CamWriteCmosSensor(0x9d , 0x1a);//rpc_min_outdr                                                   
//ae setting  
CamWriteCmosSensor(0xfd , 0x01);   
CamWriteCmosSensor(0x94 , 0x70);//rpc_max_indr   
CamWriteCmosSensor(0x9c , 0x70);//rpc_max_outdr 
CamWriteCmosSensor(0xfd , 0x00);                                      
CamWriteCmosSensor(0x05 , 0x00);                                      
CamWriteCmosSensor(0x06 , 0x00);                                      
CamWriteCmosSensor(0x07 , 0x00);                                      
CamWriteCmosSensor(0x08 , 0x00);                                      
CamWriteCmosSensor(0x09 , 0x01);                                      
CamWriteCmosSensor(0x0A , 0x76);                                      
CamWriteCmosSensor(0xf0 , 0x62);//ABF_exp_base_8lsb                    
CamWriteCmosSensor(0xf1 , 0x00);//exp_min_base_msb                     
CamWriteCmosSensor(0xfd , 0x01);                                      
CamWriteCmosSensor(0x90 , 0x98);//exp_max_indr[7:0]                    
CamWriteCmosSensor(0x91 , 0x04);//exp_max_indr[12:8]                   
CamWriteCmosSensor(0x92 , 0x62);//exp_min_indr[7:0]                    
CamWriteCmosSensor(0x93 , 0x00);//exp_min_indr[12:8]                   
CamWriteCmosSensor(0x98 , 0x62);//exp_max_outdr[7:0]                   
CamWriteCmosSensor(0x99 , 0x00);//exp_max_outdr[12:8]                  
CamWriteCmosSensor(0x9a , 0x01);//exp_min_outdr[7:0]                   
CamWriteCmosSensor(0x9b , 0x00);//exp_min_outdr[12:8] 
//status                                                                                                   
CamWriteCmosSensor(0xfd , 0x01);                                      
CamWriteCmosSensor(0xc4 , 0x70);//mean_nr_dummy                        
CamWriteCmosSensor(0xc5 , 0x74);//mean_dummy_nr                        
CamWriteCmosSensor(0xca , 0x30);//mean_heq_low                         
CamWriteCmosSensor(0xcb , 0x45);//mean_heq_dummy                       
CamWriteCmosSensor(0xcc , 0x70);//rpc_heq_low                          
CamWriteCmosSensor(0xcd , 0x70);//rpc_heq_dummy                        
CamWriteCmosSensor(0xce , 0x98);//exp_heq_dummy_8lsm                   
CamWriteCmosSensor(0xcf , 0x04);//exp_heq_dummy_5hsm                   
CamWriteCmosSensor(0xd0 , 0x98);//exp_heq_low_8lsm                     
CamWriteCmosSensor(0xd1 , 0x04);//exp_heq_low_5hsm                     
                                                   
//ae target                                         
CamWriteCmosSensor(0xfd , 0x00);                                      
CamWriteCmosSensor(0xed , 0x80);//80);//90 0x8c                                  
CamWriteCmosSensor(0xf7 , 0x74);//7c);//8c   0x88                                
CamWriteCmosSensor(0xf8 , 0x68);//70);//84  0x80                                 
CamWriteCmosSensor(0xec , 0x6c);//6c);//80  0x7c
                                                                                   
CamWriteCmosSensor(0xef , 0x74);//99                                   
CamWriteCmosSensor(0xf9 , 0x70);//90                                   
CamWriteCmosSensor(0xfa , 0x68);//80                                   
CamWriteCmosSensor(0xee , 0x64);//78                                   
 
/*//gamma 1 ̨????                                      
CamWriteCmosSensor(0xfd , 0x00);               
CamWriteCmosSensor(0x8b , 0x0 );               
CamWriteCmosSensor(0x8c , 0x6 );               
CamWriteCmosSensor(0x8d , 0xC );               
CamWriteCmosSensor(0x8e , 0x1A);               
CamWriteCmosSensor(0x8f , 0x3A);               
CamWriteCmosSensor(0x90 , 0x56);               
CamWriteCmosSensor(0x91 , 0x70);               
CamWriteCmosSensor(0x92 , 0x86);               
CamWriteCmosSensor(0x93 , 0x99);               
CamWriteCmosSensor(0x94 , 0xA9);               
CamWriteCmosSensor(0x95 , 0xB5);               
CamWriteCmosSensor(0x96 , 0xC0);               
CamWriteCmosSensor(0x97 , 0xCA);               
CamWriteCmosSensor(0x98 , 0xD4);               
CamWriteCmosSensor(0x99 , 0xDD);               
CamWriteCmosSensor(0x9a , 0xE6);               
CamWriteCmosSensor(0x9b , 0xEF);               
CamWriteCmosSensor(0xfd , 0x01);               
CamWriteCmosSensor(0x8d , 0xF7);               
CamWriteCmosSensor(0x8e , 0xFF);*/  
/*// gamma 2 ̨???                            
CamWriteCmosSensor(0xfd , 0x00);  
CamWriteCmosSensor(0x8b , 0x0 );  
CamWriteCmosSensor(0x8c , 0xA );  
CamWriteCmosSensor(0x8d , 0x13);  
CamWriteCmosSensor(0x8e , 0x25);  
CamWriteCmosSensor(0x8f , 0x43);  
CamWriteCmosSensor(0x90 , 0x5D);  
CamWriteCmosSensor(0x91 , 0x74);  
CamWriteCmosSensor(0x92 , 0x88);  
CamWriteCmosSensor(0x93 , 0x9A);  
CamWriteCmosSensor(0x94 , 0xA9);  
CamWriteCmosSensor(0x95 , 0xB5);  
CamWriteCmosSensor(0x96 , 0xC0);  
CamWriteCmosSensor(0x97 , 0xCA);  
CamWriteCmosSensor(0x98 , 0xD4);  
CamWriteCmosSensor(0x99 , 0xDD);  
CamWriteCmosSensor(0x9a , 0xE6);  
CamWriteCmosSensor(0x9b , 0xEF);  
CamWriteCmosSensor(0xfd , 0x01);  
CamWriteCmosSensor(0x8d , 0xF7);  
CamWriteCmosSensor(0x8e , 0xFF);*/
//gamma 3 ???1?
CamWriteCmosSensor(0xfd , 0x00);
CamWriteCmosSensor(0x8b , 0x0 );
CamWriteCmosSensor(0x8c , 0xC );
CamWriteCmosSensor(0x8d , 0x19);
CamWriteCmosSensor(0x8e , 0x2C);
CamWriteCmosSensor(0x8f , 0x49);
CamWriteCmosSensor(0x90 , 0x61);
CamWriteCmosSensor(0x91 , 0x77);
CamWriteCmosSensor(0x92 , 0x8A);
CamWriteCmosSensor(0x93 , 0x9B);
CamWriteCmosSensor(0x94 , 0xA9);
CamWriteCmosSensor(0x95 , 0xB5);
CamWriteCmosSensor(0x96 , 0xC0);
CamWriteCmosSensor(0x97 , 0xCA);
CamWriteCmosSensor(0x98 , 0xD4);
CamWriteCmosSensor(0x99 , 0xDD);
CamWriteCmosSensor(0x9a , 0xE6);
CamWriteCmosSensor(0x9b , 0xEF);
CamWriteCmosSensor(0xfd , 0x01);
CamWriteCmosSensor(0x8d , 0xF7);
CamWriteCmosSensor(0x8e , 0xFF);  
/*//gamma 4 ̨???                     
CamWriteCmosSensor(0xfd , 0x00);  
CamWriteCmosSensor(0x8b , 0x0 );  
CamWriteCmosSensor(0x8c , 0x14);  
CamWriteCmosSensor(0x8d , 0x22);  
CamWriteCmosSensor(0x8e , 0x36);  
CamWriteCmosSensor(0x8f , 0x51);  
CamWriteCmosSensor(0x90 , 0x67);  
CamWriteCmosSensor(0x91 , 0x7A);  
CamWriteCmosSensor(0x92 , 0x8C);  
CamWriteCmosSensor(0x93 , 0x9B);  
CamWriteCmosSensor(0x94 , 0xA9);  
CamWriteCmosSensor(0x95 , 0xB5);  
CamWriteCmosSensor(0x96 , 0xC0);  
CamWriteCmosSensor(0x97 , 0xCA);  
CamWriteCmosSensor(0x98 , 0xD4);  
CamWriteCmosSensor(0x99 , 0xDD);  
CamWriteCmosSensor(0x9a , 0xE6);  
CamWriteCmosSensor(0x9b , 0xEF);  
CamWriteCmosSensor(0xfd , 0x01);  
CamWriteCmosSensor(0x8d , 0xF7);  
CamWriteCmosSensor(0x8e , 0xFF);*/
/*//gamma 5 ̨1a??                       
CamWriteCmosSensor(0xfd , 0x00);  
CamWriteCmosSensor(0x8b , 0x0 );  
CamWriteCmosSensor(0x8c , 0x20);  
CamWriteCmosSensor(0x8d , 0x2d);  
CamWriteCmosSensor(0x8e , 0x40);  
CamWriteCmosSensor(0x8f , 0x5a);  
CamWriteCmosSensor(0x90 , 0x6e);  
CamWriteCmosSensor(0x91 , 0x80);  
CamWriteCmosSensor(0x92 , 0x8f);  
CamWriteCmosSensor(0x93 , 0x9c);  
CamWriteCmosSensor(0x94 , 0xa9);  
CamWriteCmosSensor(0x95 , 0xb5);  
CamWriteCmosSensor(0x96 , 0xc0);  
CamWriteCmosSensor(0x97 , 0xca);  
CamWriteCmosSensor(0x98 , 0xd4);  
CamWriteCmosSensor(0x99 , 0xdd);  
CamWriteCmosSensor(0x9a , 0xe6);  
CamWriteCmosSensor(0x9b , 0xef);  
CamWriteCmosSensor(0xfd , 0x01);  
CamWriteCmosSensor(0x8d , 0xf7);  
CamWriteCmosSensor(0x8e , 0xff);*/                                        
//Lens shading                                      
CamWriteCmosSensor(0xfd , 0x00);                                      
CamWriteCmosSensor(0xa0 , 0x10);//lsc_gr_gain                          
CamWriteCmosSensor(0xa1 , 0x10);//lsc_gb_gain                          
CamWriteCmosSensor(0xa2 , 0x14);//lsc_r_gain                           
CamWriteCmosSensor(0xa3 , 0x10);//lsc_b_gain                           
CamWriteCmosSensor(0xa4 , 0x14);//lsc_gain_max                         
CamWriteCmosSensor(0xa5 , 0x80);//col_center                           
CamWriteCmosSensor(0xa6 , 0x80);//row_center                                                                              
//uv en                                             
CamWriteCmosSensor(0xfd , 0x00);                                      
CamWriteCmosSensor(0xb0 , 0x00);//uv_dif_gain_outdoor,uv_dif_gain_nr   
CamWriteCmosSensor(0xb1 , 0x33);//uv_dif_gain_dummy,uv_dif_gain_low   0x33 
//neg
CamWriteCmosSensor(0xfd , 0x01);                                      
CamWriteCmosSensor(0xd2 , 0x00);                                                   
//lowlight lum                                      
CamWriteCmosSensor(0xfd , 0x00);                                      
CamWriteCmosSensor(0xb2 , NORMAL_Y0ffset);//lum_limit                            
CamWriteCmosSensor(0xb3 , 0x1f);//lum_set                              
CamWriteCmosSensor(0xb4 , 0x20);//black_vt                             
CamWriteCmosSensor(0xb5 , 0x45);//white_vt                                                                              
//auto sat                                          
CamWriteCmosSensor(0xfd , 0x00);                                      
CamWriteCmosSensor(0xbf , 0x01);//autosa_en                            
CamWriteCmosSensor(0xc0 , 0xff);//y_p_th                               
CamWriteCmosSensor(0xc1 , 0xff);//y_mean_th                                                                        
//saturation                                        
CamWriteCmosSensor(0xfd , 0x00);                                      
CamWriteCmosSensor(0xd8 , 0x74);//74//sat_uv_s1                     
CamWriteCmosSensor(0xd9 , 0x74);//74//sat_uv_s2                           
CamWriteCmosSensor(0xda , 0x68);//74//sat_uv_s3                          
CamWriteCmosSensor(0xdb , 0x68);//74//sat_uv_s4                                                                              
//heq                                               
CamWriteCmosSensor(0xfd , 0x00);                                      
CamWriteCmosSensor(0xdc , 0x00);//heq_offset                           
CamWriteCmosSensor(0xdd,0x70);////ku
CamWriteCmosSensor(0xde,0xa0);//b0//kl
CamWriteCmosSensor(0xdf,0x80);//heq_mean 0x80
//CCM                                               
CamWriteCmosSensor(0xfd , 0x01);                                      
CamWriteCmosSensor(0xa0 , 0x80);//80(ɫӽɫ)                                          
CamWriteCmosSensor(0xa1 , 0x0 );//0                                                                 
CamWriteCmosSensor(0xa2 , 0x0 );//0                                                                
CamWriteCmosSensor(0xa3 , 0xf3);//f0                                                                
CamWriteCmosSensor(0xa4 , 0x8e);//a6                                                                
CamWriteCmosSensor(0xa5 , 0x0 );//ea                                                                
CamWriteCmosSensor(0xa6 , 0x0 );//0                                                                 
CamWriteCmosSensor(0xa7 , 0xe6);//e6                          //55                                   
CamWriteCmosSensor(0xa8 , 0x9a);//9a                          //                                  
CamWriteCmosSensor(0xa9 , 0x0 );//0                                                                
CamWriteCmosSensor(0xaa , 0x3 );//33                                                                
CamWriteCmosSensor(0xab , 0xc );//c                           //f                                                                                     
//LSC                                               
CamWriteCmosSensor(0xfd , 0x00);                                      
CamWriteCmosSensor(0x33 , 0xcf);                                                                                      
//skin                                              
CamWriteCmosSensor(0xfd , 0x01);                                                                                        
CamWriteCmosSensor(0x8b , 0x2f);//bit7,0 en                            
CamWriteCmosSensor(0x01 , 0xf0);                                      
CamWriteCmosSensor(0x02 , 0x04);                                      
CamWriteCmosSensor(0x03 , 0x70);                                      
CamWriteCmosSensor(0x04 , 0x99);                                      
CamWriteCmosSensor(0x05 , 0x24);                                                                                      
//resize_en                                         
CamWriteCmosSensor(0xfd , 0x01);                                      
CamWriteCmosSensor(0x0e , 0x00);                                                                                                                                   
//outformat                                         
CamWriteCmosSensor(0xfd , 0x00);                                      
CamWriteCmosSensor(0x35 , 0x00);                                      
CamWriteCmosSensor(0x5f , 0x01);                                                                                  
//En AE                                             
CamWriteCmosSensor(0xfd , 0x00);                                      
CamWriteCmosSensor(0x32 , 0x0d);                                      
CamWriteCmosSensor(0x34 , 0x06); 
CamWriteCmosSensor(0xf4 , 0x09); 

CamWriteCmosSensor(0x0e , 0x00); 

}

/*************************************************************************
* FUNCTION
*	SP0A18_Write_More_Registers
*
* DESCRIPTION
*	This function is served for FAE to modify the necessary Init Regs. Do not modify the regs
*     in init_SP0A18() directly.
*
* PARAMETERS
*	None
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
void SP0A18MoreSetting(void)
{
	//  TODO: FAE Modify the Init Regs here!!! 
    SP0A18GammaSelect(2);
}
/*************************************************************************
* FUNCTION
*    SP0A18GetSensorInfo
*
* DESCRIPTION
*    This function set sensor infomation
*
* PARAMETERS
*    Info
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0A18GetSensorInfo(P_IMAGE_SENSOR_GET_SENSOR_INFO_STRUCT Info)
{
  Info->SensorId = SP0A18_SENSOR_ID;
  Info->SensorIf = IMAGE_SENSOR_IF_PARALLEL;
  Info->PreviewNormalDataFormat = IMAGE_SENSOR_DATA_OUT_FORMAT_UYVY;
  Info->PreviewHMirrorDataFormat = IMAGE_SENSOR_DATA_OUT_FORMAT_UYVY;
  Info->PreviewVMirrorDataFormat = IMAGE_SENSOR_DATA_OUT_FORMAT_UYVY;
  Info->PreviewHVMirrorDataFormat = IMAGE_SENSOR_DATA_OUT_FORMAT_UYVY;
  Info->CaptureDataFormat = IMAGE_SENSOR_DATA_OUT_FORMAT_UYVY;
  Info->PixelClkInv = KAL_FALSE;
  Info->PixelClkPolarity = POLARITY_LOW;
  Info->HsyncPolarity = POLARITY_LOW;
  Info->VsyncPolarity = POLARITY_HIGH;
  Info->PreviewMclkFreq = SP0A18_MCLK;
  Info->CaptureMclkFreq = SP0A18_MCLK;
  Info->VideoMclkFreq = SP0A18_MCLK;
  Info->PreviewWidth = SP0A18_IMAGE_SENSOR_WIDTH_DRV;
  Info->PreviewHeight = SP0A18_IMAGE_SENSOR_HEIGHT_DRV;
  Info->FullWidth = SP0A18_IMAGE_SENSOR_WIDTH_DRV;
  Info->FullHeight = SP0A18_IMAGE_SENSOR_HEIGHT_DRV;
  Info->SensorAfSupport = KAL_FALSE;
  Info->SensorFlashSupport = KAL_FALSE;
}

/*************************************************************************
* FUNCTION
*    SP0A18PowerOn
*
* DESCRIPTION
*    This function reset sensor and read id
*
* PARAMETERS
*    None
*
* RETURNS
*    sensor id
*
* LOCAL AFFECTED
*
*************************************************************************/
static kal_uint16 SP0A18PowerOn(void)
{
  kal_uint16 SensorId;
CameraSccbSetAddr(CAMERA_SCCB_SENSOR, 0x42);
  
  CisModulePowerOn(SP0A18Sensor.SensorIdx, KAL_TRUE);
  kal_sleep_task(2);  /* delay for power stable */
  CameraSccbOpen(CAMERA_SCCB_SENSOR, SP0A18_WRITE_ID, CAMERA_SCCB_8BIT, CAMERA_SCCB_8BIT, 100);
  #if defined(__DUAL_CAMERA_SUPPORT__)	 // dual camera
   zh_print("-------Get_current_cameraID()=%d\r\n",Get_current_cameraID());
   if(Get_current_cameraID()== CAMERA_SENSOR_BACK)
  {
	CamPdnPinCtrl(0, 0);
 	CamPdnPinCtrl(1, 1);
  }
  else
  {
  	CamPdnPinCtrl(0, 1);
  	CamPdnPinCtrl(1, 0);
  }
  #else  
  CamPdnPinCtrl(SP0A18Sensor.SensorIdx, 0);
  #endif
//  CamPdnPinCtrl(SP0A18Sensor.SensorIdx, 0);
  
  CamRstPinCtrl(SP0A18Sensor.SensorIdx, 1);
  kal_sleep_task(2);
  CamRstPinCtrl(SP0A18Sensor.SensorIdx, 0);
  kal_sleep_task(2);
  CamRstPinCtrl(SP0A18Sensor.SensorIdx, 1);
  kal_sleep_task(4);
  
  SensorId = CamReadCmosSensor(0x02);
    zh_print("SP0A18PowerOn!the SensorId = %x\r\n",SensorId);
  if (SensorId != SP0A18_SENSOR_ID) /* READ SENSOR ID */
  {
    //zh_print("SP0A18PowerOn!the SensorId = %x , SP0A18Sensor.SensorIdx = %d\r\n",SensorId,SP0A18Sensor.SensorIdx);
#if defined(__SP0A18_DEBUG_TRACE__)
    kal_print_string_trace(MOD_ENG, TRACE_ERROR, "SENSOR ID: %x", SensorId);
#endif
  }
  return SensorId;
}

/*************************************************************************
* FUNCTION
*    SP0A18DetectSensorId
*
* DESCRIPTION
*    This function detect sensor id
*
* PARAMETERS
*    None
*
* RETURNS
*    sensor id
*
* LOCAL AFFECTED
*
*************************************************************************/
static kal_uint32 SP0A18DetectSensorId(void)
{
  MM_ERROR_CODE_ENUM SP0A18SensorClose(void);

  kal_uint8 SensorId;
  IMAGE_SENSOR_INDEX_ENUM InvIdx;
  kal_int8 i, j;
  
  switch (SP0A18Sensor.SensorIdx)
  {
  case IMAGE_SENSOR_MAIN:
  case IMAGE_SENSOR_BAK1:
    InvIdx = IMAGE_SENSOR_SUB;
    break;
  default:
    InvIdx = IMAGE_SENSOR_MAIN;
    break;
  }
  for (i = 1; i >= 0; i--)
  {
    for (j = 1; j >= 0; j--)
    {
      CamRstPinCtrl(InvIdx, i);
      CamPdnPinCtrl(InvIdx, j);
      SensorId = SP0A18PowerOn();
      SP0A18SensorClose();
	
      //dbg_print("SP0A18DetectSensorId!SP0A18_SENSOR_ID = %x,i=%d,j=%d\r\n",SP0A18_SENSOR_ID,i,j);
      if (SP0A18_SENSOR_ID == SensorId)
      {
        return SP0A18_SENSOR_ID;
      }
    }
  }
  return MM_ERROR_SENSOR_READ_ID_FAIL;
}

/*************************************************************************
* FUNCTION
*    SP0A18InitOperationPara
*
* DESCRIPTION
*    This function set sensor operation para
*
* PARAMETERS
*    Para
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0A18InitOperationPara(P_IMAGE_SENSOR_GET_INIT_OPERATION_PARA_STRUCT Para)
{
  Para->CaptureDelayFrame = 2;
  Para->PreviewDelayFrame = 4;
  Para->PreviewDisplayWaitFrame = 8;
}

/*************************************************************************
* FUNCTION
*    SP0A18Preview
*
* DESCRIPTION
*    This function set to preview mode
*
* PARAMETERS
*    Id, In, Out
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0A18Preview(CAL_SCENARIO_ENUM Id, P_IMAGE_SENSOR_SCENARIO_PARA_IN_STRUCT In, P_IMAGE_SENSOR_SCENARIO_PARA_OUT_STRUCT Out)
{
  //kal_uint16 DummyPixel;
  
  //SP0A18SetMirror(In->ImageMirror);
  //SP0A18SetClock(SP0A18_PREVIEW_CLK);  
  zh_print("zch SP0A18Preview\r\n");
  
  switch (Id)
  {
  case CAL_SCENARIO_VIDEO:
    //SP0A18Sensor.VideoFps = SP0A18SetVideoFps(In->MaxVideoFrameRate);
			SP0A18videomode = KAL_TRUE;
			SP0A18NightMode(In->NightMode,In->BandingFreq);
    break;
  default:
  	SP0A18videomode = KAL_FALSE;
			SP0A18NightMode(In->NightMode,In->BandingFreq);
    //DummyPixel = 0;
    //SP0A18SetDummy(DummyPixel, 0);
    //SP0A18SetMinFps(In->NightMode ? SP0A18_FPS(5) : SP0A18_FPS(10));
  }
  //SP0A18SetBaseShutter(CAM_BANDING_50HZ == In->BandingFreq ? SP0A18_NUM_50HZ : SP0A18_NUM_60HZ);
  //SP0A18NightMode(In->NightMode);
  SP0A18AeEnable(KAL_TRUE);
  SP0A18AwbEnable(KAL_TRUE);
  
  Out->WaitStableFrameNum = 0;
  Out->GrabStartX = SP0A18_X_START;
  Out->GrabStartY = SP0A18_Y_START;
  Out->ExposureWindowWidth = SP0A18_IMAGE_SENSOR_WIDTH;
  Out->ExposureWindowHeight = SP0A18_IMAGE_SENSOR_HEIGHT;
}

/*************************************************************************
* FUNCTION
*    SP0A18Capture
*
* DESCRIPTION
*    This function set to capture mode
*
* PARAMETERS
*    Id, In, Out
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0A18Capture(CAL_SCENARIO_ENUM Id, P_IMAGE_SENSOR_SCENARIO_PARA_IN_STRUCT In, P_IMAGE_SENSOR_SCENARIO_PARA_OUT_STRUCT Out)
{
  Out->WaitStableFrameNum = 0;
  Out->GrabStartX = SP0A18_X_START;
  Out->GrabStartY = SP0A18_Y_START;
  Out->ExposureWindowWidth = SP0A18_IMAGE_SENSOR_WIDTH;
  Out->ExposureWindowHeight = SP0A18_IMAGE_SENSOR_HEIGHT;
}

/*************************************************************************
* FUNCTION
*    SP0A18SensorOpen
*
* DESCRIPTION
*    This function read sensor id and init sensor
*
* PARAMETERS
*    None
*
* RETURNS
*    Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0A18SensorOpen(void)
{
#if 1
  if (SP0A18PowerOn() != SP0A18_SENSOR_ID)
  {
    return MM_ERROR_SENSOR_READ_ID_FAIL;
  }
#else
    MM_ERROR_CODE_ENUM SP0A18SensorClose(void);
    kal_uint8 SensorId;
    IMAGE_SENSOR_INDEX_ENUM InvIdx;
    kal_int8 i, j;

    switch (SP0A18Sensor.SensorIdx)
    {
        case IMAGE_SENSOR_MAIN:
        case IMAGE_SENSOR_BAK1:
            InvIdx = IMAGE_SENSOR_SUB;
            break;
        default:
            InvIdx = IMAGE_SENSOR_MAIN;
            break;
    }
    CamRstPinCtrl(InvIdx, 1);
    CamPdnPinCtrl(InvIdx,1);
    SensorId = SP0A18PowerOn();
    if (SP0A18_SENSOR_ID != SensorId)
    {
        //dbg_print("SP0A18SensorOpen!the line = %d\r\n",__LINE__);
        kal_prompt_trace(MOD_MED,"Telacom SP0A18SensorOpen!the line = %d\r\n",__LINE__);
        SP0A18SensorClose();
        return MM_ERROR_SENSOR_READ_ID_FAIL;
    }
#endif


	SP0827_SERIAL_Disable();
CameraSccbSetAddr(CAMERA_SCCB_SENSOR, 0x42);
     SP0A18InitialSetting();
  //SP0A18MoreSetting();
  /* default setting */
  SP0A18Sensor.BypassAe = KAL_FALSE;
  SP0A18Sensor.BypassAwb = KAL_FALSE;
  SP0A18Sensor.Ctrl3A = CamReadCmosSensor(0x32);
  SP0A18Sensor.AecMode3 = CamReadCmosSensor(0x32);
  SP0A18Sensor.VideoFps = 0;
  SP0A18Sensor.IntClk = 0;
  SP0A18Sensor.FrameHeight = 0;
  SP0A18Sensor.LineLength = 0;
  
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*    SP0A18SensorFeatureCtrl
*
* DESCRIPTION
*    This function set sensor feature mode
*
* PARAMETERS
*    Id: scenario id
*    In: input parameter
*    Out: output parameter
*    OutLen: output parameter length
*    RealOutLen: real output parameter length
*
* RETURNS
*    Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0A18FlashMode(P_CAL_FEATURE_CTRL_STRUCT In, P_CAL_FEATURE_CTRL_STRUCT Out)
{
    if (CAL_FEATURE_QUERY_OPERATION == In->FeatureCtrlCode)
    {
        const P_CAL_FEATURE_TYPE_ENUM_STRUCT FlashMode = &Out->FeatureInfo.FeatureEnum;
 
        Out->FeatureType = CAL_FEATURE_TYPE_ENUMERATE;
        Out->FeatureOperationSupport = CAL_FEATURE_SET_OPERATION|CAL_FEATURE_QUERY_OPERATION;
        Out->FeatureModeSupport = CAL_FEATURE_CAMERA_SUPPORT;
        // TODO: add supported flash mode enum here
#ifndef LED_FLASHLIGHT_SUPPORT
        FlashMode->IsSupport = KAL_FALSE;
#else
        FlashMode->IsSupport = KAL_TRUE;
        FlashMode->ItemCount = 2;
        FlashMode->SupportItem[0] = CAM_FLASH_OFF;
        FlashMode->SupportItem[1] = CAM_FLASH_ON;
#endif
    }
    return MM_ERROR_NONE;
}
static MM_ERROR_CODE_ENUM SP0A18SensorFeatureCtrl(kal_uint32 Id, void *In, void *Out, kal_uint32 OutLen, kal_uint32 *RealOutLen)
{
  MM_ERROR_CODE_ENUM ErrCode = MM_ERROR_NONE;
  
  if (Id >= CAL_FEATURE_WEBCAM_BEGIN && Id <= CAL_FEATURE_WEBCAM_END)
  {
    return SP0A18WebcamFeatureCtrl(Id, In, Out, OutLen, RealOutLen);
  }
  switch (Id)
  {
  /* query and set series */
  case CAL_FEATURE_CAMERA_BRIGHTNESS:
  case CAL_FEATURE_CAMERA_EV_VALUE:
    ErrCode = SP0A18Ev(In, Out);
    break;
  case CAL_FEATURE_CAMERA_CONTRAST:
  case CAL_FEATURE_CAMERA_HUE:
  case CAL_FEATURE_CAMERA_SATURATION:
  case CAL_FEATURE_CAMERA_SHARPNESS:
  case CAL_FEATURE_CAMERA_GAMMA:
    ErrCode = MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
    break;
  case CAL_FEATURE_CAMERA_WB:
    ErrCode = SP0A18Wb(In, Out);
    break;
  case CAL_FEATURE_CAMERA_IMAGE_EFFECT:
    ErrCode = SP0A18Effect(In, Out);
    break;
  case CAL_FEATURE_CAMERA_STILL_CAPTURE_SIZE:
    ErrCode = SP0A18StillCaptureSize(In, Out);
    break;
  case CAL_FEATURE_CAMERA_BANDING_FREQ:
    ErrCode = SP0A18Banding(In, Out);
    break;
  case CAL_FEATURE_CAMERA_SCENE_MODE:
    ErrCode = SP0A18SceneMode(KAL_TRUE, In, Out);
    break;
  case CAL_FEATURE_CAMERA_VIDEO_SCENE_MODE:
    ErrCode = SP0A18SceneMode(KAL_FALSE, In, Out);
    break;
    case CAL_FEATURE_CAMERA_FLASH_MODE:
      ErrCode = SP0A18FlashMode(In, Out);
      break;
    case IMAGE_SENSOR_FEATURE_QUERY_YUV_CTRL_FLASHLIGHT_TRIGGER_MODE:
        ((P_IMAGE_SENSOR_COMM_DATA_STRUCT)Out)->FeatureValue = FLASHLIGHT_CONTINUOUS_MODE;
        break;
    case IMAGE_SENSOR_FEATURE_CTRL_FLASHLIGHT:
        FlashlightPowerOn(SP0A18Sensor.SensorIdx, ((P_IMAGE_SENSOR_COMM_CTRL_STRUCT)In)->FeatureEnable);
        break;
  
  /* get info series */
  case IMAGE_SENSOR_FEATURE_GET_SENSOR_INFO:
    SP0A18GetSensorInfo(Out);
    break;
  case IMAGE_SENSOR_FEATURE_GET_SENSOR_ID:
    ((P_IMAGE_SENSOR_COMM_DATA_STRUCT)Out)->FeatureValue = SP0A18DetectSensorId();
    break;
  case IMAGE_SENSOR_FEATURE_GET_SENSOR_FRAME_RATE:
    ((P_IMAGE_SENSOR_COMM_DATA_STRUCT)Out)->FeatureValue = SP0A18Sensor.VideoFps;
    break;
  case IMAGE_SENSOR_FEATURE_GET_INIT_OPERATION_PARA:
    SP0A18InitOperationPara(Out);
    break;
  case IMAGE_SENSOR_FEATURE_GET_HW_DEPENDENT_SETTING:
    CamGetHWInfo(SP0A18Sensor.SensorIdx, Out);
    break;
  
  /* set para series */
  case IMAGE_SENSOR_FEATURE_SET_SENSOR_POWER_DOWN:
    CamPdnPinCtrl(SP0A18Sensor.SensorIdx, 1);
    CamRstPinCtrl(SP0A18Sensor.SensorIdx, 0);
    break;
  case IMAGE_SENSOR_FEATURE_SET_NVRAM_SENSOR_INFO:
    SP0A18Sensor.NvramData = &(((nvram_camera_para_struct *)In)->SENSOR);
    break;
  case IMAGE_SENSOR_FEATURE_SET_CAMERA_SOURCE:
    SP0A18Sensor.SensorIdx = ((P_IMAGE_SENSOR_SET_CAMERA_SOURCE_STRUCT)In)->ImageSensorIdx;
    break;
  case IMAGE_SENSOR_FEATURE_CTRL_NIGHTMODE: /* move to preview */
    break;
  case IMAGE_SENSOR_FEATURE_SET_AE_BYPASS:
    SP0A18Sensor.BypassAe = *(kal_bool *)In;
    SP0A18AeEnable(SP0A18Sensor.BypassAe ? KAL_FALSE : KAL_TRUE);
    break;
  case IMAGE_SENSOR_FEATURE_SET_AWB_BYPASS:
    SP0A18Sensor.BypassAwb = *(kal_bool *)In;
    SP0A18AwbEnable(SP0A18Sensor.BypassAwb ? KAL_FALSE : KAL_TRUE);
    break;
  default:
    ErrCode = MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
    break;
  }
  return ErrCode;
}

/*************************************************************************
* FUNCTION
*    SP0A18SensorCtrl
*
* DESCRIPTION
*    This function set sensor scenario mode
*
* PARAMETERS
*    Id: scenario id
*    In/Out: parameter
*    OutLen: Out parameter length
*    RealOutLen: Real out parameter length
*
* RETURNS
*    Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0A18SensorCtrl(CAL_SCENARIO_ENUM Id, void *In, void *Out, kal_uint32 OutLen, kal_uint32 *RealOutLen)
{
  switch (Id)
  {
  case CAL_SCENARIO_CAMERA_PREVIEW:
  case CAL_SCENARIO_VIDEO:
  case CAL_SCENARIO_WEBCAM_PREVIEW:
  case CAL_SCENARIO_WEBCAM_CAPTURE:
    SP0A18Preview(Id, In, Out);
    break;
  case CAL_SCENARIO_CAMERA_STILL_CAPTURE:
    SP0A18Capture(Id, In, Out);
    break;
  default:
    break;
  }
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*    SP0A18SensorClose
*
* DESCRIPTION
*    This function is to turn off sensor module power.
*
* PARAMETERS
*    None
*
* RETURNS
*    Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0A18SensorClose(void)
{
CameraSccbSetAddr(CAMERA_SCCB_SENSOR, 0x42);
	CamWriteCmosSensor(0xfd, 0x00); 
	CamWriteCmosSensor(0x0e, 0xff);
    kal_prompt_trace(MOD_MED,"Telacom SP0A18SensorClose!");
  CamPdnPinCtrl(SP0A18Sensor.SensorIdx, 1);
  CamRstPinCtrl(SP0A18Sensor.SensorIdx, 0);
  CisModulePowerOn(SP0A18Sensor.SensorIdx, KAL_FALSE);
  CameraSccbClose(CAMERA_SCCB_SENSOR);
  
  return MM_ERROR_NONE;
}
/*************************************************************************
* FUNCTION
*    SP0A18SensorFunc
*
* DESCRIPTION
*    This function get sensor function pointer
*
* PARAMETERS
*    sensor function pointer
*
* RETURNS
*    Error code
*
* GLOBALS AFFECTED
*
*************************************************************************/
MM_ERROR_CODE_ENUM SP0A18SensorFunc(P_IMAGE_SENSOR_FUNCTION_STRUCT *pfSensorFunc)
{
  static IMAGE_SENSOR_FUNCTION_STRUCT ImageSensorFuncSP0A18 =
  {
    SP0A18SensorOpen,
    SP0A18SensorFeatureCtrl,
    SP0A18SensorCtrl,
    SP0A18SensorClose,
  };
  *pfSensorFunc = &ImageSensorFuncSP0A18;
  
  return MM_ERROR_NONE;
}


